/// <reference types="react" />
import { ApiTableProps } from '../ApiTable/interface';
/**
 * 说明： ApiTableModal 的 标题为 modalTitle 字段，而不是 title 字段
*/
export interface ShowTableStaticProps extends ApiTableProps {
    icon?: string;
    modalTitle?: React.ReactNode;
    /** 宽度 */
    width?: string | number;
    className?: string;
}
export interface TableModalProps extends ShowTableStaticProps {
    /**
     * table 映射对象，用于实现更多高级功能
     * */
    tableRef?: (table: any) => void;
    /**
     * 选中回调
    */
    onSelected?: (ids?: string[], objs?: any[]) => void;
    /**
     * 是否显示
    */
    visible: boolean;
    /**
     * 关闭窗体事件
    */
    onCancel?: (e: React.MouseEvent<HTMLElement>) => void;
}
