import * as React from 'react';
import { AutoCompleteProps } from 'antd/lib/auto-complete';
/**
 * 搜索工具：自动完成输入，必须传入符合VAP规范的接口
 */
export interface AutoCompleteOpts extends AutoCompleteProps {
    /**
     * 获取数据API
    */
    api: string;
    /**
     * API匹配字段，优先 field > name > "name"
    */
    field?: string;
    /**
     * 下拉显示名称，优先 field > name > "name"
    */
    nameField?: string;
    /**
     * 选中时的值，默认id
    */
    valueField?: string;
    /**
     * 接口默认参数
     */
    default?: any;
}
export default class extends React.PureComponent<AutoCompleteOpts> {
    state: {
        response: any[];
        options: any[];
    };
    fetchData(text?: string): Promise<void>;
    componentDidMount(): void;
    render(): JSX.Element;
}
