import * as React from 'react';
export interface SelectionOpts {
    data: any[];
    /**
     * 名称字段，默认为 name
     */
    nameField?: string;
    /**
     * 取值Format,默认为 v=>v
     */
    nameFormat?: Function;
    /**
     * 取值字段，默认为空（不显示值）
     */
    valueField?: string;
    /**
     * 取值Format,默认为 v=>v
     */
    valueFormat?: Function;
    /**
     * 是否进行排序，默认为true
     * */
    sorted?: boolean;
    /**
     * 选中事件
     * */
    onSelect?: Function;
    /**
     * 是否一行显示2条数据，默认为false
     */
    double?: boolean;
    /**
     * 过滤条件
     *  */
    searchValue?: string;
    /**
     * 默认选中
     */
    defaultSelect?: any;
}
export default class extends React.PureComponent<SelectionOpts> {
    nameField: string;
    nameFormat: Function;
    valueField: string;
    valueFormat: Function;
    hasOnSelected: boolean;
    doubled: boolean;
    className: string;
    defaultSelect: string;
    state: {
        currentSelected: string;
        data: any[];
    };
    constructor(props: any);
    filterData(props: SelectionOpts): void;
    componentWillReceiveProps(props: any): void;
    componentDidMount(): void;
    renderItem(item: any): JSX.Element;
    render(): JSX.Element;
}
