"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var React = require("react");
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1(props) {
        var _this = _super.call(this, props) || this;
        _this.nameField = 'name';
        _this.nameFormat = function (v) { return v; };
        _this.valueField = '';
        _this.valueFormat = function (v) { return v; };
        _this.hasOnSelected = false;
        _this.doubled = false;
        _this.className = '';
        //记录是否赋值
        _this.defaultSelect = '';
        _this.state = {
            currentSelected: '',
            data: [],
        };
        if (_.has(_this.props, 'nameField')) {
            _this.nameField = _this.props.nameField;
        }
        if (_.has(_this.props, 'nameFormat')) {
            _this.nameFormat = _this.props.nameFormat;
        }
        var className = ['selection-list'];
        if (_.has(_this.props, 'valueField')) {
            _this.valueField = _this.props.valueField;
            className.push('selection-list-valued');
        }
        if (_.has(_this.props, 'valueFormat')) {
            _this.valueFormat = _this.props.valueFormat;
        }
        if (_this.props.onSelect) {
            _this.hasOnSelected = true;
            className.push('selection-list-select');
        }
        if (_this.props.double) {
            _this.doubled = true;
            className.push('selection-list-doubled');
        }
        _this.className = className.join(' ');
        return _this;
    }
    default_1.prototype.filterData = function (props) {
        var _this = this;
        var data = (props.data && props.data.length) ? props.data.slice() : [];
        if (this.valueField && this.props.sorted) {
            data = _.orderBy(data, this.valueField, 'desc');
        }
        data.map(function (item) {
            item.__name = _this.nameFormat(item[_this.nameField]);
            if (_this.valueField) {
                item.__name = item.__name + ' : ' + _this.valueFormat(item[_this.valueField]);
            }
            item.__label = _this.nameFormat(item[_this.nameField]);
        });
        if (props.searchValue) {
            data = _.filter(data, function (item) { return _.includes(item.__label.toUpperCase(), props.searchValue.toUpperCase()); });
            data.map(function (item) {
                var index = item.__label.toUpperCase().indexOf(props.searchValue.toUpperCase());
                if (index < 0) {
                    return;
                }
                var beforeStr = item.__label.substr(0, index);
                var middleStr = item.__label.substr(index, props.searchValue.length);
                var afterStr = item.__label.substr(index + props.searchValue.length);
                item.__label = React.createElement("span", null,
                    beforeStr,
                    React.createElement("span", { className: "high" }, middleStr),
                    afterStr);
            });
        }
        this.setState({ data: data });
    };
    default_1.prototype.componentWillReceiveProps = function (props) {
        if ((this.props.data.length != props.data.length) || this.props.searchValue != props.searchValue) {
            this.filterData(props);
        }
        //是否有默认选中 如果有只在第一赋值时执行
        if (!this.defaultSelect && this.props.defaultSelect) {
            this.props.onSelect(this.props.defaultSelect);
            this.setState({ currentSelected: this.props.defaultSelect[this.nameField] });
            this.defaultSelect = this.props.defaultSelect;
        }
    };
    default_1.prototype.componentDidMount = function () {
        this.filterData(this.props);
    };
    default_1.prototype.renderItem = function (item) {
        var _this = this;
        var currentSelected = this.state.currentSelected;
        var param = {};
        if (currentSelected == item[this.nameField]) {
            param.className = 'selection-item-select';
        }
        if (this.hasOnSelected) {
            param.onClick = function () {
                if (item[_this.nameField] == _this.state.currentSelected) {
                    _this.setState({ currentSelected: null });
                    _this.props.onSelect(null);
                }
                else {
                    _this.setState({ currentSelected: item[_this.nameField] });
                    _this.props.onSelect(item);
                }
            };
        }
        if (this.valueField) {
            return React.createElement("li", __assign({}, param, { title: item.__name }),
                React.createElement("span", { className: "selection-item-label" }, item.__label),
                this.valueField && React.createElement("span", { className: "selection-item-value" }, this.valueFormat(item[this.valueField])));
        }
        return React.createElement("li", __assign({}, param, { title: item.__name }),
            React.createElement("span", { className: "selection-item-label", style: { maxWidth: '100%' } }, item.__label));
    };
    default_1.prototype.render = function () {
        var _this = this;
        return React.createElement("ul", { className: this.className }, this.state.data.map(function (item) { return _this.renderItem(item); }));
    };
    return default_1;
}(React.PureComponent));
exports.default = default_1;
