import * as React from 'react';
import { CSSProperties } from 'react';
export interface DragSortProps {
    /**
     * 传入数据
     */
    data: any | string[] | number[] | {
        name: string;
        [propName: string]: any;
    }[];
    /**
     * 包围的容器样式
     */
    style?: CSSProperties;
    /**
     * 单条数据样式
     */
    itemStyle?: CSSProperties;
    /**
     * 每一条数据展示内容，默认参数为数组元素值或元素对象name属性
     */
    nameFormat?: (obj: any, index: number) => React.ReactNode;
    /**
     * 返回排序后的data
     */
    onChange?: (data: any[]) => void;
}
/**
 * 上下拖拽排序组件
 * 传入数组：单数组[1,2,3]，对象数组至少包括name属性[{name: sting, any:any}]
 */
export default class DragSort extends React.PureComponent<DragSortProps> {
    state: any;
    dragged: any;
    overing: any;
    componentWillReceiveProps(nextProps: any): void;
    getStyle: () => {
        ulTop: number;
        liMarginBottom: number;
        liHeight: number;
        liMarginTop: number;
    };
    dragStart: (e: any) => void;
    dragOver: (e: any) => void;
    dragEnd(e: any): Promise<void>;
    renderObject: (data: any) => any;
    renderStr: (data: any) => any;
    render(): JSX.Element;
}
