"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var _ = require("lodash");
var utils_1 = require("../../utils");
/**
 * 上下拖拽排序组件
 * 传入数组：单数组[1,2,3]，对象数组至少包括name属性[{name: sting, any:any}]
 */
var DragSort = /** @class */ (function (_super) {
    __extends(DragSort, _super);
    function DragSort() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            _data: _this.props.data
        };
        _this.dragged = null; //选中的目标
        _this.overing = null; //经过的目标
        //获取容器padding或列表margin的值，用于动画
        _this.getStyle = function () {
            var _a = _this.props, style = _a.style, itemStyle = _a.itemStyle;
            var ulTop = 0;
            var liMarginBottom = 10;
            var liMarginTop = 10;
            var liHeight = 30;
            if (style) {
                if (_.has(style, 'padding')) {
                    var paddingBox = _.replace(style['padding'], /\s/g, ' ');
                    var paddingList = paddingBox.split(' ');
                    ulTop = parseInt(paddingList[0]);
                }
                if (_.has(style, 'paddingTop')) {
                    ulTop = parseInt(style.paddingTop);
                }
            }
            if (itemStyle) {
                if (_.has(style, 'margin')) {
                    var marginBox = _.replace(style['padding'], /\s/g, ' ');
                    var marginList = marginBox.split(' ');
                    liMarginTop = parseInt(marginList[0]) || 0;
                    liMarginBottom = (marginList.length < 3) ? (parseInt(marginList[0]) || 0) : (parseInt(marginList[2]) || 0);
                }
                if (_.has(style, 'marginTop')) {
                    liMarginTop = parseInt(style.marginTop);
                }
                if (_.has(style, 'marginBottom')) {
                    liMarginBottom = parseInt(style.marginBottom);
                }
                if (_.has(style, 'height')) {
                    liHeight = parseInt(style.height);
                }
            }
            return { ulTop: ulTop, liMarginBottom: liMarginBottom, liHeight: liHeight, liMarginTop: liMarginTop };
        };
        _this.dragStart = function (e) {
            _this.dragged = e.target;
            _this.dragged.classList.add('drag-start');
        };
        _this.dragOver = function (e) {
            e.preventDefault();
            var styleObject = _this.getStyle();
            //不是LI元素，返回
            if (e.target.tagName !== 'LI') {
                return;
            }
            var fromIndex = _this.dragged.dataset.id;
            var passIndex = e.target.dataset.id;
            var animateName = parseInt(fromIndex) > parseInt(passIndex) ? 'drag-down' : (parseInt(fromIndex) < parseInt(passIndex) ? 'drag-up' : 'drag-null');
            _this.dragged.style.top = ((styleObject.liHeight + _.max([styleObject.liMarginBottom, styleObject.liMarginTop])) * parseInt(fromIndex) + (styleObject.ulTop - styleObject.liMarginTop)) + 'px';
            if (_this.overing && _this.overing.dataset.id != passIndex) {
                _this.overing.classList.remove("drag-up", "drag-down", 'drag-null');
            }
            _this.overing = e.target;
            if (!_.includes(_this.overing.classList, animateName)) {
                _this.overing.classList.add(animateName);
            }
        };
        //对象数组时
        _this.renderObject = function (data) {
            var nameFormat = _this.props.nameFormat;
            return data.map(function (obj, i) {
                var name = obj.name;
                if (nameFormat) {
                    name = nameFormat(obj, i);
                }
                var dataItem = JSON.stringify(obj);
                return React.createElement("li", { key: '_li_' + i, "data-id": i, title: obj.name, "data-item": dataItem, draggable: true, onDragStart: _this.dragStart, onDragEnd: _this.dragEnd.bind(_this) },
                    " ",
                    name,
                    " ");
            });
        };
        //其他数组时
        _this.renderStr = function (data) {
            var nameFormat = _this.props.nameFormat;
            return data.map(function (d, i) {
                var name = d;
                if (nameFormat) {
                    name = nameFormat(d, i);
                }
                return React.createElement("li", { key: '_li_' + i, "data-id": i, "data-item": d, draggable: true, onDragStart: _this.dragStart, onDragEnd: _this.dragEnd.bind(_this) },
                    " ",
                    name,
                    " ");
            });
        };
        return _this;
    }
    DragSort.prototype.componentWillReceiveProps = function (nextProps) {
        if (!_.isEqual(this.props.data, nextProps.data)) {
            this.setState({ _data: nextProps.data });
        }
    };
    DragSort.prototype.dragEnd = function (e) {
        return __awaiter(this, void 0, void 0, function () {
            var styleObject, fromIndex, toIndex, newData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        styleObject = this.getStyle();
                        return [4 /*yield*/, utils_1.Ajax.WAIT(100)];
                    case 1:
                        _a.sent();
                        fromIndex = this.dragged.dataset.id;
                        toIndex = this.overing.dataset.id;
                        if (!(fromIndex != toIndex)) return [3 /*break*/, 3];
                        this.dragged.style.top = ((styleObject.liHeight + _.max([styleObject.liMarginBottom, styleObject.liMarginTop])) * (parseInt(toIndex) || -1) + (styleObject.ulTop - styleObject.liMarginTop)) + 'px';
                        this.dragged.classList.add('drag-end');
                        return [4 /*yield*/, utils_1.Ajax.WAIT(1000)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        this.dragged.classList.remove("drag-up", "drag-down", 'drag-end', 'drag-start', 'drag-null');
                        this.overing.classList.remove("drag-up", "drag-down", 'drag-end', 'drag-start', 'drag-null');
                        this.dragged.style.top = '';
                        newData = _.concat([], this.state._data);
                        newData.splice(toIndex, 0, newData.splice(fromIndex, 1)[0]);
                        this.setState({ _data: newData });
                        if (this.props.onChange) {
                            this.props.onChange(newData);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    DragSort.prototype.render = function () {
        var _data = this.state._data;
        if (!_.isArray(_data) || _.isEmpty(_data)) {
            return null;
        }
        var isObject = _data[0] && _.isObject(_data[0]);
        return React.createElement("ul", { className: 'drop-sort', onDragOver: this.dragOver, style: this.props.style || {} }, isObject ? this.renderObject(_data) : this.renderStr(_data));
    };
    return DragSort;
}(React.PureComponent));
exports.default = DragSort;
