"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var antd_1 = require("antd");
var _ = require("lodash");
/**
 * 排序弹框,用于拖动排序,返回排序后的列表顺序
 */
var DragSortModal = /** @class */ (function (_super) {
    __extends(DragSortModal, _super);
    function DragSortModal() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            dataTemp: _this.props.data || [],
            mode: _this.props.mode || 'default',
        };
        _this.dragActiveElem = null;
        _this.dragOverELem = null;
        //开始拖拽
        _this.dragStart = function (e) {
            e.persist();
            _this.dragActiveElem = e.currentTarget;
            _this.dragActiveElem.classList.add('sort-item-active');
        };
        //结束拖拽
        _this.dragEnd = function (e) {
            e.persist();
            _this.setNullByMode();
            window.setTimeout(function () { return _this.dragActiveElem.classList.remove('sort-item-active'); }, 500);
            var startIndex = _this.dragActiveElem.dataset.id;
            var endIndex = _this.dragOverELem.dataset.id;
            var newData = _.concat([], _this.state.dataTemp);
            newData.splice(endIndex, 0, newData.splice(startIndex, 1)[0]);
            _this.setState({ dataTemp: newData });
        };
        //拖拽过程
        _this.dragOver = function (e) {
            e.persist();
            if (_.get(e, 'target.tagName') != 'SPAN') {
                return;
            }
            if (!_this.dragOverELem) {
                _this.dragOverELem = e.target;
            }
            var start = _.get(_this.dragActiveElem, 'dataset.id');
            var temp = _.get(e.target, 'dataset.id');
            var over = _.get(_this.dragOverELem, 'dataset.id');
            if (over == start) {
                _this.setNullByMode();
            }
            else {
                _this.setSizeByMode(start < temp);
            }
            if (over != temp) {
                _this.setNullByMode();
                _this.dragOverELem = e.target;
                _this.setSizeByMode(start < temp);
            }
        };
        _this.setNullByMode = function () {
            if (_this.state.mode == 'list') {
                _this.dragOverELem.style.marginTop = '';
                _this.dragOverELem.style.marginBottom = '';
            }
            else {
                _this.dragOverELem.style.marginLeft = '';
                _this.dragOverELem.style.marginRight = '';
            }
        };
        //true表示右下移动,false表示左上移动
        _this.setSizeByMode = function (direction) {
            if (_this.state.mode == 'list') {
                if (direction) {
                    _this.dragOverELem.style.marginBottom = _this.dragActiveElem.offsetHeight + 'px';
                }
                else {
                    _this.dragOverELem.style.marginTop = _this.dragActiveElem.offsetHeight + 'px';
                }
            }
            else {
                if (direction) {
                    _this.dragOverELem.style.marginRight = _this.dragActiveElem.offsetWidth + 'px';
                }
                else {
                    _this.dragOverELem.style.marginLeft = _this.dragActiveElem.offsetWidth + 'px';
                }
            }
        };
        return _this;
    }
    DragSortModal.prototype.componentWillUpdate = function (props) {
        if (!_.isEqual(this.props, props)) {
            this.setState({ dataTemp: props.data, mode: props.mode });
        }
    };
    DragSortModal.prototype.render = function () {
        var _this = this;
        var isList = this.state.mode == 'list';
        var tagStyle = isList ? { width: '100%' } : {};
        var modalParam = {};
        return React.createElement(antd_1.Modal, __assign({}, modalParam, this.props, { onOk: function (e) { return _this.props.onOk(_this.state.dataTemp, e); }, title: React.createElement("div", null,
                this.props.title || '拖动排序',
                React.createElement("span", { style: { float: 'right', marginRight: 24, fontSize: '12px' } },
                    React.createElement("span", null, "\u5C55\u793A\u6A21\u5F0F: "),
                    React.createElement(antd_1.Switch, { size: 'small', defaultChecked: !isList, unCheckedChildren: '\u5217\u8868', checkedChildren: '\u5E73\u94FA', onChange: function (checked) { return _this.setState({ mode: checked ? 'default' : 'list' }); } }))) }),
            React.createElement("div", { className: 'sort-panel', id: 'sort-panel-id', onDragOver: this.dragOver }, _.isEmpty(this.state.dataTemp) ? React.createElement(antd_1.Empty, null) : this.state.dataTemp.map(function (d, i) {
                return React.createElement(antd_1.Tag, { "data-id": i, key: _this.props.renderKey(d, i), className: 'sort-item', draggable: true, style: tagStyle, onDragStart: _this.dragStart, onDragEnd: _this.dragEnd },
                    isList ? React.createElement("span", { className: 'sort-item-index' }, i) : null,
                    _this.props.renderItem(d, i));
            })));
    };
    return DragSortModal;
}(React.PureComponent));
exports.default = DragSortModal;
