"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var _ = require("lodash");
var antd_1 = require("antd");
var zh_ch = window.antd.locales.zh_CN;
var ESTable_1 = require("../ESTable");
/***
 * ApiTableModal 使用说明
 *
 * ApiTableModal  =  ApiTable + Modal
 *
 * 关于ApiTable 的使用说明请参考 ApiTable
 *
 * 使用方式 1：
 * ```
 * <ApiTableModal ...param />
 * ```
 *
 * 使用方式 2:
 * <XXX onClick={item=>ApiTableModal.show({xxxxxx})}/>
 *
 *
 *
*/
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.lastShow = false;
        _this.table = null;
        return _this;
    }
    default_1.prototype._isReShow = function (old) {
        if (old.visible === false && this.props.visible === true) {
            return true;
        }
        return false;
    };
    default_1.prototype._isShutDown = function (old) {
        if (old.visible === true && this.props.visible === false) {
            return true;
        }
        return false;
    };
    default_1.prototype.componentDidUpdate = function (old) {
        if (this._isReShow(old) && _.has(this.table, 'query')) {
            this.table.cleanAndQuery(this.props.default);
        }
        else if (this._isShutDown(old)) {
            this.table.clear();
        }
        this.lastShow = this.props.visible;
    };
    default_1.prototype.render = function () {
        var _this = this;
        var modalParam = {
            visible: this.props.visible,
            footer: null,
            width: this.props.width || 800,
            title: [],
        };
        var className = ['vap-table-modal'];
        if (this.props.className) {
            className.push(this.props.className);
        }
        if (this.props.icon) {
            modalParam.title.push(React.createElement(antd_1.Icon, { type: this.props.icon }));
        }
        if (this.props.modalTitle) {
            modalParam.title.push(this.props.modalTitle);
        }
        var tableParam = _.extend({}, this.props, { modalMode: true });
        _.unset(tableParam, 'modalTitle');
        _.unset(tableParam, 'visible');
        _.unset(tableParam, 'className');
        _.unset(tableParam, 'onCancel');
        _.unset(tableParam, 'width');
        return React.createElement(antd_1.Modal, __assign({}, modalParam, this.props, { className: className.join(' '), destroyOnClose: true }),
            React.createElement(ESTable_1.default, __assign({ pageSize: window.VAP_GLOBAL.PAGINATION.SIZE_DEFAULT_MODAL }, tableParam, { ref: function (table) { return _this.table = table; } })));
    };
    default_1.SHOW = function (config) {
        var title = [];
        if (config.icon) {
            title.push(React.createElement(antd_1.Icon, { type: config.icon }));
        }
        if (config.modalTitle) {
            title.push(config.modalTitle);
        }
        var tableParam = _.extend({}, config, { modalMode: true });
        _.unset(tableParam, 'modalTitle');
        _.unset(tableParam, 'visible');
        _.unset(tableParam, 'className');
        _.unset(tableParam, 'onCancel');
        // _.unset(tableParam, 'width');
        antd_1.Modal.info({
            maskClosable: true,
            // destroyOnClose:true,
            width: config.width || 800,
            icon: null,
            className: config.className ? 'vap-table-modal-warper vap-table-modal ' + config.className : 'vap-table-modal-warper vap-table-modal',
            title: React.createElement("div", null,
                title,
                " ",
                React.createElement("span", { style: { cursor: 'pointer', float: 'right', paddingRight: 12 }, onClick: function () { return antd_1.Modal.destroyAll(); } },
                    React.createElement(antd_1.Icon, { type: "close" }))),
            content: React.createElement(antd_1.ConfigProvider, { locale: zh_ch },
                React.createElement(ESTable_1.default, __assign({ pageSize: window.VAP_GLOBAL.PAGINATION.SIZE_DEFAULT_MODAL }, tableParam)))
        });
    };
    return default_1;
}(React.PureComponent));
exports.default = default_1;
