"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var antd_1 = require("antd");
var utils_1 = require("../../utils");
var RuleTip_1 = require("../RuleTip");
var SingleImage_1 = require("../Upload/SingleImage");
var SingleImageSelect_1 = require("../Upload/SingleImageSelect");
var Single_1 = require("../Upload/Single");
var React = require("react");
var _ = require("lodash");
var moment = require("moment");
var OrganizationSelect_1 = require("./OrganizationSelect");
var DomainSelect_1 = require("./DomainSelect");
var MultiDomainSelect_1 = require("./MultiDomainSelect");
var AutoComplete_1 = require("../DataComponents/AutoComplete");
var ListSelectModal_1 = require("../ListSelectModal/ListSelectModal");
var LinkColumn_1 = require("./LinkColumn");
var PrefixInput_1 = require("./PrefixInput");
var CheckbleDomainSelect_1 = require("./CheckbleDomainSelect");
var MORE = '__MORE';
var STOREMORE = {};
var nvToTree = function (options) {
    return options.map(function (item) {
        // value, title, children
        var result = { value: item.value, title: item.name };
        if (_.isArray(item.children) && item.children.length > 0) {
            result.children = nvToTree(item.children);
        }
        return result;
    });
};
/**
 * @private
*/
var FromContent = /** @class */ (function (_super) {
    __extends(FromContent, _super);
    function FromContent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.SelectModals = new Map();
        _this.LinkUtil = null;
        _this.state = {
            columns: []
        };
        _this.inputElement = function (column, initValue) {
            var params = {};
            if (column.disabled) {
                params.disabled = column.disabled;
            }
            switch (column.type) {
                case 'number':
                    return _this.buildNumber(column, params);
                case 'select':
                    return _this.buildSelect(column, params);
                case 'selectcode':
                    return _this.buildSelectCode(column, params);
                case 'tree-select':
                    return _this.buildTreeSelect(column, params);
                case 'radio':
                    return _this.buildRadio(column, params);
                case 'radiomore':
                    return _this.buildRadioMore(column, params);
                case 'checkbox':
                    return _this.buildCheckBox(column, params);
                case 'checkbox-with-all':
                    return _this.buildCheckBoxWithAll(column, params);
                case 'switch':
                    return _this.buildSwitch(column, params);
                case 'month':
                    return _this.buildMonth(column, params);
                case 'week':
                    return _this.buildWeek(column, params);
                case 'date':
                    return _this.buildDate(column, params);
                case 'datetime':
                    return _this.buildDateTime(column, params);
                case 'time':
                    return _this.buildTime(column, params);
                case 'daterange':
                    return _this.buildDateRange(column, params);
                case 'prefix-text':
                    return _this.buildPrefixText(column, params, initValue);
                case 'icon':
                    return _this.buildIcon(column, params);
                case 'customicon':
                    return _this.buildIconCustom(column, params);
                case 'image':
                    return _this.buildImage(column, params);
                case 'file':
                    return _this.buildFile(column, params, initValue);
                case 'cascader':
                    return _this.buildCascader(column, params);
                case 'editor':
                    return _this.buildEditor(column, params, initValue);
                case 'organization':
                    return _this.buildOrganization(column, params, initValue);
                case 'list-select-modal':
                    return _this.buildListModalButton(column, params, initValue);
                case 'domain':
                    return _this.buildDomain(column, params, initValue);
                case 'autocomplete':
                    return _this.buildAutocomplete(column, params, initValue);
                case 'multiDomain':
                    return _this.buildMultiDomain(column, params, initValue);
                case 'checkbleDomain':
                    return _this.buildCheckbleDomain(column, params, initValue);
                case 'password':
                    return _this.buildPassword(column, params);
                case 'textarea':
                    return _this.buildTextArea(column, params);
                case 'pic':
                    return _this.buildPic(column, params, initValue);
                case 'button':
                    return _this.buildButton(column, params, initValue);
                default:
                    return _this.buildText(column, params);
            }
        };
        return _this;
    }
    FromContent.prototype.componentWillMount = function () {
        this.state.columns = this.props.columns;
        this.LinkUtil = new LinkColumn_1.default(this.props.columns, this.props.form, this);
    };
    //多行文本输入框
    FromContent.prototype.buildTextArea = function (column, params) {
        if (column.placeholder) {
            params.placeholder = column.placeholder;
        }
        else {
            params.placeholder = '请填写' + column.title;
        }
        if (column.max) {
            params.maxLength = column.max;
        }
        return React.createElement(antd_1.Input.TextArea, __assign({}, column.config, params, { autoComplete: "off" }));
    };
    //文本输入框
    FromContent.prototype.buildText = function (column, params) {
        // this.__Link(column, params);
        this.LinkUtil.getLink(column, params);
        if (column.placeholder) {
            params.placeholder = column.placeholder;
        }
        else {
            params.placeholder = '请填写' + column.title;
        }
        if (column.max) {
            params.maxLength = column.max;
        }
        if (column.tip) {
            if (_.isString(column.tip)) {
                params.suffix = React.createElement(antd_1.Tooltip, { title: column.tip },
                    React.createElement(antd_1.Icon, { type: "info-circle" }));
            }
            else if (_.isPlainObject(column.tip)) {
                params.suffix = React.createElement(antd_1.Tooltip, { title: column.tip.text },
                    React.createElement(antd_1.Icon, { type: column.tip.icon }));
            }
        }
        return React.createElement(antd_1.Input, __assign({}, column.config, params, { autoComplete: "off" }));
    };
    //密码输入框
    FromContent.prototype.buildPassword = function (column, params) {
        if (column.placeholder) {
            params.placeholder = column.placeholder;
        }
        else {
            params.placeholder = '请填写' + column.title;
        }
        if (column.max) {
            params.maxLength = column.max;
        }
        return React.createElement(antd_1.Input.Password, __assign({}, column.config, params, { autoComplete: "off" }));
    };
    //数字输入框
    FromContent.prototype.buildNumber = function (column, params) {
        return React.createElement(antd_1.InputNumber, __assign({}, column.config, params, { autoComplete: "off" }));
    };
    //下拉框
    FromContent.prototype.buildSelect = function (column, params) {
        this.LinkUtil.getLink(column, params);
        if (column.placeholder) {
            params.placeholder = column.placeholder;
        }
        else {
            params.placeholder = '请选择' + column.title;
        }
        // if (_.has(column.config, 'mode') && column.config == 'multiple') {
        // }
        return React.createElement(antd_1.Select, __assign({}, column.config, params), column.options.map(function (item) { return React.createElement(antd_1.Select.Option, { key: "form-modal-select-".concat(column.field, "-").concat(item.value), value: item.value + '' }, item.name); }));
    };
    //下拉框(CODE模式)
    FromContent.prototype.buildSelectCode = function (column, params) {
        var e_1, _a;
        var getFieldValue = this.props.form.getFieldValue;
        var value = getFieldValue(column.field);
        var currentCode = null;
        try {
            for (var value_1 = __values(value), value_1_1 = value_1.next(); !value_1_1.done; value_1_1 = value_1.next()) {
                var i = value_1_1.value;
                var tmp = _.find(column.options, { value: i });
                // @ts-ignore
                if (tmp != null && tmp.code) {
                    // @ts-ignore
                    currentCode = tmp.code;
                    break;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (value_1_1 && !value_1_1.done && (_a = value_1.return)) _a.call(value_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        if (column.placeholder) {
            params.placeholder = column.placeholder;
        }
        else {
            params.placeholder = '请选择' + column.title;
        }
        return React.createElement(antd_1.Select, __assign({ mode: "multiple" }, params), column.options.map(function (item) { return React.createElement(antd_1.Select.Option, { value: item.value }, item.name); }));
    };
    //单选框
    FromContent.prototype.buildRadio = function (column, params) {
        this.LinkUtil.getLink(column, params);
        return React.createElement(antd_1.Radio.Group, __assign({}, column.config, params), column.options.map(function (item) { return React.createElement(antd_1.Radio, { value: item.value + '' }, item.name); }));
    };
    //单选框
    FromContent.prototype.buildRadioMore = function (column, params) {
        var _a;
        var _this = this;
        var value = this.props.form.getFieldValue(column.field);
        var idx = _.findIndex(column.options, { value: value });
        if (idx < 0) {
            STOREMORE[MORE + column.field] = value;
            this.props.form.setFieldsValue((_a = {}, _a[column.field] = MORE, _a));
        }
        return React.createElement(antd_1.Radio.Group, __assign({}, column.config, params, { className: "radio-group-widt-more" }), column.options.map(function (item) {
            return React.createElement(antd_1.Radio, { value: item.value + '' },
                item.name,
                item.value == MORE ? (_this.props.form.getFieldValue(column.field) == MORE ? React.createElement(antd_1.Input, { onChange: function (evt) { return STOREMORE[MORE + column.field] = evt.target.value; }, defaultValue: STOREMORE[MORE + column.field], style: { width: 100, marginLeft: 10 } }) : null) : null);
        }));
    };
    //多选框
    FromContent.prototype.buildCheckBox = function (column, params) {
        return React.createElement(antd_1.Checkbox.Group, __assign({}, column.config, params), column.options.map(function (item) { return React.createElement(antd_1.Checkbox, { value: item.value + '' }, item.name); }));
    };
    FromContent.prototype.buildCheckBoxWithAll = function (column, params) {
        var _this = this;
        var value = this.props.form.getFieldValue(column.field);
        var allChecked = false;
        if (value.length == column.options.length) {
            allChecked = true;
        }
        return React.createElement(React.Fragment, null,
            React.createElement(antd_1.Checkbox, { checked: allChecked, onChange: function (evt) {
                    var _a, _b;
                    if (evt.target.checked) {
                        _this.props.form.setFieldsValue((_a = {}, _a[column.field] = column.options.map(function (item) { return item.value; }), _a));
                    }
                    else {
                        _this.props.form.setFieldsValue((_b = {}, _b[column.field] = [], _b));
                    }
                } }, "\u5168\u9009"),
            column.options.map(function (item) { return React.createElement(antd_1.Checkbox, { style: { marginLeft: 0 }, value: item.value + '', checked: _.indexOf(value, item.value + '') >= 0, onChange: function (evt) {
                    var _a;
                    var values = _.concat([], _this.props.form.getFieldValue(column.field));
                    if (evt.target.checked) {
                        values.push(item.value + '');
                    }
                    else {
                        values = _.filter(values, function (val) { return val != (item.value + ''); });
                    }
                    _this.props.form.setFieldsValue((_a = {}, _a[column.field] = values, _a));
                } }, item.name); }));
    };
    //选择器
    FromContent.prototype.buildSwitch = function (column, params) {
        var _this = this;
        var initVal = _.has(this.props.data, column.field) ? this.props.data[column.field] : column.options[0].value;
        var checked = column.options[0].value === initVal;
        return React.createElement(antd_1.Switch, __assign({}, column.config, params, { checkedChildren: column.options[0].name, unCheckedChildren: column.options[1].name, defaultChecked: checked, onChange: function (check) {
                var _a;
                return _this.props.form.setFieldsValue((_a = {}, _a[column.field] = check ? column.options[0].value : column.options[1].value, _a));
            } }));
    };
    //日期选择器
    FromContent.prototype.buildDate = function (column, params) {
        return React.createElement(antd_1.DatePicker, __assign({}, column.config, params, { showTime: false, showToday: false, format: "YYYY-MM-DD" }));
    };
    //月份选择器
    FromContent.prototype.buildMonth = function (column, params) {
        return React.createElement(antd_1.DatePicker.MonthPicker, __assign({}, column.config, { placeholder: "\u8BF7\u9009\u62E9\u6708\u4EFD" }, params, { showTime: false, showToday: false, format: "YYYY-MM" }));
    };
    //月份选择器
    FromContent.prototype.buildWeek = function (column, params) {
        return React.createElement(antd_1.DatePicker.WeekPicker, __assign({}, column.config, { placeholder: "\u8BF7\u9009\u62E9\u5468" }, params, { showTime: false, showToday: false, format: "YYYY\u5E74, \u7B2Cw\u5468" }));
    };
    //日期选择器（带时间）
    FromContent.prototype.buildDateTime = function (column, params) {
        return React.createElement(antd_1.DatePicker, __assign({}, column.config, params, { showTime: true, showToday: false, format: "YYYY-MM-DD HH:mm:ss" }));
    };
    //时间选择器（仅时间）
    FromContent.prototype.buildTime = function (column, params) {
        return React.createElement(antd_1.TimePicker, __assign({}, column.config, params));
        // return <DatePicker {...params} showTime={true} showToday={false} format="YYYY-MM-DD HH:mm:ss" />
    };
    //日期范围选择器
    FromContent.prototype.buildDateRange = function (column, params) {
        return React.createElement(antd_1.DatePicker.RangePicker, __assign({}, column.config, params, { showTime: false, ranges: { Today: [moment(), moment()], '本月': [moment(), moment().endOf('month')] } }));
    };
    // 可选前辍的文本输入框
    FromContent.prototype.buildPrefixText = function (column, params, initValue) {
        var form = this.props.form;
        return React.createElement(PrefixInput_1.PrefixInput, { placeholder: column.placeholder ? column.placeholder : ('请填写' + column.title), options: column.options, value: initValue, onChange: function (val) {
                var _a;
                return form.setFieldsValue((_a = {}, _a[column.field] = val, _a));
            } });
    };
    //ICON图标选择器
    FromContent.prototype.buildIcon = function (column, params) {
        return React.createElement(antd_1.Select, __assign({}, column.config, params, { dropdownClassName: "icon-select" }), utils_1.IconUtil.IconList.map(function (icon) { return React.createElement(antd_1.Select.Option, { value: icon },
            React.createElement(antd_1.Icon, { type: icon })); }));
    };
    //ICON图标选择器:仅出现自定义图标
    FromContent.prototype.buildIconCustom = function (column, params) {
        return React.createElement(antd_1.Select, __assign({}, column.config, params, { dropdownClassName: "icon-select" }), utils_1.IconUtil.ExtraList.map(function (icon) { return React.createElement(antd_1.Select.Option, { value: icon },
            React.createElement(antd_1.Icon, { type: icon })); }));
    };
    //ICON图标选择器
    FromContent.prototype.buildImage = function (column, params) {
        var form = this.props.form;
        return React.createElement(SingleImage_1.default, __assign({}, column.config, { namespace: "app-portal" }, column.config, { def: this.initValue(column), callback: function (val) {
                var _a;
                return form.setFieldsValue((_a = {}, _a[column.field] = val, _a));
            } }));
    };
    //上传文件选择器
    FromContent.prototype.buildFile = function (column, params, initValue) {
        var form = this.props.form;
        var param = {};
        var value = form.getFieldValue(column.field);
        if (value && value.fileName) {
            param.initFile = value.fileName;
        }
        return React.createElement(Single_1.default, __assign({}, param, column.config, { callback: function (fileId, fileName) {
                var _a;
                return form.setFieldsValue((_a = {}, _a[column.field] = { fileId: fileId, fileName: fileName }, _a));
            } }));
    };
    //级联选择
    FromContent.prototype.buildCascader = function (column, params) {
        if (column.placeholder) {
            params.placeholder = column.placeholder;
        }
        else {
            params.placeholder = '请选择' + column.title;
        }
        return React.createElement(antd_1.Cascader, __assign({}, column.config, { changeOnSelect: true, options: column.options }, params, { fieldNames: { label: 'name', value: 'value', children: 'children' } }));
    };
    //级联选择
    FromContent.prototype.buildTreeSelect = function (column, params) {
        params.treeIcon = false;
        params.multiple = false;
        params.treeCheckable = false;
        if ((_.has(column.config, 'multiple') && column.config.multiple) || (_.has(column.config, 'treeCheckable') && column.config.treeCheckable)) {
            params.multiple = true;
            params.treeCheckable = true;
        }
        if (column.placeholder) {
            params.placeholder = column.placeholder;
        }
        else {
            params.placeholder = '请选择' + column.title;
        }
        if (_.has(column, 'options') && !_.has(column.config, 'treeData')) {
            params.treeData = nvToTree(column.options);
            // params.treeDataSimpleMode = {
            //     }
        }
        return React.createElement(antd_1.TreeSelect, __assign({}, column.config, params));
    };
    FromContent.prototype.setOrganizationValue = function (column, orgInfo) {
        var _a, _b;
        var filelds = column.field.split(',');
        var _c = __read(filelds, 4), code = _c[0], name = _c[1], province = _c[2], city = _c[3];
        var form = this.props.form;
        if (orgInfo == null) {
            form.setFieldsValue((_a = {},
                _a[column.field] = undefined,
                _a[code] = undefined,
                _a[name] = undefined,
                _a[province] = undefined,
                _a[city] = undefined,
                _a));
            var btn_1 = document.getElementById(column.field);
            if (btn_1) {
                btn_1.textContent = '请选择组织机构';
            }
            return;
        }
        form.setFieldsValue((_b = {}, _b[column.field] = orgInfo, _b));
        var btn = document.getElementById(column.field);
        if (btn) {
            var name_1 = utils_1.Format.formatString(orgInfo.name);
            var span = btn.getElementsByTagName('span')[0];
            if (span) {
                span.textContent = name_1;
            }
            else {
                var span1 = document.createElement('span');
                span1.textContent = name_1;
                btn.appendChild(span1);
                btn.classList.remove('ant-btn-icon-only');
            }
        }
    };
    FromContent.prototype.setMultiDomainValue = function (column, multiDomain) {
        var _a, _b;
        var filelds = column.field.split(',');
        var _c = __read(filelds, 2), code = _c[0], domainName = _c[1];
        var form = this.props.form;
        if (multiDomain == null || _.isEmpty(multiDomain)) {
            form.setFieldsValue((_a = {},
                _a[column.field] = '',
                _a[code] = '',
                _a[domainName] = '',
                _a));
            var btn_2 = document.getElementById(column.field);
            if (btn_2) {
                btn_2.textContent = '请选择安全域';
            }
            return;
        }
        form.setFieldsValue((_b = {}, _b[column.field] = multiDomain, _b));
        var btn = document.getElementById(column.field);
        if (btn) {
            btn.textContent = multiDomain.domainName.length > 26 ? (multiDomain.domainName.substr(0, 23) + '...') : multiDomain.domainName;
            btn.title = multiDomain.domainName;
        }
    };
    FromContent.prototype.setCheckbleDomainValue = function (column, multiDomain) {
        var _a, _b;
        var filelds = column.field.split(',');
        var _c = __read(filelds, 2), code = _c[0], domainName = _c[1];
        var form = this.props.form;
        if (multiDomain == null || _.isEmpty(multiDomain)) {
            form.setFieldsValue((_a = {},
                _a[column.field] = '',
                _a[code] = '',
                _a[domainName] = '',
                _a));
            var btn_3 = document.getElementById(column.field);
            if (btn_3) {
                btn_3.textContent = '请选择安全域';
            }
            return;
        }
        form.setFieldsValue((_b = {}, _b[column.field] = multiDomain, _b));
        var btn = document.getElementById(column.field);
        if (btn) {
            btn.textContent = multiDomain.domainName.length > 26 ? (multiDomain.domainName.substr(0, 23) + '...') : multiDomain.domainName;
            btn.title = multiDomain.domainName;
        }
    };
    FromContent.prototype.setDomainValue = function (column, domain) {
        var _a, _b;
        var filelds = column.field.split(',');
        var _c = __read(filelds, 2), code = _c[0], domainName = _c[1];
        var form = this.props.form;
        if (domain == null) {
            form.setFieldsValue((_a = {},
                _a[column.field] = '',
                _a[code] = '',
                _a[domainName] = '',
                _a));
            var btn_4 = document.getElementById(column.field);
            if (btn_4) {
                btn_4.textContent = '请选择安全域';
            }
            return;
        }
        form.setFieldsValue((_b = {}, _b[column.field] = domain, _b));
        var btn = document.getElementById(column.field);
        if (btn) {
            var span = btn.getElementsByTagName('span')[0];
            var name_2 = utils_1.Format.formatString(domain.domainName);
            if (span) {
                span.textContent = name_2;
            }
            else {
                var span1 = document.createElement('span');
                span1.textContent = name_2;
                btn.appendChild(span1);
                btn.classList.remove('ant-btn-icon-only');
            }
        }
    };
    FromContent.prototype.buildOrganizationEditor = function (column, initValue) {
        var _this = this;
        var param = { businessLine: '', useRoot: false };
        if (_.isPlainObject(column.config)) {
            if (_.has(column.config, 'businessLine') && !_.isEmpty(column.config.businessLine + '')) {
                param.businessLine = column.config.businessLine + '';
            }
            if (_.has(column.config, 'useRoot') && column.config.useRoot === true) {
                param.useRoot = true;
            }
        }
        return React.createElement(OrganizationSelect_1.default, __assign({}, param, { orgInfo: initValue, required: _.filter(column.rule, function (item) { return item.required; }).length > 0, onSelect: function (org) { return _this.setOrganizationValue(column, org); }, ref: function (modal) { return _this.SelectModals.set(column.field, modal); } }));
    };
    FromContent.prototype.buildDomainEditor = function (column, initValue) {
        var _this = this;
        return React.createElement(DomainSelect_1.default, { domainInfo: initValue, required: _.filter(column.rule, function (item) { return item.required; }).length > 0, onSelect: function (domain) { return _this.setDomainValue(column, domain); }, ref: function (modal) { return _this.SelectModals.set(column.field, modal); } });
    };
    FromContent.prototype.buildMultiDomainEditor = function (column, initValue) {
        var _this = this;
        return React.createElement(MultiDomainSelect_1.default, { domainInfo: initValue, required: _.filter(column.rule, function (item) { return item.required; }).length > 0, onSelect: function (multiDomain) { return _this.setMultiDomainValue(column, multiDomain); }, ref: function (modal) { return _this.SelectModals.set(column.field, modal); } });
    };
    FromContent.prototype.buildCheckbleDomainEditor = function (column, initValue) {
        var _this = this;
        return React.createElement(CheckbleDomainSelect_1.default, { domainInfo: initValue, required: _.filter(column.rule, function (item) { return item.required; }).length > 0, onCheck: function (multiDomain) { return _this.setCheckbleDomainValue(column, multiDomain); }, ref: function (modal) { return _this.SelectModals.set(column.field, modal); } });
    };
    FromContent.prototype.buildListModalButton = function (column, params, initialValue) {
        var form = this.props.form;
        var param = {
            onClick: function () {
                if (column.config.beforeQuery) {
                    var value = column.config.beforeQuery(column.config.param, form.getFieldsValue());
                    if (value === false) {
                        form.validateFields();
                        return false;
                    }
                }
                var props = {
                    title: "\u8BF7\u9009\u62E9".concat(column.title),
                    valueField: column.config.valueField,
                    columns: column.config.columns,
                    labelField: column.config.labelField || column.config.valueField,
                    param: column.config.param,
                    searchBar: column.config.searchBar,
                    api: column.config.api,
                    multi: column.config.multi,
                    width: column.config.width,
                    onSelect: function (ids, objs, label) {
                        var _a;
                        form.setFieldsValue((_a = {}, _a[column.field] = { value: ids.join(','), label: label }, _a));
                        var btn = document.getElementById(column.field);
                        if (btn) {
                            btn.textContent = utils_1.Format.formatString(label, 24);
                            btn.title = label;
                        }
                    }
                };
                ListSelectModal_1.default.SHOW(props);
            }
        };
        var txt = initialValue ? initialValue.label || initialValue.value : null;
        return React.createElement(antd_1.Button, __assign({ icon: "select" }, param),
            "  ",
            txt || column.placeholder || "\u8BF7\u9009\u62E9".concat(column.title),
            "  ");
    };
    FromContent.prototype.buildOrganization = function (column, params, initialValue) {
        var _this = this;
        var onSelect = function () {
            var modal = _this.SelectModals.get(column.field);
            modal.show();
        };
        return React.createElement(antd_1.Button, { icon: "select", onClick: function () { return onSelect(); } }, (initialValue && initialValue.name) ? initialValue.name : '请选择机构');
    };
    FromContent.prototype.buildDomain = function (column, params, initialValue) {
        var _this = this;
        var onSelect = function () {
            var modal = _this.SelectModals.get(column.field);
            modal.show();
        };
        return React.createElement(antd_1.Button, { icon: "select", onClick: function () { return onSelect(); } }, initialValue ? utils_1.Format.formatString(initialValue.domainName, 40) : '请选择管辖安全域');
    };
    FromContent.prototype.buildMultiDomain = function (column, params, initialValue) {
        var _this = this;
        var onSelect = function () {
            var modal = _this.SelectModals.get(column.field);
            modal.show();
        };
        var hasInitial = initialValue && initialValue.domainName;
        return React.createElement(antd_1.Button, { icon: "select", onClick: function () { return onSelect(); }, title: hasInitial ? initialValue.domainName : '' }, hasInitial ? (initialValue.domainName.length > 26 ? React.createElement("span", null,
            " ",
            initialValue.domainName.substr(0, 23) + '...',
            " ") :
            initialValue.domainName) : '请选择管辖安全域');
    };
    FromContent.prototype.buildCheckbleDomain = function (column, params, initialValue) {
        var _this = this;
        var onSelect = function () {
            var modal = _this.SelectModals.get(column.field);
            modal.show();
        };
        var hasInitial = initialValue && initialValue.domainName;
        return React.createElement(antd_1.Button, { icon: "select", onClick: function () { return onSelect(); }, title: hasInitial ? initialValue.domainName : '' }, hasInitial ? (initialValue.domainName.length > 26 ? React.createElement("span", null,
            " ",
            initialValue.domainName.substr(0, 23) + '...',
            " ") :
            initialValue.domainName) : '请选择管辖安全域');
    };
    FromContent.prototype.buildAutocomplete = function (column, params, initialValue) {
        if (_.has(column.config, 'api')) {
            this.LinkUtil.getLink(column, params);
            return React.createElement(AutoComplete_1.default, __assign({ placeholder: "\u8BF7\u586B\u5199".concat(column.title) }, column.config, params, { defaultValue: initialValue }));
        }
        return React.createElement(antd_1.Input, __assign({}, params));
    };
    FromContent.prototype.buildEditor = function (column, params, initialValue) {
        if (initialValue === void 0) { initialValue = ''; }
        return React.createElement(antd_1.Input, __assign({}, params));
    };
    FromContent.prototype.buildPic = function (column, params, initValue) {
        var form = this.props.form;
        return React.createElement(SingleImageSelect_1.default, __assign({ options: column.options }, column.config, { namespace: "app-portal" }, column.config, { def: this.initValue(column), callback: function (val) {
                var _a;
                return form.setFieldsValue((_a = {}, _a[column.field] = val, _a));
            } }));
    };
    FromContent.prototype.buildButton = function (column, params, initialValue) {
        if (initialValue === void 0) { initialValue = ''; }
        var form = this.props.form;
        var value = form.getFieldValue(column.field);
        return React.createElement(antd_1.Button, __assign({}, column.config), value || column.placeholder || column.title);
    };
    // 初始化每列的值 
    FromContent.prototype.initValue = function (column) {
        var e_2, _a, _b;
        if (column.type == 'date' || column.type == 'datetime' || column.type == 'month' || column.type == 'week') {
            if (_.has(this.props.data, column.field)) {
                if (this.props.data[column.field] === '') {
                    return '';
                }
                var date = moment(this.props.data[column.field], 'YYYY-MM-DD HH:mm:ss');
                if (date.format() == 'Invalid date') {
                    return moment(new Date());
                }
                return moment(this.props.data[column.field], 'YYYY-MM-DD HH:mm:ss');
            }
            else {
                return moment(new Date());
            }
        }
        else if (column.type == 'daterange') {
            var ptn = column.field.split(',');
            var _c = __read([undefined, undefined], 2), start = _c[0], end = _c[1];
            if (ptn.length == 2) {
                if (_.has(this.props.data, ptn[0])) {
                    start = moment(this.props.data[ptn[0]], 'YYYY-MM-DD');
                }
                if (_.has(this.props.data, ptn[1])) {
                    end = moment(this.props.data[ptn[1]], 'YYYY-MM-DD');
                }
            }
            return [start, end];
        }
        else if (column.type == 'prefix-text') {
            var ptn = column.field.split(',');
            var _d = __read([undefined, undefined], 2), select = _d[0], input = _d[1];
            if (ptn.length == 2) {
                var _e = __read(ptn, 2), selectField = _e[0], inputField = _e[1];
                if (_.has(this.props.data, selectField)) {
                    select = this.props.data[selectField] + '';
                }
                if (_.has(this.props.data, inputField)) {
                    input = this.props.data[inputField] + '';
                }
                ;
            }
            else {
                input = _.has(this.props.data, column.field) ? this.props.data[column.field] + '' : '';
                if (input == null || input == '') {
                    return [select, input];
                }
                if (!_.has(column, 'options')) {
                    return [select, input];
                }
                try {
                    for (var _f = __values(column.options), _g = _f.next(); !_g.done; _g = _f.next()) {
                        var opt = _g.value;
                        var prefix = opt.value + '';
                        if (_.startsWith(input, prefix)) {
                            select = prefix;
                            input = input.substr(prefix.length);
                        }
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_g && !_g.done && (_a = _f.return)) _a.call(_f);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
            return [select, input];
        }
        else if (column.type == 'time') {
            if (_.has(this.props.data, column.field)) {
                if (this.props.data[column.field] === '') {
                    return moment('00:00:00', 'HH:mm:ss');
                }
                var date = moment(this.props.data[column.field], 'HH:mm:ss');
                if (date.format() == 'Invalid date') {
                    return moment('00:00:00', 'HH:mm:ss');
                }
                return moment(this.props.data[column.field], 'HH:mm:ss');
            }
            else {
                return moment('00:00:00', ' HH:mm:ss');
            }
        }
        else if (column.type == 'checkbox' || column.type == 'checkbox-with-all' || column.type == 'selectcode' || (column.type == 'select' && column.config && column.config.mode == 'multiple')) {
            if (_.has(this.props.data, column.field)) {
                return _.filter(('' + this.props.data[column.field]).split(','), function (item) { return item != ''; });
            }
            return [];
        }
        else if (column.type == 'tree-select') {
            if ((_.has(column.config, 'multiple') && column.config.multiple) || (_.has(column.config, 'treeCheckable') && column.config.treeCheckable)) {
                return _.filter(('' + this.props.data[column.field]).split(','), function (item) { return item != ''; });
            }
            return _.has(this.props.data, column.field) ? this.props.data[column.field] + '' : '';
        }
        else if (column.type == 'cascader') {
            if (_.has(this.props.data, column.field)) {
                var val = this.props.data[column.field];
                var sel = [];
                for (var i = 0; i < column.options.length; i++) {
                    if (sel.length > 0) {
                        break;
                    }
                    if (column.options[i].value == val) {
                        sel = [column.options[i].value];
                    }
                    for (var j = 0; j < column.options[i].children.length; j++) {
                        if (val == column.options[i].children[j].value) {
                            sel = [column.options[i].value, column.options[i].children[j].value];
                        }
                    }
                }
                return sel;
            }
        }
        else if (column.type == 'organization') {
            var filelds = column.field.split(',');
            var _h = __read(filelds, 2), codeField = _h[0], nameField = _h[1];
            if (_.isEmpty(this.props.data) || _.isEmpty(this.props.data[codeField])) {
                return undefined;
            }
            var code = this.props.data[codeField] || null;
            var name_3 = this.props.data[nameField] || null;
            if (name_3 == null && code != null) {
                name_3 = OrganizationSelect_1.default.GET_NAME(code);
            }
            return { code: code, name: name_3 };
        }
        else if (column.type == 'file') {
            var idField = column.field, nameField = null;
            var ptns = column.field.split(',');
            if (ptns.length >= 2) {
                _b = __read(ptns, 2), idField = _b[0], nameField = _b[1];
            }
            var fileId = this.props.data[idField] || null;
            var fileName = nameField ? (this.props.data[nameField] || null) : null;
            return (fileId || fileName) ? ({ fileId: fileId, fileName: fileName }) : null;
        }
        else if (column.type == 'list-select-modal') {
            var _j = __read(column.field.split(','), 2), field = _j[0], label = _j[1];
            if (_.isEmpty(this.props.data) || this.props.data[field] == null || this.props.data[field] == '') {
                return undefined;
            }
            return { value: this.props.data[field] || null, label: this.props.data[label] || null };
        }
        else if (column.type == 'domain') {
            var filelds = column.field.split(',');
            var _k = __read(filelds, 2), code = _k[0], domainName = _k[1];
            if (_.isEmpty(this.props.data) || _.isEmpty(this.props.data[code])) {
                return undefined;
            }
            return { code: this.props.data[code] || null, domainName: this.props.data[domainName] || null };
        }
        else if (column.type == 'multiDomain' || column.type == 'checkbleDomain') {
            var filelds = column.field.split(',');
            var _l = __read(filelds, 2), domainCode = _l[0], domainName = _l[1];
            if (_.isEmpty(this.props.data) || this.props.data[domainCode] == null) {
                return undefined;
            }
            return { domainCode: this.props.data[domainCode] || null, domainName: this.props.data[domainName] || null };
        }
        else if (column.type == 'switch') {
            return _.has(this.props.data, column.field) ? this.props.data[column.field] : column.options[0].value;
        }
        else if (column.type == 'select' || column.type == 'radio') {
            return _.has(this.props.data, column.field) ? (this.props.data[column.field] + '') : undefined;
        }
        return _.has(this.props.data, column.field) ? (this.props.data[column.field] + '') : '';
    };
    FromContent.prototype.buildInput = function (column) {
        var getFieldDecorator = this.props.form.getFieldDecorator;
        var rules = (0, RuleTip_1.ruleMessage)(column);
        var initialValue = this.initValue(column);
        if (_.has(column, 'showed') && column.showed === false) {
            return React.createElement(antd_1.Form.Item, { label: column.title, style: { display: 'none' } }, getFieldDecorator(column.field, { initialValue: initialValue, })(this.inputElement(column, initialValue)));
        }
        return React.createElement(antd_1.Form.Item, __assign({ label: column.title }, (this.props.loose ? {
            labelCol: { span: 3, }, wrapperCol: { span: 20 }
        } : {
            labelCol: { span: 6, }, wrapperCol: { span: 16 }
        })),
            getFieldDecorator(column.field, {
                initialValue: initialValue,
                rules: rules,
            })(this.inputElement(column, initialValue)),
            [
                column.type == 'organization' && this.buildOrganizationEditor(column, initialValue),
                column.type == 'domain' && this.buildDomainEditor(column, initialValue),
                column.type == 'multiDomain' && this.buildMultiDomainEditor(column, initialValue),
                column.type == 'checkbleDomain' && this.buildCheckbleDomainEditor(column, initialValue),
            ]);
    };
    FromContent.prototype.buildColumn = function (columns) {
        var _this = this;
        return columns.map(function (row) {
            return row.map(function (column) { return _this.buildInput(column); });
        });
    };
    FromContent.prototype.render = function () {
        return React.createElement(antd_1.Form, null, this.buildColumn(this.state.columns));
    };
    return FromContent;
}(React.PureComponent));
/**
 *
 * @deprecated
 * 说明 : FormModal VFormModal 不再维护，
 * 统一使用  UForm UFormModal UInfo UInfoModal
 *
 * 表单弹框，支持各种类型的表单元素填写，当提交时，会调用 onOk 方法将编辑的对象信息以参数传递回去。
*/
var FormModal = /** @class */ (function (_super) {
    __extends(FormModal, _super);
    function FormModal() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.submiting = false;
        _this.form = null;
        return _this;
    }
    FormModal.prototype._warpColumns = function (columns) {
        var e_3, _a;
        var columnGroups = [];
        var breaked = false;
        try {
            for (var columns_1 = __values(columns), columns_1_1 = columns_1.next(); !columns_1_1.done; columns_1_1 = columns_1.next()) {
                var column = columns_1_1.value;
                if (!column) {
                    continue;
                }
                var group = [];
                if (!breaked) {
                    columnGroups.push(group);
                }
                else {
                    group = columnGroups[columnGroups.length - 1];
                }
                group.push(column);
                if (column.inline) {
                    breaked = true;
                }
                else {
                    breaked = false;
                }
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (columns_1_1 && !columns_1_1.done && (_a = columns_1.return)) _a.call(columns_1);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return columnGroups;
    };
    FormModal.prototype.componentDidUpdate = function (old) {
        if (!old.visible && this.props.visible) {
            this.submiting = false;
        }
    };
    FormModal.prototype.getField = function (field) {
        var form = this.form.getForm();
        return form.getFieldValue(field);
    };
    FormModal.prototype.submit = function () {
        var _this = this;
        if (this.submiting) {
            return;
        }
        var form = this.form.getForm();
        form.validateFields(function (err, values) {
            if (err) {
                _this.submiting = false;
                return;
            }
            _this.submiting = true;
            _this.props.columns.map(function (column) {
                var _a;
                if (column.type == 'switch') {
                    if (_.has(values, column.field)) {
                        if (values[column.field] === true) {
                            values[column.field] = column.options[0].value;
                        }
                        else if (values[column.field] === false) {
                            values[column.field] = column.options[1].value;
                        }
                    }
                }
                else if (column.type == 'date') {
                    if (values[column.field]) {
                        values[column.field] = values[column.field].format('YYYY-MM-DD');
                    }
                    else {
                        return '';
                    }
                }
                else if (column.type == 'month') {
                    if (values[column.field]) {
                        values[column.field] = values[column.field].format('YYYY-MM-01');
                    }
                    else {
                        return '';
                    }
                }
                else if (column.type == 'week') {
                    if (values[column.field]) {
                        values[column.field] = moment(values[column.field]).day(1).format('YYYY-MM-DD');
                    }
                    else {
                        return '';
                    }
                }
                else if (column.type == 'datetime') {
                    if (values[column.field]) {
                        values[column.field] = values[column.field].format('YYYY-MM-DD HH:mm:ss');
                    }
                    else {
                        return '';
                    }
                }
                else if (column.type == 'time') {
                    if (values[column.field]) {
                        values[column.field] = values[column.field].format('HH:mm:ss');
                    }
                    else {
                        return '';
                    }
                }
                else if (column.type == 'daterange') {
                    var _b = __read(values[column.field], 2), start = _b[0], end = _b[1];
                    var fields = column.field.split(',');
                    if (fields.length == 2) {
                        values[fields[0]] = start ? start.format('YYYY-MM-DD') : '';
                        values[fields[1]] = end ? end.format('YYYY-MM-DD') : '';
                        _.unset(values, column.field);
                    }
                }
                else if (column.type == 'prefix-text') {
                    var ptn = column.field.split(',');
                    var select = values[column.field][0] || '';
                    var text = values[column.field][1] || '';
                    if (ptn.length == 1) {
                        values[column.field] = select + text;
                    }
                    else {
                        var _c = __read(ptn, 2), selectField = _c[0], inputField = _c[1];
                        values[selectField] = select;
                        values[inputField] = text;
                        _.unset(values, column.field);
                    }
                }
                else if (column.type == 'checkbox' || column.type == 'checkbox-with-all' || column.type == 'selectcode' || (column.type == 'select' && column.config && column.config.mode == 'multiple')) {
                    values[column.field] = values[column.field].join(',');
                }
                else if (column.type == 'tree-select') {
                    if ((_.has(column.config, 'multiple') && column.config.multiple) || (_.has(column.config, 'treeCheckable') && column.config.treeCheckable)) {
                        values[column.field] = values[column.field].join(',');
                    }
                }
                else if (column.type == 'radiomore') {
                    if (values[column.field] == MORE) {
                        if (_.has(STOREMORE, MORE + column.field)) {
                            values[column.field] = STOREMORE[MORE + column.field];
                        }
                        else {
                            values[column.field] = '';
                        }
                    }
                }
                else if (column.type == 'cascader') {
                    if (values[column.field].length > 0) {
                        values[column.field] = values[column.field][values[column.field].length - 1];
                    }
                    else {
                        values[column.field] = '';
                    }
                }
                else if (column.type == 'list-select-modal') {
                    var filelds = column.field.split(',');
                    var _d = __read(filelds, 2), field = _d[0], label = _d[1];
                    var info = values[column.field];
                    if (info) {
                        if (label)
                            values[label] = info.label;
                        values[field] = info.value;
                    }
                    else {
                        if (label)
                            values[label] = '';
                        values[field] = '';
                    }
                    _.unset(values, column.field);
                }
                else if (column.type == 'organization') {
                    var filelds = column.field.split(',');
                    var _e = __read(filelds, 4), code = _e[0], name_4 = _e[1], province = _e[2], city = _e[3];
                    var orgInfo = values[column.field];
                    if (orgInfo) {
                        if (code)
                            values[code] = orgInfo.code;
                        if (name_4)
                            values[name_4] = orgInfo.name;
                        if (province)
                            values[province] = orgInfo.code.substr(0, 2);
                        if (city)
                            values[city] = orgInfo.code.substr(0, 4);
                    }
                    else {
                        if (code)
                            values[code] = '';
                        if (name_4)
                            values[name_4] = '';
                        if (province)
                            values[province] = '';
                        if (city)
                            values[city] = '';
                    }
                    _.unset(values, column.field);
                }
                else if (column.type == 'file') {
                    var info = values[column.field];
                    if (info) {
                        var idField = column.field, nameField = null;
                        var ptns = column.field.split(',');
                        if (ptns.length >= 2) {
                            _a = __read(ptns, 2), idField = _a[0], nameField = _a[1];
                        }
                        values[idField] = info.fileId;
                        if (nameField) {
                            values[nameField] = info.fileName;
                        }
                        _.unset(values, column.field);
                    }
                }
                else if (column.type == 'domain') {
                    var filelds = column.field.split(',');
                    var _f = __read(filelds, 2), code = _f[0], domainName = _f[1];
                    var domainInfo = values[column.field];
                    if (domainInfo) {
                        if (code)
                            values[code] = domainInfo.code;
                        if (domainName)
                            values[domainName] = domainInfo.domainName;
                    }
                    else {
                        if (code)
                            values[code] = '';
                        if (domainName)
                            values[domainName] = '';
                    }
                    _.unset(values, column.field);
                }
                else if (column.type == 'editor') {
                }
                else if (column.type == 'multiDomain' || column.type == 'checkbleDomain') {
                    var filelds = column.field.split(',');
                    var _g = __read(filelds, 2), domainCode = _g[0], domainName = _g[1];
                    var multiDomainInfo = values[column.field];
                    if (multiDomainInfo) {
                        if (domainCode)
                            values[domainCode] = multiDomainInfo.domainCode;
                        if (domainName)
                            values[domainName] = multiDomainInfo.domainName;
                    }
                    else {
                        if (domainCode)
                            values[domainCode] = '';
                        if (domainName)
                            values[domainName] = '';
                    }
                    _.unset(values, column.field);
                }
            });
            _this.props.onOk(_.assign({}, _this.props.default, _this.props.data, values));
            _this.submiting = false;
        });
    };
    FormModal.prototype.render = function () {
        var _this = this;
        var data = _.assign({}, this.props.default, this.props.data);
        _.keys(data).map(function (key) {
            if (data[key] === null) {
                data[key] = '';
            }
        });
        var loose = false;
        if (_.isNumber(this.props.width) && this.props.width >= 960) {
            loose = true;
        }
        var DataFrom = antd_1.Form.create()(FromContent);
        var columns = this._warpColumns(this.props.columns);
        var param = {};
        if (window.VAP_GLOBAL.UFORM.maskClosable == false) {
            param.maskClosable = false;
        }
        return React.createElement(antd_1.Modal, __assign({ footer: [
                React.createElement(antd_1.Button, { type: "primary", onClick: function () { return _this.submit(); } }, "\u786E\u5B9A"),
                React.createElement(antd_1.Button, { onClick: function (evt) { return _this.props.onCancel(evt); } }, "\u53D6\u6D88")
            ] }, param, this.props, { onOk: function () { return _this.submit(); } }),
            this.props.tip ? React.createElement("div", { style: { marginBottom: 6 } }, this.props.tip) : [],
            React.createElement(DataFrom, { loose: loose, data: data, columns: columns, show: this.props.visible, ref: function (form) { return _this.form = form; } }));
    };
    FormModal.MORE = MORE;
    return FormModal;
}(React.PureComponent));
exports.default = FormModal;
