"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var antd_1 = require("antd");
var _ = require("lodash");
var classValue = function (data, column) {
    if (column.className) {
        if (column.render) {
            return React.createElement("span", { className: column.className }, column.render(data[column.field], data));
        }
        return React.createElement("span", { className: column.className }, data[column.field]);
    }
    else {
        if (column.render) {
            return column.render(data[column.field], data);
        }
        return data[column.field];
    }
};
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    default_1.prototype.renderItem = function (data, column) {
        var param = {
            label: column.label
        };
        if (_.has(column, 'icon')) {
            param.label = [React.createElement(antd_1.Icon, { type: param.icon }), param.label];
        }
        if (_.has(column, 'span')) {
            param.span = column.span;
        }
        if (_.has(column, 'align')) {
            param.align = column.align;
        }
        return React.createElement(antd_1.Descriptions.Item, __assign({}, param),
            classValue(data, column),
            " ");
    };
    default_1.prototype.renderGroup = function (group) {
        var _this = this;
        var param = {
            size: 'small',
            bordered: false,
            title: React.createElement("span", { className: "group-title" }, group.title),
            column: _.has(group, 'cols') ? group.cols : 2,
        };
        if (group.field) {
            var data_1 = _.get(this.props.data, group.field);
            if (_.isNull(data_1)) {
                var colParam = { style: { width: '100%' } };
                return React.createElement(antd_1.Descriptions, __assign({}, param, { column: 1 }),
                    React.createElement(antd_1.Descriptions.Item, __assign({}, colParam),
                        React.createElement(antd_1.Empty, { imageStyle: { margin: 0 }, image: antd_1.Empty.PRESENTED_IMAGE_SIMPLE, description: "\u6682\u65E0\u6570\u636E", style: { textAlign: 'center', margin: "0 0 0 ".concat((800 - 84) / 2, "px") } })));
            }
            if (_.isArray(data_1)) {
                return React.createElement(React.Fragment, null,
                    React.createElement(antd_1.Descriptions, __assign({}, param)),
                    React.createElement(antd_1.List, { size: "small", dataSource: data_1, renderItem: function (item) {
                            return React.createElement(antd_1.Descriptions, { size: "small", bordered: false, column: _.has(group, 'cols') ? group.cols : 2 }, group.columns.map(function (col) { return _this.renderItem(item, col); }));
                        } }));
            }
            else if (_.isObject(data_1)) {
                React.createElement(antd_1.Descriptions, __assign({}, param), group.columns.map(function (col) { return _this.renderItem(data_1, col); }));
            }
            return React.createElement(antd_1.Descriptions, __assign({}, param));
        }
        else {
            return React.createElement(antd_1.Descriptions, __assign({}, param), group.columns.map(function (col) { return _this.renderItem(_this.props.data, col); }));
        }
    };
    default_1.prototype.render = function () {
        var _this = this;
        var modalParam = {};
        return React.createElement(antd_1.Modal, __assign({}, modalParam, this.props, { footer: null, className: "vap-groupinfo-modal" }), _.isPlainObject(this.props.data) ? this.props.groups.map(function (group) { return _this.renderGroup(group); }) : React.createElement(antd_1.Spin, null));
    };
    return default_1;
}(React.PureComponent));
exports.default = default_1;
