/// <reference types="react" />
import { ModalProps } from 'antd/lib/modal/Modal';
export interface ColumnProps {
    label: React.ReactNode;
    field: string;
    icon?: string;
    render?: (text: any, obj: any) => React.ReactNode;
    align?: 'left' | 'right' | 'center';
    className?: string;
    span?: 1 | 2 | 3;
}
export interface Group {
    /**
     * 一行显示几列，默认为 2
    */
    cols?: 1 | 2 | 3;
    /**
     * 标题
    */
    title?: string;
    /**
     * 如果展示是是一个列表,或是一个下级对象，传 field Path
    */
    field?: string;
    /**
     * 列定义
    */
    columns: ColumnProps[];
}
export interface GroupInfoModalOpts extends ModalProps {
    /**
     * 需要展示的数据
    */
    data: any;
    /**
     * 展示信息
    */
    groups: Group[];
}
