"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var _ = require("lodash");
var antd_1 = require("antd");
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.listScreen = null;
        _this.setInterval = null;
        _this.scrollTop = 0;
        _this.state = {
            speed: 0,
            showAction: false,
            play: true,
        };
        return _this;
    }
    default_1.prototype.load = function () {
        var _this = this;
        this.setInterval = window.setInterval(function () {
            ++_this.scrollTop;
            _this.listScreen.scrollTop = _this.scrollTop;
            if (_this.listScreen.scrollTop + _this.listScreen.offsetHeight == _this.listScreen.scrollHeight) {
                _this.scrollTop = 0;
                _this.listScreen.scrollTop = 0;
            }
        }, this.state.speed);
    };
    default_1.prototype.componentDidMount = function () {
        var _this = this;
        var speed = this.getSpeed();
        this.setState({ speed: speed }, function () {
            _this.load();
        });
    };
    default_1.prototype.componentWillUnmount = function () {
        clearInterval(this.setInterval);
    };
    default_1.prototype.getSpeed = function () {
        var speed = 0;
        if (_.isNumber(this.props.speed)) {
            speed = this.props.speed;
        }
        else {
            switch (this.props.speed) {
                case 'quick':
                    speed = 1;
                    break;
                case 'slow':
                    speed = 50;
                    break;
                default:
                    speed = 30;
            }
        }
        return speed;
    };
    default_1.prototype.onMouseOver = function () {
        clearInterval(this.setInterval);
        this.setState({ showAction: true });
    };
    default_1.prototype.onMouseLeave = function () {
        if (this.state.play)
            this.load();
        this.setState({ showAction: false });
    };
    default_1.prototype.render = function () {
        var _this = this;
        // 计算减速倍速
        var slow = this.state.speed / this.getSpeed();
        // 计算加速倍速
        var quick = this.getSpeed() / this.state.speed;
        // 最小倍速
        var minSpeed = slow < 4;
        // 最大倍速
        var maxSpeed = quick < 8;
        // 判断是加速还是减速
        var isQuick = quick >= 1;
        return React.createElement("div", { className: 'listScreen_box ' + this.props.className || '', style: this.props.style, onMouseOver: function () { return _this.onMouseOver(); }, onMouseLeave: function () { return _this.onMouseLeave(); }, ref: function (listScreen) { return _this.listScreen = listScreen; } },
            this.props.action && React.createElement("div", { className: 'action_box ant-popover-inner', style: { display: this.state.showAction ? 'flex' : 'none', } },
                React.createElement("a", null,
                    React.createElement(antd_1.Icon, { type: 'fast-backward', onClick: function () { return minSpeed && _this.setState({ speed: _this.state.speed * 2 }); } })),
                !this.state.play ?
                    React.createElement("a", null,
                        React.createElement(antd_1.Icon, { type: 'play-circle', onClick: function () { return _this.setState({ play: true }); } })) :
                    React.createElement("a", null,
                        " ",
                        React.createElement(antd_1.Icon, { type: 'pause-circle', onClick: function () { return _this.setState({ play: false }, function () { return clearInterval(_this.setInterval); }); } })),
                React.createElement("a", null,
                    " ",
                    React.createElement(antd_1.Icon, { type: 'fast-forward', onClick: function () { return maxSpeed && _this.setState({ speed: _this.state.speed / 2 }); } })),
                React.createElement("span", { className: 'vapfont' },
                    isQuick ? '×' : '÷',
                    (isQuick ? quick : slow))),
            this.props.data.map(function (item, index) { return _this.props.itemRender(item, index); }));
    };
    return default_1;
}(React.PureComponent));
exports.default = default_1;
