import { ColumnProps } from 'antd/lib/table/interface';
import { SearchBarOpts } from '../Table/interface';
/**
 * 模块化前的封装，可用脚本控制
*/
export interface ListSelectProps {
    /**
     * 已经选中的项，
     * 说明：由于技术限制，有BUG，谨慎使用，如果打开之前已经有了选中项，打开时查询到选中列之后，自动将基勾选
    */
    selected?: string[];
    /**
     * 数据的 fieldKey ，默认为 'id'
     * 选中后的数据会以KEY传出
    */
    valueField?: string;
    /**
     * 选中后返回文本的字段，默认与 valueField保持一致
    */
    labelField?: string;
    /**
        * 列定义
       */
    columns: ColumnProps<any>[];
    /**
     * 查询地址 必传，必须是 POST 接口
    */
    api: string;
    /**
     * 是否支持多选,必须select有传时才能使用
    */
    multi?: boolean;
    /**
     * 默认查询参数
    */
    param?: any;
    /**
     * 搜索参数 不再使用
    */
    searchBar?: SearchBarOpts;
    /**
     * 传择回调，传入 select 后，弹框变为选择模式，不再支持增删改操作
    */
    onSelect: Function;
    /**
     * 查询前调用方法
    */
    beforeQuery?: Function;
    /**
     * 是否支持选中
    */
    canSelect?: (item: any) => boolean;
}
/**
 * 模块化后的封装，用 Modal 进行控制
*/
export interface ListSelectModalProps extends ListSelectProps {
    /**
   * 选择器标题
   *
  */
    title?: string;
    /**
     *
    */
    visible?: boolean;
    /**
     *
    */
    width?: number;
    /**
     * 取消
    */
    onCancel?: Function;
    /**
     * 扩展样式
    */
    className?: String;
}
