"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var _ = require("lodash");
var antd_1 = require("antd");
var ActionButton_1 = require("../Table/ActionButton");
var _Util_1 = require("./_Util");
var WIDTH_ONE = 480; // 一列宽度
var WIDTH_TWO = 800; // 两列宽度
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.cols = 1;
        _this.width = WIDTH_TWO;
        _this.fixedWidth = 320;
        _this.labelWidth = 96;
        _this.SearchFilelds = [];
        _this.inputFields = null;
        _this.state = {
            keyword_: undefined,
            __showPopup: false,
        };
        return _this;
    }
    default_1.prototype.componentDidMount = function () {
        var _this = this;
        var cols = 1;
        if (_.has(this.props, 'cols')) {
            cols = this.props.cols;
        }
        else if (this.props.fields && this.props.fields.length >= 8) {
            cols = 2;
        }
        this.cols = cols;
        this.width = cols > 1 ? WIDTH_TWO : WIDTH_ONE;
        this.fixedWidth = (this.width - 24) / cols;
        var rowUse = 0;
        this.SearchFilelds = [];
        this.inputFields = new Set();
        var state = {};
        if (_.has(this.props, 'fields') && this.props.fields.length > 0) {
            this.SearchFilelds.push([]);
            this.props.fields.map(function (field) {
                if (field.show === false) {
                    return;
                }
                if (field.type == 'timerange' || field.type == 'daterange') {
                    var _a = __read(field.field.split(','), 2), startField = _a[0], endField = _a[1];
                    if (_.has(_this.props.default, startField)) {
                        state[startField] = _this.props.default[startField];
                    }
                    if (_.has(_this.props.default, endField)) {
                        state[endField] = _this.props.default[endField];
                    }
                }
                if (_.has(_this.props.default, field.field)) {
                    state[field.field] = _this.props.default[field.field];
                }
                var row = _this.SearchFilelds[_this.SearchFilelds.length - 1];
                var span = field.span || 1;
                var tryfill = rowUse + span;
                if (field.field.indexOf(',') > 0) {
                    field.field.split(',').map(function (key) { return _this.inputFields.add(key); });
                }
                else {
                    _this.inputFields.add(field.field);
                }
                if (tryfill > cols) {
                    _this.SearchFilelds.push([field]);
                    rowUse = span;
                }
                else {
                    row.push(field);
                    rowUse += span;
                }
            });
        }
        this.setState(state);
    };
    default_1.prototype.check = function (field, value) {
        var _a;
        if (_.isPlainObject(value)) {
            this.setState(value);
        }
        else {
            this.setState((_a = {}, _a[field] = value, _a));
        }
    };
    default_1.prototype.clear = function () {
        var _this = this;
        var state = {};
        _.keys(this.state).map(function (key) {
            if (!key.startsWith('__')) {
                state[key] = _.has(_this.props.default, key) ? _this.props.default[key] : '';
            }
        });
        this.setState(state);
    };
    default_1.prototype.search = function (isAdvance) {
        var _this = this;
        if (isAdvance === void 0) { isAdvance = false; }
        var query = {};
        _.keys(this.state).map(function (key) {
            if (key.startsWith('__'))
                return;
            if (!isAdvance && !_.has(_this.props.default, key)) {
                return;
            }
            // 自动 trim
            if (_.isString(_this.state[key])) {
                query[key] = _.trim(_this.state[key]);
            }
            else {
                query[key] = _this.state[key];
            }
        });
        if (isAdvance) {
            query.keyword_ = null;
        }
        else {
            query.keyword_ = this.state.keyword_;
        }
        this.props.onSearch(query);
        this.setState({ __showPopup: false });
    };
    default_1.prototype.renderInput = function (field) {
        var _this = this;
        var SearchField = (0, _Util_1.getSearchField)(field.type);
        var times = field.span || 1;
        times = times > this.cols ? this.cols : times;
        var width = this.fixedWidth * times - this.labelWidth;
        return React.createElement(React.Fragment, null,
            React.createElement("label", { style: { width: this.labelWidth }, className: "search-bar-field-label" }, field.label),
            React.createElement("div", { className: "search-bar-field-input search-bar-field-input-".concat(field.type) },
                React.createElement(SearchField, { width: width, field: field, onChange: function (val) { return _this.check(field.field, val); }, triggerSearch: function () { return _this.search(); }, data: this.state })));
    };
    default_1.prototype.renderPopup = function () {
        var _this = this;
        return React.createElement(antd_1.Row, { className: "vap-table-search-bar  vap-table-search-bar-expand vap-table-keyword-modal", style: { width: this.width } },
            React.createElement(antd_1.Col, { className: 'vap-table-keyword-modal-title' },
                "\u9AD8\u7EA7\u641C\u7D22 ",
                React.createElement(antd_1.Icon, { type: 'close', title: '\u5173\u95ED', onClick: function () { return _this.setState({ __showPopup: false }); } })),
            React.createElement(antd_1.Col, { className: "vap-table-search-bar-input" }, this.SearchFilelds.map(function (row, i) { return React.createElement(antd_1.Input.Group, { compact: false, className: 'search-bar-outside' }, row.map(function (field) { return _this.renderInput(field); })); })),
            React.createElement(antd_1.Col, { className: 'vap-table-keyword-modal-buttons' },
                React.createElement(antd_1.Button, { icon: 'search', type: 'primary', onClick: function () { return _this.search(true); } }, "\u641C \u7D22"),
                React.createElement(antd_1.Button, { icon: 'redo', onClick: function () { return _this.clear(); } }, "\u91CD \u7F6E"),
                React.createElement(antd_1.Button, { icon: 'close', type: "danger", onClick: function () { return _this.setState({ __showPopup: false }); } }, "\u53D6 \u6D88")));
    };
    default_1.prototype.renderButtons = function () {
        if (!_.has(this.props, 'buttons')) {
            return [];
        }
        return React.createElement(ActionButton_1.ActionButton, { buttons: this.props.buttons, selectedRowKeys: this.props.selectedRowKeys, selectObjects: this.props.selectObjects, param: this.props.param });
    };
    default_1.prototype.render = function () {
        var _this = this;
        var canExpand = false;
        var inputProps = {
            placeholder: '请填写关键字',
        };
        if (typeof this.props.keyword != 'boolean') {
            if (this.props.keyword.placeholder) {
                inputProps.placeholder = this.props.keyword.placeholder;
            }
        }
        if (this.props.fields && this.props.fields.length) {
            canExpand = true;
        }
        var icon = 'more';
        var _a = this.state, keyword_ = _a.keyword_, __showPopup = _a.__showPopup;
        return React.createElement(antd_1.Row, { className: "vap-table-search-bar" },
            React.createElement(antd_1.Col, { className: "vap-table-search-bar-input" },
                React.createElement(antd_1.Input.Group, { compact: true, className: "search-bar-inside search-bar-keyword" },
                    React.createElement(antd_1.Input, __assign({}, inputProps, { value: keyword_, onChange: function (evt) { return _this.setState({ keyword_: evt.target.value }); }, onPressEnter: function () { return _this.search(); }, style: { width: 320 }, allowClear: true })),
                    canExpand ? React.createElement(antd_1.Dropdown.Button, { trigger: ['click'], visible: __showPopup, 
                        //@ts-ignore
                        onVisibleChange: function (visible, b, c) {
                            // if (visible) {
                            _this.setState({ __showPopup: visible });
                            // }
                        }, icon: React.createElement(antd_1.Icon, { type: icon, title: '\u9AD8\u7EA7\u641C\u7D22', onClick: function () { return _this.setState({ __showPopup: true }); } }), type: 'primary', onClick: function () { return _this.search(); }, overlay: function () { return _this.renderPopup(); }, title: "\u9AD8\u7EA7\u641C\u7D22" },
                        React.createElement(antd_1.Icon, { type: 'search' }),
                        "\u641C \u7D22") :
                        React.createElement(antd_1.Button, { icon: 'search', type: 'primary', onClick: function () { return _this.search(); } }, "\u641C \u7D22"),
                    React.createElement("div", { className: "vap-table-search-bar-btns" }, this.renderButtons()))));
    };
    return default_1;
}(React.PureComponent));
exports.default = default_1;
