"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isSearchFieldOutSide = exports.getSearchField = exports.registerSearchField = exports.getSelectBar = exports.registerSelectBar = void 0;
var _ = require("lodash");
if (!_.has(window, '_TABLE_SELECTIONS'))
    window['_TABLE_SELECTIONS'] = new Map();
if (!_.has(window, '_TABLE_SEARCHTYPES'))
    window['_TABLE_SEARCHTYPES'] = new Map();
if (!_.has(window, '_TABLE_FIELD_OUTSIDE'))
    window['_TABLE_FIELD_OUTSIDE'] = new Map();
var TABLE_SELECT_MAP = window['_TABLE_SELECTIONS'];
var TABLE_FIELD_MAP = window['_TABLE_SEARCHTYPES'];
var TABLE_FIELD_OUTSIDE = window['_TABLE_FIELD_OUTSIDE'];
var registerSelectBar = function (type, compoment) {
    if (TABLE_SELECT_MAP.has(type)) {
        // console.warn(`${type} is aready registered, use new component overwrite`)
        // return;
    }
    TABLE_SELECT_MAP.set(type, compoment);
};
exports.registerSelectBar = registerSelectBar;
var getSelectBar = function (type) { return TABLE_SELECT_MAP.get(type); };
exports.getSelectBar = getSelectBar;
var registerSearchField = function (type, compoment, outside) {
    if (outside === void 0) { outside = false; }
    if (TABLE_FIELD_MAP.has(type)) {
        // console.warn(`${type} is aready registered , use new component overwrite`)
        // return;
    }
    TABLE_FIELD_MAP.set(type, compoment);
    TABLE_FIELD_OUTSIDE.set(type, outside ? true : false);
};
exports.registerSearchField = registerSearchField;
var getSearchField = function (type) { return TABLE_FIELD_MAP.has(type) ? TABLE_FIELD_MAP.get(type) : TABLE_FIELD_MAP.get('text'); };
exports.getSearchField = getSearchField;
var isSearchFieldOutSide = function (type) {
    if (TABLE_FIELD_OUTSIDE.has(type) && TABLE_FIELD_OUTSIDE.get(type)) {
        return true;
    }
    return false;
};
exports.isSearchFieldOutSide = isSearchFieldOutSide;
