import { TableProps } from 'antd/lib/table/interface';
export interface TopTableProps extends TableProps<any> {
    /**
     * TopTable 模式下，dataSource必传
     */
    dataSource: any[];
    /**
     * 最大显示榜单个数
     */
    pageSize?: number;
    /**
     * 是否显示排行（默认显示）
     */
    showIndex?: boolean | string;
    /**
     * 数据切换时是否自动选择（默认选择）
     */
    autoRow?: boolean;
    /**
     * 是否显示前几名颜色（默认显示 ）
     */
    topColor?: boolean;
    /**
     * 锁定表头
     * 说明：为了方便，默认为true，
     * 如果想不锁定，或锁定有问题，可以传false,自行传scroll
    */
    fixHeader?: boolean;
    /**
     * 选中操作
     */
    onRowClick?: (record: any, index?: number, event?: Event) => void;
}
