"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.UDescriptions = exports.UDescriptionsItem = void 0;
var React = require("react");
var _ = require("lodash");
var UDescriptionsItem = /** @class */ (function (_super) {
    __extends(UDescriptionsItem, _super);
    function UDescriptionsItem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return UDescriptionsItem;
}(React.PureComponent));
exports.UDescriptionsItem = UDescriptionsItem;
var isReactFragment = function (variableToInspect) {
    if (variableToInspect.type) {
        return variableToInspect.type === React.Fragment;
    }
    return false;
};
var toArray = function (children) {
    var ret = [];
    React.Children.forEach(children, function (child) {
        if (child === undefined || child === null) {
            return;
        }
        if (isReactFragment(child)) {
            //@ts-ignore
            ret = ret.concat(toArray(child.props.children));
            return;
        }
        if (Array.isArray(child)) {
            ret = ret.concat(toArray(child));
        }
        else {
            ret.push(child);
        }
    });
    return ret;
};
var UDescriptions = exports.UDescriptions = /** @class */ (function (_super) {
    __extends(UDescriptions, _super);
    function UDescriptions() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UDescriptions.prototype.render = function () {
        var _a;
        var className = (_a = this.props, _a.className), style = _a.style, title = _a.title, lebelWidth = _a.lebelWidth, column = _a.column;
        var cols = column || 2;
        var items = toArray(this.props.children);
        if (items.length == 0) {
            return [];
        }
        var classes = "ant-descriptions ant-descriptions-small ant-descriptions-bordered u-descriptions  u-descriptions-cols-".concat(cols, " u-descriptions-labels-").concat(lebelWidth, " ").concat(className ? className : '');
        var rows = generateChildrenRows(items, cols);
        return React.createElement("div", { className: classes, style: style },
            title && React.createElement("div", { className: "ant-descriptions-title" }, title),
            React.createElement("div", { className: "ant-descriptions-view" },
                React.createElement("table", null,
                    React.createElement("colgroup", null, _.range(cols * 2).map(function (i) { return React.createElement("col", { className: (i % 2 == 0) ? 'u-label' : 'u-value' }); })),
                    React.createElement("tbody", null,
                        React.createElement("tr", { className: "udes-align" }, _.range(cols * 2).map(function (i) { return (i % 2 == 0) ? React.createElement("th", null) : React.createElement("td", null); })),
                        rows.map(function (row) { return React.createElement("tr", { className: "ant-descriptions-row" }, renderRow(row, column)); })))));
    };
    UDescriptions.Item = UDescriptionsItem;
    return UDescriptions;
}(React.PureComponent));
var generateChildrenRows = function (items, column) {
    var rows = [];
    var columns = null;
    var leftSpans;
    items.forEach(function (node, index) {
        // let itemNode = node;
        if (!columns) {
            leftSpans = column;
            columns = [];
            rows.push(columns);
        }
        var _a = node.props.span, span = _a === void 0 ? 1 : _a;
        if (span >= column) {
            span = column;
        }
        if (index === items.length - 1) {
            span = leftSpans;
        }
        if (span <= leftSpans) {
            leftSpans -= span;
        }
        else {
            // 超出结界，换行重构
            var cells = columns.map(function (item) { return item.props.span; });
            var diffSpan = column - _.sum(cells);
            var lastNode = columns.pop();
            columns.push(React.cloneElement(lastNode, { span: lastNode.props.span + diffSpan }));
            leftSpans = column - span;
            columns = [];
            rows.push(columns);
        }
        columns.push(React.cloneElement(node, { span: span }));
        if (leftSpans <= 0) {
            columns = null;
        }
    });
    return rows;
};
var Col = function (props) {
    if (props.isLabel) {
        return React.createElement("th", { className: "ant-descriptions-item-label" }, props.children);
    }
    var colSpan = 1;
    if (props.breakLebel) {
        colSpan += 1;
    }
    if (props.span && props.span > 1) {
        colSpan += ((props.span - 1) * 2);
    }
    return React.createElement("td", { className: "ant-descriptions-item-content ant-descriptions-item-spaned" + colSpan, colSpan: colSpan }, props.children);
};
var renderRow = function (row, cols) {
    var columns = [];
    row.map(function (col) {
        var breakLebel = !_.has(col.props, 'label') || col.props.breakLebel;
        if (!breakLebel) {
            columns.push(React.createElement(Col, { isLabel: true, breakLebel: breakLebel, span: col.props.span, cols: cols }, col.props.label));
        }
        columns.push(React.createElement(Col, { isLabel: false, breakLebel: breakLebel, span: col.props.span, cols: cols }, col.props.children));
    });
    return columns;
};
