"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UFormModal = void 0;
var React = require("react");
var _ = require("lodash");
var antd_1 = require("antd");
var UForm_1 = require("./UForm");
var _Util_1 = require("./_Util");
var PageUtil_1 = require("../../utils/PageUtil");
var clearPid = null;
/**
 * 新版本表单弹框，支持各种类型的表单元素填写，当提交时，
 * 会调用 onOk 方法将编辑的对象信息以参数传递回去。
*/
var UFormModal = /** @class */ (function (_super) {
    __extends(UFormModal, _super);
    function UFormModal() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.submiting = false;
        _this.state = {
            Form: null,
        };
        _this.form = null;
        return _this;
    }
    UFormModal.prototype._isReShow = function (old) {
        if (old.visible === false && this.props.visible === true) {
            return true;
        }
        return false;
    };
    UFormModal.prototype._isShutDown = function (old) {
        if (old.visible === true && this.props.visible === false) {
            return true;
        }
        return false;
    };
    UFormModal.prototype.componentDidMount = function () {
        window.clearTimeout(clearPid);
        this.submiting = false;
        this.setState({ Form: UForm_1.UForm.create() });
    };
    UFormModal.prototype.componentDidUpdate = function (old) {
        var _this = this;
        if (this._isReShow(old)) {
            window.clearTimeout(clearPid);
            this.submiting = false;
            this.setState({ Form: UForm_1.UForm.create() });
        }
        else if (this._isShutDown(old)) {
            clearPid = window.setTimeout(function () { return _this.setState({ Form: null }); }, 500);
        }
    };
    UFormModal.prototype.clean = function (values) {
        _.keys(values).map(function (key) {
            if (key.indexOf(',') > 0 || values[key] === undefined) {
                _.unset(values, key);
            }
        });
        return values;
    };
    UFormModal.prototype.submit = function (fn) {
        var _this = this;
        var form = this.form.getForm();
        form.validateFields(function (err, values) {
            if (err) {
                fn(err, values);
                return;
            }
            fn(err, _this.clean(_.assign({}, _this.props.default, _this.props.data, values)));
        });
    };
    UFormModal.prototype.onSubmit = function () {
        var _this = this;
        if (this.submiting) {
            return;
        }
        var form = this.form.getForm();
        form.validateFields(function (err, values) {
            if (err) {
                _this.submiting = false;
                return;
            }
            _this.submiting = true;
            _this.props.onOk(_this.clean(_.assign({}, _this.props.default, _this.props.data, values)));
            _this.submiting = false;
        });
    };
    UFormModal.prototype.renderFooter = function () {
        var _this = this;
        var btns = (_.has(this.props, 'buttons') && _.isArray(this.props.buttons)) ? this.props.buttons.filter(function (item) {
            if (_.has(item, 'roleCode') && item.roleCode) {
                if (!PageUtil_1.default.hasRole(item.roleCode)) {
                    return false;
                }
            }
            return true;
        }) : [];
        if (btns.length == 0) {
            return React.createElement(React.Fragment, null,
                React.createElement(antd_1.Button, { type: "primary", onClick: function () { return _this.onSubmit(); } }, "\u786E\u5B9A"),
                React.createElement(antd_1.Button, { onClick: function (evt) { return _this.props.onCancel(evt); } }, "\u53D6\u6D88"));
        }
        return btns.map(function (btn) {
            var onClick = function (evt) {
                evt.preventDefault();
                evt.stopPropagation();
            };
            switch (btn.action) {
                case 'button':
                    onClick = function (evt) {
                        evt.preventDefault();
                        evt.stopPropagation();
                        if (btn.onClick) {
                            btn.onClick(_this.form.getFieldsValue());
                        }
                    };
                    break;
                case 'reset':
                    onClick = function (evt) {
                        evt.preventDefault();
                        evt.stopPropagation();
                        _this.form.resetFields();
                        if (btn.onClick) {
                            btn.onClick(_this.form.getFieldsValue());
                        }
                    };
                    break;
                default:
                    onClick = function (evt) {
                        evt.preventDefault();
                        evt.stopPropagation();
                        _this.form.validateFields(function (err, values) {
                            if (err) {
                                return;
                            }
                            if (btn.onClick) {
                                btn.onClick(values);
                                return;
                            }
                            console.error('必须设置onClick参数');
                        });
                    };
                    break;
            }
            if (btn.confirm) {
                return React.createElement(antd_1.Popconfirm, { title: btn.confirm, onConfirm: function (evt) { return onClick(evt); } },
                    React.createElement(antd_1.Button, __assign({}, btn, { onClick: undefined }), btn.text));
            }
            return React.createElement(antd_1.Button, __assign({}, btn, { onClick: function (evt) { return onClick(evt); } }), btn.text);
        });
    };
    UFormModal.prototype.render = function () {
        var _this = this;
        if (this.state.Form == null) {
            return [];
        }
        var data = _.assign({}, this.props.default, this.props.data);
        _.keys(data).map(function (key) {
            if (data[key] === null) {
                data[key] = '';
            }
        });
        var param = {};
        if (window.VAP_GLOBAL.UFORM.maskClosable == false) {
            param.maskClosable = false;
        }
        var layout = (0, _Util_1.getFormLayout)(this.props);
        param.width = layout.width;
        var clazz = ['uform-modal'];
        if (this.props.className) {
            clazz.push(this.props.className);
        }
        return React.createElement(antd_1.Modal, __assign({ footer: this.renderFooter() }, param, this.props, { onOk: function () { return _this.onSubmit(); }, className: clazz.join(' ') }),
            this.props.tip ? React.createElement("div", { style: { marginBottom: 6 } }, this.props.tip) : [],
            React.createElement(this.state.Form, __assign({}, this.props, { className: this.props.formClassName ? this.props.formClassName : null, buttons: null, ref: function (form) { return _this.form = form; } })));
    };
    return UFormModal;
}(React.PureComponent));
exports.UFormModal = UFormModal;
