"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UInfo = void 0;
var React = require("react");
var _ = require("lodash");
var UDescriptions_1 = require("../UDescriptions");
var _FormLayout_1 = require("./_FormLayout");
var _Util_1 = require("./_Util");
var UInfo = /** @class */ (function (_super) {
    __extends(UInfo, _super);
    function UInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.isInfo = true;
        return _this;
    }
    UInfo.prototype.componentDidMount = function () {
        var _this = this;
        var state = _super.prototype.componentDidMount.call(this);
        var values = __assign({}, this.props.data);
        if (state.isGroup) {
            this.props.fields.map(function (group) { return group.fields.map(function (field) {
                if (field.link == null || field.link.length == 0) {
                    return;
                }
                var val = values[field.field];
                if (val == null || val == '') {
                    return;
                }
                field.link.map(function (_a) {
                    var field = _a.field, call = _a.call;
                    var result = call(val, values);
                    if (_.isPlainObject(result) && _.has(result, 'show')) {
                        var show = result.show;
                        if (show && _this.hiddFields.has(field)) {
                            _this.hiddFields.delete(field);
                        }
                        else if (!show && !_this.hiddFields.has(field)) {
                            _this.hiddFields.add(field);
                        }
                    }
                });
            }); });
        }
        else {
            this.props.fields.map(function (field) {
                if (field.link == null || field.link.length == 0) {
                    return;
                }
                var val = values[field.field];
                if (val == null || val == '') {
                    return;
                }
                field.link.map(function (_a) {
                    var field = _a.field, call = _a.call;
                    var result = call(val, values);
                    if (_.isPlainObject(result) && _.has(result, 'show')) {
                        var show = result.show;
                        if (show && _this.hiddFields.has(field)) {
                            _this.hiddFields.delete(field);
                        }
                        else if (!show && !_this.hiddFields.has(field)) {
                            _this.hiddFields.add(field);
                        }
                    }
                });
            });
        }
        return state;
    };
    UInfo.prototype.shouldComponentUpdate = function (old) {
        //@ts-ignore
        if (_.has(this.props, 'visible') && this.props.visible === false) {
            return false;
        }
        return true;
    };
    UInfo.prototype.renderValue = function (component, field, data) {
        if (field.render) {
            return field.render(data[field.field], data);
        }
        if (component.show) {
            return component.show(data[field.field], field, data);
        }
        if (_.has(data, field.field)) {
            if (!_.has(field, 'options')) {
                return data[field.field];
            }
            var find = _.find(field.options, { value: data[field.field] });
            return find ? find.name : data[field.field];
        }
        var idx = field.field.indexOf(',');
        if (idx > 0) {
            var nameField = field.field.substr(idx + 1).trim();
            if (_.has(data, nameField)) {
                return data[nameField];
            }
        }
        return '';
    };
    UInfo.prototype.renderForm = function (fields, title) {
        var _this = this;
        if (title === void 0) { title = null; }
        var _a = this.state, cols = _a.cols, MAX_LEN = _a.MAX_LEN;
        var data = this.props.data;
        return React.createElement(UDescriptions_1.UDescriptions, { title: title, lebelWidth: MAX_LEN.COUNT, column: cols, className: this.props.className }, fields.map(function (field) {
            //@ts-ignore
            if (field == null || field === false || _this.hiddFields.has(field.field)) {
                return [];
            }
            var component = (0, _Util_1.getInputComponent)(field.type);
            if (component.breakDes && component.show != null && _.isFunction(component.show)) {
                return component.show(data[field.field], field, data);
            }
            if (component.breakTitle) {
                return React.createElement(UDescriptions_1.UDescriptions.Item, { breakLebel: true, span: cols }, _this.renderValue(component, field, data));
            }
            if ((field.span && field.span >= cols) || component.breakCol) {
                return React.createElement(UDescriptions_1.UDescriptions.Item, { span: cols, label: field.title }, _this.renderValue(component, field, data));
            }
            return React.createElement(UDescriptions_1.UDescriptions.Item, { span: field.span || 1, label: field.title }, _this.renderValue(component, field, data));
        }));
    };
    UInfo.prototype.renderGroup = function (group) {
        var _this = this;
        return group.map(function (item) { return _this.renderForm(item.fields, item.title); });
    };
    UInfo.prototype.render = function () {
        if (this.state.loading) {
            return [];
        }
        var fields = this.props.fields;
        var isGroup = this.state.isGroup;
        if (isGroup) {
            return React.createElement("div", { className: "uinfo uinfo-group" }, this.renderGroup(fields));
        }
        return React.createElement("div", { className: "uinfo" }, this.renderForm(fields));
    };
    return UInfo;
}(_FormLayout_1._BaseUForm));
exports.UInfo = UInfo;
