"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.UModal = void 0;
var React = require("react");
var _ = require("lodash");
var UFormModal_1 = require("./UFormModal");
var UInfoModal_1 = require("./UInfoModal");
/**
 * 新版本表单弹框，支持各种类型的表单元素填写，当提交时，
 * 会调用 onOk 方法将编辑的对象信息以参数传递回去。
*/
var UModal = /** @class */ (function (_super) {
    __extends(UModal, _super);
    function UModal() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            Component: null
        };
        return _this;
    }
    // static buildParam = (show: boolean, isEdit: boolean, editObject: any,): UModalProps => {
    //     return {
    //         visible: false,
    //     } as UModalProps;
    // }
    UModal.prototype._isReShow = function (old) {
        if (old.visible === false && this.props.visible === true) {
            return true;
        }
        return false;
    };
    UModal.prototype._isShutDown = function (old) {
        if (old.visible === true && this.props.visible === false) {
            return true;
        }
        return false;
    };
    UModal.prototype.componentDidUpdate = function (old) {
        if (this._isReShow(old)) {
            this.setState({ Component: React.createElement(this.getModal(), this.props) });
        }
        else if (this._isShutDown(old)) {
            this.setState({ Component: React.cloneElement(this.state.Component, { visible: false }) });
        }
    };
    UModal.prototype.getModal = function () {
        // 指定模式时，以指定的模式为准
        if (_.has(this.props, 'mode')) {
            if (this.props.mode == 'INFO') {
                return UInfoModal_1.UInfoModal;
            }
            return UFormModal_1.UFormModal;
        }
        if (this.props.isEdit) {
            return UFormModal_1.UFormModal;
        }
        // 如果不存在 data 则 只可能是 表单 模式(ADD)
        if (!_.has(this.props, 'data') || this.props.data == null) {
            return UFormModal_1.UFormModal;
        }
        return UInfoModal_1.UInfoModal;
    };
    UModal.prototype.render = function () {
        return this.state.Component;
    };
    return UModal;
}(React.PureComponent));
exports.UModal = UModal;
