"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports._BaseUForm = void 0;
var React = require("react");
var _ = require("lodash");
var _Util_1 = require("./_Util");
var COLMAX = [12, 12, 8, 9];
var FONT_SIZE = 14;
var _BaseUForm = /** @class */ (function (_super) {
    __extends(_BaseUForm, _super);
    function _BaseUForm() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.disableFields = new Set();
        _this.hiddFields = new Set();
        _this.state = {
            loading: true,
            isGroup: false,
            width: 880,
            cols: 2,
            COLSPAN: 12,
            LABELSPAN: 6,
            INPUTSPAN: 16,
            MAX_LEN: { COUNT: 0 },
        };
        _this.isInfo = false;
        _this.isEdit = false;
        return _this;
    }
    // 遍历字段，计算表单属性
    _BaseUForm.prototype._LOOP = function (fs, MAX_LEN) {
        var _this = this;
        fs.map(function (field) {
            //@ts-ignore
            if (field == null || field === false) {
                return;
            }
            var show = true;
            if (_.has(field, 'show')) {
                if (field.show === false || field.show === true) {
                    show = field.show;
                }
                else if (field.show) {
                    switch (field.show) {
                        case 'A':
                            show = !_this.isInfo && !_this.isEdit;
                            break;
                        case 'AE':
                            show = !_this.isInfo;
                            break;
                        case 'I':
                            show = _this.isInfo;
                            break;
                        case 'IE':
                            show = _this.isInfo || _this.isEdit;
                            break;
                        case 'IA':
                            show = _this.isInfo || !_this.isEdit;
                            break;
                        case 'E':
                            show = _this.isEdit && !_this.isInfo;
                            break;
                        case 'IAE':
                            show = true;
                            break;
                    }
                }
            }
            if (!show) {
                _this.hiddFields.add(field.field);
                return;
            }
            if (MAX_LEN.COUNT < field.title.length) {
                if (field.type != 'json-array') {
                    MAX_LEN.COUNT = field.title.length;
                }
            }
            var disabled = false;
            if (!_this.isInfo && _.has(field, 'disabled')) {
                if (field.disabled === false || field.disabled === true) {
                    disabled = field.disabled;
                }
                else if (field.disabled) {
                    switch (field.disabled) {
                        case 'A':
                        case 'IE':
                            disabled = !_this.isEdit;
                            break;
                        case 'IE':
                        case 'E':
                            disabled = _this.isEdit;
                            break;
                        case 'AE':
                        case 'IAE':
                            disabled = true;
                            break;
                    }
                }
            }
            if (disabled) {
                _this.disableFields.add(field.field);
            }
        });
    };
    _BaseUForm.prototype.componentDidMount = function () {
        var _this = this;
        var fields = this.props.fields;
        if (fields == null || fields.length == 0) {
            throw new Error('Must Have Fields');
        }
        var _a = (0, _Util_1.getFormLayout)(this.props), isGroup = _a.isGroup, width = _a.width, cols = _a.cols;
        var COLSPAN = 24 / cols;
        var MAX_LABEL_SPAN = COLMAX[cols];
        var MAX_LEN = { COUNT: 0 };
        if (!this.isInfo) {
            // @ts-ignore
            this.isEdit = _.has(this.props, 'isEdit') ? (this.props.isEdit) : (_.has(this.props, 'data') && this.props.data != null && _.keys(this.props.data).length > 0);
        }
        this.disableFields.clear();
        this.hiddFields.clear();
        if (isGroup) {
            fields.map(function (group) { return _this._LOOP(group.fields, MAX_LEN); });
        }
        else {
            this._LOOP(fields, MAX_LEN);
        }
        var fieldWidth = width / cols;
        var percent = (MAX_LEN.COUNT * FONT_SIZE + 20) / fieldWidth;
        var LABELSPAN = Math.ceil(percent * 24);
        if (MAX_LABEL_SPAN > MAX_LABEL_SPAN) {
            LABELSPAN = MAX_LABEL_SPAN;
        }
        var fix = LABELSPAN % cols;
        if (fix != 0) {
            LABELSPAN += fix;
        }
        if (cols == 1) {
            if (LABELSPAN < 6) {
                LABELSPAN = 6;
            }
        }
        var INPUTSPAN = 24 - LABELSPAN;
        if (cols == 1 && INPUTSPAN > 14) {
            INPUTSPAN = INPUTSPAN - 1;
        }
        // let state = { width, cols, isGroup, COLSPAN, LABELSPAN, INPUTSPAN, loading: false };
        var state = { width: width, cols: cols, MAX_LEN: MAX_LEN, isGroup: isGroup, COLSPAN: COLSPAN, LABELSPAN: LABELSPAN, INPUTSPAN: INPUTSPAN, loading: false };
        this.setState(state);
        return state;
    };
    return _BaseUForm;
}(React.PureComponent));
exports._BaseUForm = _BaseUForm;
