import * as React from 'react';
import { ShowTableStaticProps } from '../../_common/ApiTableModal/interface';
import { UFormInputProps } from './interface';
/**
 * 常用的扩展抽像：
 * 通常使用 UFormInput 来扩展单个输入
 * 使用 UFormMultiInput 用来扩展组件输入,通常需要实现 onChange / render
 * 使用 UFormTableButton 用来扩展常用的API弹框选择器
*/
export declare abstract class UFormInput extends React.PureComponent<UFormInputProps> {
    getOptions(): import("./interface").Option[];
    getSelectTip(): string;
    onChange(value: any): void;
    abstract render(): React.ReactNode;
}
export declare abstract class UFormMultiInput extends UFormInput {
    state: {
        loaded: boolean;
    };
    protected dataFields: any[];
    componentDidMount(): void;
}
export declare abstract class UFormTableButton extends UFormMultiInput {
    width: number;
    abstract table: ShowTableStaticProps;
    abstract itemFields: string[];
    state: {
        loaded: boolean;
        showSelector: boolean;
    };
    getSelectTip(): any;
    onChange(item: any, extra?: any): void;
    render(): any[] | JSX.Element;
}
