"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UFormTableButton = exports.UFormMultiInput = exports.UFormInput = void 0;
var React = require("react");
var _ = require("lodash");
var antd_1 = require("antd");
var ApiTableModal_1 = require("../../_common/ApiTableModal");
/**
 * 常用的扩展抽像：
 * 通常使用 UFormInput 来扩展单个输入
 * 使用 UFormMultiInput 用来扩展组件输入,通常需要实现 onChange / render
 * 使用 UFormTableButton 用来扩展常用的API弹框选择器
*/
var UFormInput = /** @class */ (function (_super) {
    __extends(UFormInput, _super);
    function UFormInput() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UFormInput.prototype.getOptions = function () {
        if (_.has(this.props, 'options') && _.isArray(this.props.options)) {
            return this.props.options;
        }
        if (_.isArray(this.props.field.options)) {
            return this.props.field.options;
        }
        return [];
    };
    UFormInput.prototype.getSelectTip = function () {
        if (this.props.field.placeholder) {
            return this.props.field.placeholder;
        }
        return '请选择' + this.props.field.title;
    };
    UFormInput.prototype.onChange = function (value) {
        var _a;
        this.props.onChange((_a = {}, _a[this.props.field.field] = value, _a));
    };
    return UFormInput;
}(React.PureComponent));
exports.UFormInput = UFormInput;
var UFormMultiInput = /** @class */ (function (_super) {
    __extends(UFormMultiInput, _super);
    function UFormMultiInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            loaded: false,
        };
        _this.dataFields = [];
        return _this;
    }
    UFormMultiInput.prototype.componentDidMount = function () {
        var field = this.props.field;
        this.dataFields = field.field.split(',');
        this.setState({ loaded: true, });
    };
    return UFormMultiInput;
}(UFormInput));
exports.UFormMultiInput = UFormMultiInput;
var UFormTableButton = /** @class */ (function (_super) {
    __extends(UFormTableButton, _super);
    function UFormTableButton() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.width = 1024;
        _this.state = {
            loaded: false,
            showSelector: false,
        };
        return _this;
    }
    UFormTableButton.prototype.getSelectTip = function () {
        var data = this.props.form.getFieldsValue() || {};
        if (data[this.dataFields[0]] && data[this.dataFields[this.dataFields.length - 1]]) {
            return data[this.dataFields[this.dataFields.length - 1]];
        }
        if (this.props.field.placeholder) {
            return this.props.field.placeholder;
        }
        return '请选择' + this.props.field.title;
    };
    UFormTableButton.prototype.onChange = function (item, extra) {
        var _a;
        var _this = this;
        this.setState({ showSelector: false });
        var values = (_a = {}, _a[this.props.field.field] = true, _a);
        this.dataFields.map(function (key, i) {
            if (i < _this.itemFields.length) {
                values[key] = _.has(item, [_this.itemFields[i]]) ? item[_this.itemFields[i]] : null;
            }
            else {
                values[key] = null;
            }
        });
        this.props.onChange(values, extra);
    };
    UFormTableButton.prototype.render = function () {
        var _this = this;
        if (!this.state.loaded) {
            return [];
        }
        var disabled = this.props.disabled;
        var params = { disabled: disabled };
        return React.createElement(React.Fragment, null,
            React.createElement(antd_1.Button, __assign({}, params, { style: { width: '100%', textAlign: 'left' }, icon: "select", onClick: function () { return _this.setState({ showSelector: true }); } }), this.getSelectTip()),
            React.createElement(ApiTableModal_1.default, __assign({ modalTitle: '请选择' + this.props.field.title, width: this.width }, this.table, { visible: this.state.showSelector, onCancel: function () { return _this.setState({ showSelector: false }); } })));
    };
    return UFormTableButton;
}(UFormMultiInput));
exports.UFormTableButton = UFormTableButton;
