/// <reference types="react" />
import { DTreeOpts } from './interface';
import { ActionTree } from './ActionTree';
/**
 * 动态树
 * CRUD        ：   支持
 * 动态加载     ：   支持
 * 搜索         ：   仅支持已加载的节点
 * 数据         ：
 *          1. 必传 childApi
 *          2. 可选 rootCode，默认为 0
 *          3. 可选 rootApi    传 rootApi 根节点数据将调用 rootApi获取，不传 rootApi时，将由 childApi + rootCode 获取
 *
*/
export declare class DTree extends ActionTree<DTreeOpts> {
    componentDidMount(): Promise<void>;
    clearCache(parentId: string): void;
    getChildren(parentId: any): Promise<any[]>;
    onLoadData(treeNode: any): Promise<void>;
    getNodeParam(node: any, keyword: any, pos: any, len: any, position: any): import("antd/lib/tree").AntTreeNodeProps;
    render(): any[] | JSX.Element;
}
