"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DTree = void 0;
var React = require("react");
var _ = require("lodash");
var antd_1 = require("antd");
var ActionTree_1 = require("./ActionTree");
var utils_1 = require("../../utils");
/**
 * 动态树
 * CRUD        ：   支持
 * 动态加载     ：   支持
 * 搜索         ：   仅支持已加载的节点
 * 数据         ：
 *          1. 必传 childApi
 *          2. 可选 rootCode，默认为 0
 *          3. 可选 rootApi    传 rootApi 根节点数据将调用 rootApi获取，不传 rootApi时，将由 childApi + rootCode 获取
 *
*/
var DTree = /** @class */ (function (_super) {
    __extends(DTree, _super);
    function DTree() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DTree.prototype.componentDidMount = function () {
        return __awaiter(this, void 0, void 0, function () {
            var param, mustSelect, tree, rootResp, selectedKeys, obj, _a;
            var _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        param = this.getFace();
                        mustSelect = this.props.mustSelect;
                        tree = [];
                        if (!this.props.rootApi) return [3 /*break*/, 2];
                        if (!this.actions.notCache) {
                            utils_1.Ajax.SESION(this.props.rootApi);
                        }
                        return [4 /*yield*/, utils_1.Ajax.GET(this.props.rootApi)];
                    case 1:
                        rootResp = _c.sent();
                        if (rootResp.code == '0') {
                            if (_.isArray(rootResp.data)) {
                                tree = rootResp.data;
                            }
                            else {
                                tree = [rootResp.data];
                            }
                        }
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, this.getChildren(this.fields.rootCode)];
                    case 3:
                        tree = _c.sent();
                        _c.label = 4;
                    case 4:
                        selectedKeys = [];
                        if (this.props.defaultValue) {
                            obj = _.find(tree, (_b = {}, _b[this.props.keyField] = this.props.defaultValue, _b));
                            if (obj) {
                                selectedKeys = [obj[this.props.keyField]];
                                this.props.onSelect(obj[this.props.keyField], obj);
                            }
                            else {
                                if (param.selectable && mustSelect && tree.length > 0) {
                                    selectedKeys = ["".concat(tree[0][this.props.keyField])];
                                    this.props.onSelect(tree[0][this.props.keyField], tree[0], null, '0');
                                }
                            }
                        }
                        else {
                            if (param.selectable && mustSelect && tree.length > 0) {
                                selectedKeys = ["".concat(tree[0][this.props.keyField])];
                                this.props.onSelect(tree[0][this.props.keyField], tree[0], null, '0');
                            }
                        }
                        if (!(tree.length == 1 && !param.defaultExpandAll)) return [3 /*break*/, 6];
                        if (param.defaultExpandedKeys && _.isArray(param.defaultExpandedKeys)) {
                        }
                        else {
                            param.defaultExpandedKeys = [tree[0][this.fields.keyField]];
                        }
                        if (this.props.canAddRoot == undefined || this.props.canAddRoot == false) {
                            param.className = param.className + ' utree-root';
                        }
                        _a = tree[0];
                        return [4 /*yield*/, this.getChildren(tree[0][this.fields.keyField])];
                    case 5:
                        _a.children = _c.sent();
                        _c.label = 6;
                    case 6:
                        this.setState({ loading: false, tree: tree, face: param, selectedKeys: selectedKeys });
                        return [2 /*return*/];
                }
            });
        });
    };
    DTree.prototype.clearCache = function (parentId) {
        if (parentId == this.fields.rootCode) {
            if (this.props.rootApi) {
                utils_1.Ajax.CLEAR(this.props.rootApi);
                return;
            }
        }
        if (_.isString(this.props.childApi)) {
            var api = this.props.childApi + parentId;
            utils_1.Ajax.CLEAR(api);
        }
    };
    DTree.prototype.getChildren = function (parentId) {
        return __awaiter(this, void 0, void 0, function () {
            var arr, api, rootResp;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        arr = [];
                        if (!_.isString(this.props.childApi)) return [3 /*break*/, 2];
                        api = this.props.childApi + parentId;
                        if (!this.actions.notCache) {
                            utils_1.Ajax.SESION(api);
                        }
                        return [4 /*yield*/, utils_1.Ajax.GET(api)];
                    case 1:
                        rootResp = _a.sent();
                        if (rootResp.code == '0') {
                            if (_.isArray(rootResp.data)) {
                                arr = rootResp.data;
                            }
                            else {
                                arr = [rootResp.data];
                            }
                        }
                        return [3 /*break*/, 4];
                    case 2:
                        if (!_.isFunction(this.props.childApi)) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.props.childApi(parentId)];
                    case 3:
                        arr = _a.sent();
                        _a.label = 4;
                    case 4:
                        if (this.fields.sortField) {
                            return [2 /*return*/, _.orderBy(arr, this.props.sortField, 'asc').map(function (item) { return (__assign(__assign({}, item), { children: [] })); })];
                        }
                        return [2 /*return*/, arr];
                }
            });
        });
    };
    DTree.prototype.onLoadData = function (treeNode) {
        return __awaiter(this, void 0, void 0, function () {
            var eventKey, children;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        eventKey = treeNode.props.eventKey;
                        return [4 /*yield*/, this.getChildren(eventKey)];
                    case 1:
                        children = _a.sent();
                        if (this.fields.sortField) {
                            treeNode.props.dataRef.children = _.orderBy(children, this.fields.sortField, 'asc');
                        }
                        else {
                            treeNode.props.dataRef.children = children;
                        }
                        this.setState({ tree: __spreadArray([], __read(this.state.tree), false), });
                        return [2 /*return*/];
                }
            });
        });
    };
    DTree.prototype.getNodeParam = function (node, keyword, pos, len, position) {
        var param = _super.prototype.getNodeParam.call(this, node, keyword, pos, len, position);
        var checkField = this.props.checkField;
        if (checkField) {
            if (_.has(node, checkField) && node[checkField] == false) {
                param.isLeaf = true;
            }
        }
        return param;
    };
    DTree.prototype.render = function () {
        var _this = this;
        var _a = this.state, loading = _a.loading, face = _a.face, selectedKeys = _a.selectedKeys, tree = _a.tree;
        if (loading) {
            return [];
        }
        return React.createElement(React.Fragment, null,
            React.createElement(antd_1.Tree, __assign({}, face, { selectedKeys: selectedKeys, loadData: function (treeNode) { return _this.onLoadData(treeNode); } }), this.renderRoot(tree)),
            this.renderForm());
    };
    return DTree;
}(ActionTree_1.ActionTree));
exports.DTree = DTree;
