"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FTree = void 0;
var React = require("react");
var _ = require("lodash");
var antd_1 = require("antd");
var ActionTree_1 = require("./ActionTree");
var utils_1 = require("../../utils");
var _Utils_1 = require("./_Utils");
/**
 * 静态树
 * CRUD        ：  支持
 * 动态加载     ：  支持
 * 搜索         ：  支持
 * 数据         ： 通过 GET fetchApi 或 GET api  获取，响应必须为 VData<List<Object>> 结构
*/
var FTree = /** @class */ (function (_super) {
    __extends(FTree, _super);
    function FTree() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FTree.prototype.componentDidMount = function () {
        return __awaiter(this, void 0, void 0, function () {
            var fetchApi, rootResp, tree, param, mustSelect, selectedKeys;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        fetchApi = this.props.fetchApi || this.props.api;
                        if (!this.actions.notCache) {
                            utils_1.Ajax.SESION(fetchApi);
                        }
                        return [4 /*yield*/, utils_1.Ajax.GET(fetchApi)];
                    case 1:
                        rootResp = _a.sent();
                        tree = (0, _Utils_1.buildFlatTree)(this.fields, rootResp.data);
                        param = this.getFace();
                        mustSelect = this.props.mustSelect;
                        selectedKeys = [];
                        if (param.selectable && mustSelect && tree.length > 0) {
                            selectedKeys = ["".concat(tree[0][this.props.keyField])];
                            this.props.onSelect(tree[0][this.props.keyField], tree[0], null, '0');
                        }
                        if (tree.length == 1 && !param.defaultExpandAll) {
                            if (param.defaultExpandedKeys && _.isArray(param.defaultExpandedKeys)) {
                            }
                            else {
                                param.defaultExpandedKeys = [tree[0][this.fields.keyField]];
                            }
                            if (this.props.canAddRoot == undefined || this.props.canAddRoot == false) {
                                param.className = param.className + ' utree-root';
                            }
                        }
                        this.setState({ loading: false, tree: tree, face: param, selectedKeys: selectedKeys });
                        return [2 /*return*/];
                }
            });
        });
    };
    FTree.prototype.clearCache = function (parentId) {
        utils_1.Ajax.CLEAR(this.props.fetchApi || this.props.api);
    };
    FTree.prototype.getChildren = function (parentId) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, []];
            });
        });
    };
    FTree.prototype.render = function () {
        var _a = this.state, loading = _a.loading, face = _a.face, selectedKeys = _a.selectedKeys, tree = _a.tree;
        if (loading) {
            return [];
        }
        return React.createElement(React.Fragment, null,
            React.createElement(antd_1.Tree, __assign({}, face, { selectedKeys: selectedKeys }), this.renderRoot(tree)),
            this.renderForm());
    };
    return FTree;
}(ActionTree_1.ActionTree));
exports.FTree = FTree;
