"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.STree = void 0;
var React = require("react");
var _ = require("lodash");
var antd_1 = require("antd");
var _Utils_1 = require("./_Utils");
var BaseTree_1 = require("./BaseTree");
/**
 * 静态树
 * CRUD        ：  不支持
 * 动态加载     ：  不支持
 * 搜索         ：  支持
 * 数据         ： 需要组装好后传入
 *
*/
var STree = /** @class */ (function (_super) {
    __extends(STree, _super);
    function STree() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    STree.prototype.componentDidUpdate = function (prevProps) {
        _super.prototype.componentDidUpdate.call(this, prevProps);
        if (prevProps.treeData != this.props.treeData) {
            var tree = [];
            if (this.props.isFlat) {
                tree = (0, _Utils_1.buildFlatTree)(this.fields, this.props.treeData);
            }
            else {
                tree = this.props.treeData;
            }
            this.setState({ loading: false, tree: tree, selectedKeys: [] });
        }
    };
    STree.prototype.componentDidMount = function () {
        var param = this.getFace();
        var _a = this.props, isFlat = _a.isFlat, mustSelect = _a.mustSelect;
        var tree = [];
        if (isFlat) {
            tree = (0, _Utils_1.buildFlatTree)(this.fields, this.props.treeData);
        }
        else {
            tree = this.props.treeData;
        }
        var selectedKeys = [];
        if (param.selectable && mustSelect && tree.length > 0) {
            selectedKeys = [tree[0][this.fields.keyField]];
            this.props.onSelect(tree[0][this.fields.keyField], tree[0], null);
        }
        if (tree.length == 1 && !param.defaultExpandAll) {
            if (param.defaultExpandedKeys && _.isArray(param.defaultExpandedKeys)) {
            }
            else {
                param.defaultExpandedKeys = [tree[0][this.fields.keyField]];
            }
            param.className = param.className + ' utree-root';
        }
        this.setState({ loading: false, tree: tree, face: param, selectedKeys: selectedKeys });
    };
    STree.prototype.render = function () {
        if (this.state.loading) {
            return [];
        }
        var _a = this.state, face = _a.face, selectedKeys = _a.selectedKeys, tree = _a.tree;
        return React.createElement(antd_1.Tree, __assign({}, face, { selectedKeys: selectedKeys }), this.renderRoot(tree));
    };
    return STree;
}(BaseTree_1.BaseTree));
exports.STree = STree;
