"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildFlatTree = exports.INSER_POS = exports.STEP = void 0;
var _ = require("lodash");
// 步长，留多点间隙避免每次移动太多
exports.STEP = 16;
var INSER_POS;
(function (INSER_POS) {
    INSER_POS[INSER_POS["BEFORE"] = 0] = "BEFORE";
    INSER_POS[INSER_POS["AFTER"] = 1] = "AFTER";
    INSER_POS[INSER_POS["INNER"] = 2] = "INNER";
})(INSER_POS = exports.INSER_POS || (exports.INSER_POS = {}));
;
var buildTree = function (list, root, keyField, parentField, sortField) {
    var e_1, _a;
    if (sortField === void 0) { sortField = null; }
    var _loop_1 = function (sub) {
        var children = _.filter(list, function (child) { return child[parentField] == sub[keyField]; });
        if (children.length > 0) {
            if (sortField) {
                sub.children = _.orderBy(children, sortField, 'asc');
            }
            else {
                sub.children = children;
            }
            buildTree(list, sub.children, keyField, parentField, sortField);
        }
    };
    try {
        for (var root_1 = __values(root), root_1_1 = root_1.next(); !root_1_1.done; root_1_1 = root_1.next()) {
            var sub = root_1_1.value;
            _loop_1(sub);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (root_1_1 && !root_1_1.done && (_a = root_1.return)) _a.call(root_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
};
// 用扁平化方式构造一棵树
var buildFlatTree = function (props, data) {
    if (!_.has(props, 'parentField')) {
        return data;
    }
    var parentField = props.parentField, sortField = props.sortField, keyField = props.keyField;
    var root = data.filter(function (item) { return item[parentField] == (props.rootCode || '0'); });
    if (sortField) {
        root = _.orderBy(root, sortField, 'asc');
    }
    buildTree(data, root, keyField, parentField, sortField);
    return root;
};
exports.buildFlatTree = buildFlatTree;
