/**
 * 导入性质Button
*/
import * as React from 'react';
export interface UploadProps {
    /**
     * namespace, 默认为app-portal
    */
    namespace?: string;
    /**
     * 接收参数
    */
    accept?: string;
    /**
     * 上传按钮的图标，默认upload
    */
    icon?: string;
    /**
     * 上传按钮的方字，默认为导入
    */
    text?: string;
    /**
     * 最开始显示的文件名
    */
    initFile?: string;
    /**
     * 上传地址，默认为 /api-fileup/fileup/uploadFile
    */
    url?: string;
    /**
     * 上传完成后的回调
    */
    callback: Function;
    /**
     * 模板下载
     * 如果有此参数，则会自动生成一个下拉，提示数据模板下载
     * 可以只传一个下载地址
    */
    templateDownload?: string | {
        /**
         * 按钮图标，默认：Table
        */
        icon?: string;
        /**
         * 按钮文字, 默认：模板下载
        */
        text?: string;
        /**
         * 下载地址
        */
        url: string;
        /**
         * 下载的IFRAME,默认 _downloadFrame
        */
        fileName?: string;
    };
}
export default class extends React.PureComponent<UploadProps> {
    state: any;
    componentDidMount(): void;
    handleChange: (info: any) => void;
    renderUpload(): JSX.Element;
    renderTemplateDownload(): JSX.Element;
    render(): JSX.Element;
}
