"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * 导入图标性质Button
*/
var React = require("react");
var antd_1 = require("antd");
var Upload_1 = require("./Upload");
var UploadService_1 = require("./UploadService");
var _ = require("lodash");
var DEF_WIDTH = 144;
var DEF_HEIGHT = 81;
var DEFAULT_UPLOAD = '/api-common/file/upload';
var DEFAULT_SHOW = function (resp, url) {
    var e_1, _a;
    if (_.startsWith(url, '/api-common/')) {
        return '/api-common/file/show/' + resp.data.fileId;
    }
    var idx = _.lastIndexOf(url, '/');
    var prefix = url;
    if (idx > 0) {
        prefix = url.substr(0, idx + 1);
    }
    try {
        for (var _b = __values(['id', 'guid', 'fileId']), _c = _b.next(); !_c.done; _c = _b.next()) {
            var field = _c.value;
            if (_.has(resp.data, field)) {
                return prefix + 'download/' + resp.data[field];
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return '';
};
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            loading: false,
            process: 0,
            imgUrl: ''
        };
        _this.handleChange = function (info) {
            if (info.file.status === 'uploading') {
                _this.setState({ loading: true, process: Math.floor(info.file.percent) });
                return;
            }
            if (info.file.status === 'done') {
                var imgUrl = '';
                if (_this.props.getViewUrl) {
                    imgUrl = _this.props.getViewUrl(info.file.response);
                }
                else {
                    imgUrl = DEFAULT_SHOW(info.file.response, _this.props.url || DEFAULT_UPLOAD);
                }
                _this.setState({
                    loading: false,
                    process: 0,
                    imgUrl: imgUrl,
                });
                _this.props.callback(imgUrl);
            }
            if (info.file.status === 'error') {
                antd_1.message.error("\u6587\u4EF6 ".concat(info.file.name, "\u4E0A\u4F20\u5931\u8D25"));
                _this.setState({
                    loading: false,
                    process: 0
                });
            }
        };
        return _this;
    }
    default_1.prototype.render = function () {
        var _this = this;
        var url = this.state.imgUrl || this.props.def || "";
        var width = _.isNumber(this.props.width) ? this.props.width : DEF_WIDTH;
        var height = _.isNumber(this.props.height) ? this.props.height : DEF_HEIGHT;
        return React.createElement(antd_1.Row, { type: "flex", style: { height: height, whiteSpace: 'nowrap', width: '100%' } },
            React.createElement(antd_1.Col, { style: { width: width, height: height, marginRight: 6, textAlign: 'center', paddingTop: url ? 0 : 12, cursor: 'pointer', borderRadius: 4, border: url ? 'none' : '1px solid' } },
                React.createElement(Upload_1.Upload, { name: "file", withCredentials: true, listType: "picture", showUploadList: false, onChange: this.handleChange, action: this.props.url || DEFAULT_UPLOAD, accept: "image/*", 
                    // className={url ? '' : 'upload-icon-empty'}
                    data: {
                        namespace: this.props.namespace,
                        userId: this.state.userId,
                        userName: this.state.userName,
                    } }, url ? React.createElement("img", { src: url, style: { width: width - 2, height: height - 2 } }) :
                    React.createElement("div", null,
                        React.createElement(antd_1.Icon, { type: this.state.loading ? 'loading' : 'plus' }),
                        React.createElement("div", { className: "ant-upload-text" }, "\u4E0A\u4F20")))),
            React.createElement(antd_1.Col, { style: { height: height, flex: '1 1 auto', maxWidth: "calc(100% - ".concat(width + 10, "px)"), whiteSpace: 'nowrap', overflow: 'auto', } }, this.props.options.map(function (img) { return React.createElement("img", { style: { height: height * 0.66, width: width * 0.66, marginRight: 5, marginTop: height * 0.1, borderRadius: 6, cursor: 'pointer' }, src: img.value, title: img.name, onClick: function () {
                    var imgUrl = img.value;
                    _this.setState({ imgUrl: imgUrl });
                    _this.props.callback(imgUrl);
                } }); })));
    };
    return default_1;
}(UploadService_1.default));
exports.default = default_1;
