"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UploadModal = void 0;
var React = require("react");
var _ = require("lodash");
var VModal_1 = require("../rewrites/VModal");
var antd_1 = require("antd");
var Upload_1 = require("../Upload/Upload");
var DEFAULT = {
    uploading: false,
    importing: false,
    error: null,
    success: null,
};
/**
 * 标准导入数据弹框，用于统一系统内， 所有需要导入数据的交互。
*/
var UploadModal = /** @class */ (function (_super) {
    __extends(UploadModal, _super);
    function UploadModal() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = __assign(__assign({}, DEFAULT), { showProgress: false, percent: 0 });
        return _this;
    }
    UploadModal.prototype._isShutDown = function (old) {
        if (old.visible === true && this.props.visible === false) {
            return true;
        }
        return false;
    };
    UploadModal.prototype.componentDidUpdate = function (old) {
        var _this = this;
        if (this._isShutDown(old)) {
            window.setTimeout(function () { return _this.setState(__assign({}, DEFAULT)); }, 300);
        }
    };
    UploadModal.prototype.onUpChange = function (info) {
        return __awaiter(this, void 0, void 0, function () {
            var uploadResponse, success, error, uploadResult, resp, importResult;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (info.file.status === 'uploading') {
                            this.setState(__assign(__assign({}, DEFAULT), { percent: Math.floor(info.file.percent), uploading: true, showProgress: true }));
                            return [2 /*return*/];
                        }
                        if (info.file.status === 'error') {
                            this.setState(__assign(__assign({}, DEFAULT), { error: "\u6587\u4EF6".concat(info.file.name, "\u4E0A\u4F20\u5931\u8D25"), showProgress: false, percent: 0 }));
                            return [2 /*return*/];
                        }
                        if (info.file.status != 'done') {
                            return [2 /*return*/];
                        }
                        this.setState({ percent: 0, showProgress: false, writing: '上传成功' });
                        uploadResponse = info.file.response;
                        success = false;
                        error = null;
                        if (this.props.onUpload) {
                            uploadResult = this.props.onUpload(uploadResponse);
                            if (_.isBoolean(uploadResult)) {
                                success = uploadResult;
                                if (!success) {
                                    error = "\u6587\u4EF6".concat(info.file.name, "\u4E0A\u4F20\u5931\u8D25");
                                }
                            }
                            else {
                                success = uploadResult.ok;
                                error = uploadResult.message;
                            }
                        }
                        else {
                            success = info.file.response.code == '0';
                            if (!success) {
                                error = "\u6587\u4EF6".concat(info.file.name, "\u4E0A\u4F20\u5931\u8D25");
                            }
                        }
                        if (!success) {
                            this.setState(__assign(__assign({}, DEFAULT), { error: error }));
                            return [2 /*return*/];
                        }
                        this.setState(__assign(__assign({}, DEFAULT), { importing: true }));
                        resp = this.props.onResult(info.file.response);
                        importResult = null;
                        if (!(resp && typeof resp.then == 'function')) return [3 /*break*/, 2];
                        return [4 /*yield*/, resp];
                    case 1:
                        importResult = _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        importResult = resp;
                        _a.label = 3;
                    case 3:
                        if (_.isBoolean(importResult)) {
                            if (importResult) {
                                this.setState(__assign(__assign({}, DEFAULT), { success: '数据导入成功' }));
                            }
                            else {
                                this.setState(__assign(__assign({}, DEFAULT), { error: '数据导入失败 ' }));
                            }
                        }
                        else {
                            if (importResult.ok) {
                                this.setState(__assign(__assign({}, DEFAULT), { success: importResult.message }));
                            }
                            else {
                                this.setState(__assign(__assign({}, DEFAULT), { error: importResult.message }));
                            }
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    UploadModal.prototype.renderTip = function () {
        if (this.props.tip) {
            return this.props.tip;
        }
        return React.createElement(antd_1.Alert, { message: React.createElement("p", null,
                " \u8BF7\u6CE8\u610F\uFF1A\u5BFC\u5165\u7684Excel\u6570\u636E\u5B57\u6BB5\u987B\u4E0EExcel\u6A21\u7248\u4FDD\u6301\u4E00\u81F4\uFF0C\u5426\u5219\u65E0\u6CD5\u5BFC\u5165\u6570\u636E\u3002 ",
                React.createElement("br", null),
                " \u70B9\u51FB\u786E\u8BA4\u65F6\u5C06\u4EC5\u5BFC\u5165\u6B63\u5E38\u6570\u636E"), type: "info" });
    };
    UploadModal.prototype.renderMessage = function () {
        var _a = this.state, error = _a.error, success = _a.success;
        if (error) {
            return React.createElement(antd_1.Alert, { type: "error", message: error, style: { marginBottom: 12 } });
        }
        if (success) {
            return React.createElement(antd_1.Alert, { type: "success", message: success, style: { marginBottom: 12 } });
        }
    };
    UploadModal.prototype.renderUpload = function () {
        var _this = this;
        var _a = this.state, uploading = _a.uploading, importing = _a.importing, showProgress = _a.showProgress, percent = _a.percent;
        var action = this.props.api || '/api-common/file/upload';
        var accept = _.has(this.props, 'accept') ? this.props.accept : 'application/vnd.ms-excel,application/vnd.openxmlformats-officedocument.spreadsheetml.sheet';
        var data = this.props.data || { namespace: 'app-portal', userId: '', userName: '' };
        var name = this.props.name || 'file';
        return React.createElement(React.Fragment, null,
            React.createElement(Upload_1.Upload, { showUploadList: false, withCredentials: true, action: action, accept: accept, name: name, data: data, onChange: function (info) { return _this.onUpChange(info); } },
                React.createElement(antd_1.Button, { icon: "upload", type: "primary", loading: uploading || importing, className: showProgress ? ('pre-' + percent) : '' }, uploading ? '正在上传' : (importing ? '正在导入' : '上传文件'))),
            React.createElement(antd_1.Button, { style: { marginLeft: 12 }, onClick: function () { return _this.props.onCancel(null); } }, "\u53D6 \u6D88"));
    };
    UploadModal.prototype.renderFooter = function () {
        var _this = this;
        return React.createElement(antd_1.Button, { type: 'primary', onClick: function () { return _this.props.onOk ? _this.props.onOk(null) : _this.props.onCancel(null); } }, "\u786E \u5B9A");
    };
    UploadModal.prototype.render = function () {
        var success = this.state.success;
        return React.createElement(VModal_1.Modal, __assign({ width: 640, title: "\u5BFC\u5165\u6570\u636E" }, this.props, { className: "u-uploadmodal", footer: success ? this.renderFooter() : this.renderUpload() }),
            this.renderTip(),
            this.renderMessage());
    };
    return UploadModal;
}(React.PureComponent));
exports.UploadModal = UploadModal;
