import * as React from 'react';
import { ColumnProps } from 'antd/lib/table/interface';
interface EditColumnProps extends ColumnProps<any> {
    [propName: string]: any;
}
export interface EditTableProps {
    /**
     * 表格列
     */
    columns: EditColumnProps[];
    /**
     * 传入表格数据，vform里不需要传
     */
    dataSource?: any[];
    /**
     * 表格数据唯一key，用于删除
     */
    rowKey: string;
    /**
     * 表格操作 增、删、改是否禁用,vform里无需传
     */
    disabled?: boolean;
    /**
     * 表格数据变化时的回调, data: 传入的dataSource, param: 变化的那一行数据，分别是增、删、改，vform中会自动管理
     */
    onChange?: (data?: any, param?: {
        method: 'delete' | 'add' | 'patch';
        data: any;
    }) => any;
    /**
     * 由上级管理修改事件，取消内部事件
     */
    onRowClick?: (item?: any, i?: any, data?: any) => any;
    /**
     * 由上级管理新增事件，取消内部事件
     */
    onAddClick?: (data?: any) => any;
    /**
     * 由上级管理删除事件，取消内部事件
     */
    onDeleteClick?: (item?: any, i?: any, data?: any) => any;
    /**
     * 其他Table属性
     */
    [propName: string]: any;
}
export default class EditTable extends React.PureComponent<EditTableProps> {
    state: {
        data: any[];
        record: {};
        emptyRecord: {};
        errorMap: Map<any, any>;
    };
    componentDidMount(): void;
    componentDidUpdate(prevProps: any, prevState: any): void;
    getEmptyRecord: () => {};
    changeInput: (val: any, column: any, record: any) => void;
    render(): JSX.Element;
}
export {};
