"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var antd_1 = require("antd");
var Upload_1 = require("../Upload/Upload");
var Renders_1 = require("../../utils/Renders");
var _ = require("lodash");
var UploadService_1 = require("../Upload/UploadService");
var strRender = Renders_1.default.strRender(8, true, '', true);
//文件上传子组件
var FileUpload = /** @class */ (function (_super) {
    __extends(FileUpload, _super);
    function FileUpload() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            loading: false,
            upName: '',
            upUrl: _this.props.initUrl
        };
        _this.onUpChange = function (info) {
            if (info.file.status === 'uploading') {
                _this.setState({ loading: true });
            }
            else if (info.file.status === 'done' && info.file.response.code == '0') {
                var upUrl_1 = '';
                var upName = _.get(info, 'file.name');
                if (_this.props.afterUrl) {
                    upUrl_1 = _this.props.afterUrl + (_.get(info.file.response.data, 'id') || _.get(info.file.response.data, 'guid') || _.get(info.file.response.data, 'fileId'));
                }
                else {
                    upUrl_1 = '/api-common/file/download/' + info.file.response.data.fileId;
                }
                _this.setState({ loading: false, upUrl: upUrl_1, upName: upName }, function () { return _this.props.callback && _this.props.callback(upUrl_1, _.has(info, 'file.response.data') ? info.file.response.data : {}); });
            }
            else {
                antd_1.message.error("\u6587\u4EF6".concat(info.file.name, "\u4E0A\u4F20\u5931\u8D25"));
                _this.setState({ loading: false, upUrl: '' });
            }
        };
        return _this;
    }
    FileUpload.prototype.render = function () {
        var url = '';
        var text = '下载模板';
        var icon = 'download';
        if (this.props.templateDownload) {
            if (_.isString(this.props.templateDownload)) {
                url = this.props.templateDownload;
            }
            else {
                if (this.props.templateDownload.icon)
                    icon = this.props.templateDownload.icon;
                if (this.props.templateDownload.text)
                    text = this.props.templateDownload.text;
                url = this.props.templateDownload.url;
            }
        }
        return React.createElement(React.Fragment, null,
            React.createElement(Upload_1.Upload, __assign({ showUploadList: false, withCredentials: true, 
                // name="file"
                action: this.props.url || '/api-common/file/upload', accept: '*' }, this.props, { onChange: this.onUpChange, data: this.props.data === false ? {} : (_.isObject(this.props.data) ? this.props.data : { userId: this.state.userId, userName: this.state.userName, namespace: this.props.namespace || 'app-portal' }) }), this.props.upButton ? this.props.upButton(this.state.upUrl) : React.createElement(antd_1.Button, { title: this.state.upName, icon: 'upload', type: this.state.upUrl ? 'primary' : 'default', loading: this.state.loading, size: 'small' }, this.state.upName ? strRender(this.state.upName) : (this.props.btnText || '上传'))),
            (!this.props.upButton && this.state.upUrl) && React.createElement("a", { style: { paddingLeft: 6 }, target: '_black', href: this.state.upUrl }, (this.state.upUrl.split('?')[1] || this.state.upName || '') + ' 下载'),
            React.createElement("br", null),
            this.props.templateDownload ? React.createElement("a", { target: "_downloadFrame", href: url, onClick: function (e) { return e.stopPropagation(); } },
                React.createElement(antd_1.Icon, { type: icon }),
                " ",
                text) : '');
    };
    return FileUpload;
}(UploadService_1.default));
exports.default = FileUpload;
