import { DISPATCH } from './index';
export type BasePageState = {
    /**
     * 是否显示表单弹框
    */
    showForm?: boolean;
    /**
     * 是否编辑模式
    */
    isEdit?: boolean;
    /**
     * 正在编辑的对象
    */
    editObject?: any;
    /**
     * 是否显示导入弹框
    */
    showImport?: boolean;
};
declare const _default: {
    /**
     * basePage 可创建一个基础页面的 state Hook
    */
    basePage: (namespace: string, dispatch: DISPATCH) => {
        state: BasePageState;
        /**
         * 显示添加弹框
        */
        showAdd: () => void;
        /**
         * 显示编辑弹框
         * @param editObject 需要编辑的对象
        */
        showEdit: (editObject: any) => void;
        /**
         * 显示详情弹框
         * @param editObject 需要编辑的对象
        */
        showInfo: (editObject: any) => void;
        /**
         * 显示详情弹框
         * @param data 需要删除的对象 ,可以为一个数组(删除多个)，可以为一个对象(删除一个)，也可以是一个字符串(删除一个，以此为id)
        */
        del: (data: any) => void;
        /**
         * 添加
         * @param data 需要添加的对象，使用 onOk 可以自动判断
        */
        add: (data: any) => void;
        /**
         * 修改
         * @param data 需要修改的对象，使用 onOk 可以自动判断
        */
        update: (data: any) => void;
        /**
         * 隐藏弹框
        */
        hide: () => void;
        /**
         * 自动添加或修改
         * @param data 需要添加或修改的对象
        */
        onOk: (data: any) => void;
        /**
         * 显示导入弹框
        */
        showImportModal: () => void;
        /**
         * 隐藏导入弹框
        */
        hideImportModal: () => void;
    };
};
export default _default;
