"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var antd_1 = require("antd");
var utils_1 = require("../../utils");
var Step = antd_1.Steps.Step;
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            files: [],
            fileList: [],
            loading: false,
            current: 0,
            resData: {}
        };
        // 上传附件
        _this.files = {
            onChange: function (_a) {
                var fileList = _a.fileList;
                _this.setState({
                    fileList: fileList
                });
            },
            // 点击文件链接或预览图标时的回调
            onPreview: function (e) { }
        };
        _this.handleOk = function () {
            if (_this.props.onOk) {
                _this.props.onOk();
            }
        };
        _this.onRemove = function () {
            utils_1.Ajax.GET(_this.props.prefix + "/clean?token=" + _this.state.resData["token"], function (res) {
            });
        };
        _this.openPostWindow = function (url, data, name) {
            //url要跳转到的页面，data要传递的数据，name显示方式（可能任意命名）
            var tempForm = document.createElement("form");
            tempForm.id = "tempForm1";
            tempForm.method = "post";
            tempForm.action = url;
            tempForm.target = name;
            tempForm.name = name;
            var hideInput = document.createElement("input");
            hideInput.type = "hidden";
            hideInput.name = "data";
            hideInput.value = JSON.stringify(data); // JSON.stringify(data);
            tempForm.appendChild(hideInput);
            tempForm.addEventListener("onsubmit", function () {
                this.openWindow(name);
            }); //必须用name不能只用url，否则无法传值到新页面
            document.body.appendChild(tempForm);
            // tempForm.fireEvent("onsubmit");
            var evt = document.createEvent("MouseEvents");
            evt.initMouseEvent("submit", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
            tempForm.dispatchEvent(evt);
            tempForm.submit();
            document.body.removeChild(tempForm);
        };
        _this.openWindow = function (name) {
            var iWidth = 1100; //弹出窗口的宽度;
            var iHeight = 550; //弹出窗口的高度;
            var iTop = (window.screen.availHeight - 30 - iHeight) / 2; //获得窗口的垂直位置;
            var iLeft = (window.screen.availWidth - 10 - iWidth) / 2; //获得窗口的水平位置;
            window.open("about:blank", name, "height=" +
                iHeight +
                ", width=" +
                iWidth +
                ", top=" +
                iTop +
                ", left=" +
                iLeft +
                ",toolbar=no, menubar=no,  scrollbars=yes,resizable=yes,location=no, status=no");
        };
        _this.onChange = function (_a) {
            var file = _a.file, fileList = _a.fileList, event = _a.event;
            var status = file.status, percent = file.percent, response = file.response;
            if (response) {
                if (status == "done" && percent == 100 && response.code == "0") {
                    var data = response.data;
                    _this.setState({
                        resData: data,
                        current: 1
                    });
                }
            }
            _this.setState({
                fileList: fileList
            });
        };
        _this.saveStream = function () {
            utils_1.Ajax.GET(_this.props.prefix + "/saveStream?token=" + _this.state.resData["token"], function (res) {
                if (res.code == "0") {
                    var status_1 = res.data.status;
                    if (status_1 == "timeOut") {
                        antd_1.message.info("文件较大，导入时间过长，等待期间可关闭当前窗口，错误数据报告将会在稍后推送。");
                    }
                    else if (status_1 == "hasError") {
                        antd_1.message.success("已成功导入正确数据，请在错误报告中查看错误数据。");
                        window.open(_this.props.prefix + "/downloadErrorInfo?token=" + _this.state.resData["token"]);
                    }
                    else if (status_1 == "saveAll") {
                        antd_1.message.success("");
                    }
                }
                else {
                    antd_1.message.error(res.msg);
                }
            });
        };
        _this.saveSuccess = function () {
            utils_1.Ajax.GET(_this.props.prefix + "/saveSuccess?token=" + _this.state.resData["token"], function (res) {
                if (res.code == "0") {
                    _this.handleOk();
                    antd_1.message.success("操作成功");
                }
                else {
                    antd_1.message.error(res.msg);
                }
            });
        };
        return _this;
    }
    default_1.prototype.componentWillReceiveProps = function (nextProps) {
        if (nextProps.show != this.props.show) {
            this.setState({
                files: [],
                fileList: [],
                resData: {},
                current: 0
            });
        }
    };
    default_1.prototype.render = function () {
        var _this = this;
        var _a = this.state, current = _a.current, resData = _a.resData;
        var alertMessage = this.props.alertMessage;
        var errMsg = React.createElement("p", null, "\u5B58\u5728\u5982\u4E0B\u9519\u8BEF\u6570\u636E\uFF0C\u8BF7\u786E\u8BA4\u662F\u5426\u7EE7\u7EED\u5BFC\u5165\u6B63\u786E\u6570\u636E\u3002"), table = React.createElement("div", null);
        var result = React.createElement(antd_1.Result, { status: "success", title: "\u5DF2\u6210\u529F\u5BFC\u5165\u6240\u6709\u6570\u636E\uFF0C\u65E0\u9519\u8BEF\u6570\u636E\u3002" });
        var footer = [React.createElement(antd_1.Button, { onClick: function () { _this.props.onCancel(); } }, "\u5173\u95ED")];
        if (resData["status"]) {
            if (resData["status"] == "bigFile") {
                result = React.createElement(antd_1.Result, { status: "warning", title: "\u7531\u4E8E\u2F42\u4EF6\u8FC7\u2F24\uFF0C\u786E\u8BA4\u662F\u5426\u76F4\u63A5\u5BFC\u5165\u6B63\u786E\u6570\u636E\uFF0C\u9519\u8BEF\u6570\u636E\u5C06\u4F1A\u4EE5\u9519\u8BEF\u62A5\u544A\u63D0\u4F9B\u3002" });
                footer = [React.createElement(antd_1.Button, { onClick: function () {
                            _this.setState({
                                fileList: [],
                                resData: {},
                                current: 0
                            });
                            _this.onRemove();
                        } }, "\u91CD\u65B0\u4E0A\u4F20\u8F83\u5C0F\u6587\u4EF6"), React.createElement(antd_1.Button, { type: "primary", onClick: this.saveStream }, "\u76F4\u63A5\u5BFC\u5165")
                ];
            }
            else if (resData["status"] == "hasError") {
                footer = [React.createElement(antd_1.Button, { onClick: function () {
                            _this.setState({
                                fileList: [],
                                resData: {},
                                current: 0
                            });
                            _this.onRemove();
                        } }, "\u53D6\u6D88\u672C\u6B21\u5BFC\u5165"), React.createElement(antd_1.Button, { type: "primary", onClick: this.saveSuccess }, "\u5BFC\u5165\u6B63\u786E\u6570\u636E")
                ];
                if (this.state.resData["errorCount"] > 10) {
                    result = React.createElement(antd_1.Result, { status: "warning", title: React.createElement("p", null,
                            "\u9519\u8BEF\u6570\u636E\u8F83\u591A\uFF0C\u53EF\u4E0B\u8F7D\u9519\u8BEF\u62A5\u544A\uFF0C\u5C06\u9519\u8BEF\u6570\u636E\u8FDB\u884C\u4FEE\u590D\u540E\u91CD\u65B0\u5BFC\u5165\u3002",
                            React.createElement("a", { href: this.props.prefix + "/downloadErrorInfo?token=" + this.state.resData["token"] }, "\u4E0B\u8F7D\u9519\u8BEF\u62A5\u544A")) });
                }
                else if (this.state.resData["errorCount"] > 0) {
                    result = React.createElement(antd_1.Alert, { message: React.createElement("p", null,
                            "\u9519\u8BEF\u6570\u5982\u4E0B\uFF0C\u53EF\u4E0B\u8F7D\u9519\u8BEF\u62A5\u544A\uFF0C\u5C06\u9519\u8BEF\u6570\u636E\u8FDB\u884C\u4FEE\u590D\u540E\u91CD\u65B0\u5BFC\u5165\u3002",
                            React.createElement("a", { href: this.props.prefix + "/downloadErrorInfo?token=" + this.state.resData["token"] }, "\u4E0B\u8F7D\u9519\u8BEF\u62A5\u544A")), style: { marginBottom: 10 }, type: "error" });
                    if (this.state.resData["errorInfo"] && this.state.resData["errorInfo"].cols) {
                        var columns_1 = [], dataSource_1 = [], x = 950;
                        var len = this.state.resData["errorInfo"].cols.length;
                        if (len * 150 > 950) {
                            x = len * 150;
                        }
                        this.state.resData["errorInfo"].cols.forEach(function (element) {
                            columns_1.push({
                                title: element.lable,
                                dataIndex: element.name,
                                key: element.name,
                                width: 150,
                                render: function (text, editObject) {
                                    if (!text) {
                                        return "";
                                    }
                                    if (text.state) {
                                        return text.value;
                                    }
                                    else {
                                        return React.createElement("div", null,
                                            React.createElement(antd_1.Popover, { content: React.createElement("div", { style: { maxWidth: 250 } }, text.msg) },
                                                React.createElement(antd_1.Icon, { type: "exclamation-circle", style: { color: "red", marginRight: 10, cursor: "pointer" } })),
                                            text.value);
                                    }
                                }
                            });
                        });
                        this.state.resData["errorInfo"].rows.forEach(function (element) {
                            dataSource_1.push(element.cells);
                        });
                        table = React.createElement(antd_1.Table, { pagination: false, scroll: { y: 450, x: x }, columns: columns_1, dataSource: dataSource_1 });
                    }
                }
            }
        }
        return (React.createElement(antd_1.Modal, { title: "文件导入", maskClosable: false, onCancel: function () { _this.props.onCancel(); }, visible: this.props.show, destroyOnClose: true, onOk: this.handleOk, width: current == 0 ? 600 : 1000, footer: footer },
            React.createElement(antd_1.Steps, { current: current, size: "small", style: { marginBottom: 20 } },
                React.createElement(Step, { title: "\u6587\u4EF6\u4E0A\u4F20" }),
                React.createElement(Step, { title: "\u6587\u4EF6\u89E3\u6790\u7ED3\u679C" })),
            React.createElement("div", { className: current == 0 ? "" : "hide", style: { marginBottom: 20 } },
                React.createElement(antd_1.Alert, { message: alertMessage ? alertMessage : "请导入符合要求的文件格式，文件过大时可能导致处理时间较长。", style: { marginBottom: 20 }, type: "error" }),
                React.createElement(antd_1.Upload.Dragger, { name: "file", accept: ".xlsx", action: this.props.prefix + "/uploadFile", onChange: this.onChange, onRemove: this.onRemove, onPreview: this.files.onPreview, showUploadList: {
                        showDownloadIcon: false
                    }, disabled: this.state.fileList.length > 0, fileList: this.state.fileList }, this.state.fileList.length > 0 ? null : (React.createElement(antd_1.Button, null,
                    React.createElement(antd_1.Icon, { type: "upload" }),
                    "\u4E0A\u4F20\u9644\u4EF6")))),
            React.createElement("div", { className: current == 1 ? "" : "hide" },
                result,
                table)));
    };
    return default_1;
}(React.Component));
exports.default = default_1;
