"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var _ = require("lodash");
var index_1 = require("../index");
var index_2 = require("../../admin/index");
var utils_1 = require("../../utils");
var user_status = utils_1.Renders.statusRender({
    success: {
        name: '启用',
        value: 0
    },
    error: {
        name: '禁用',
        value: 1
    }
});
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.table = null;
        _this.state = {
            showAdd: false,
            showEdit: false,
            showIPModel: false,
            editObject: {},
            roleOptions: [],
            selectedRowKeys: [],
            selectRows: [],
            treeData: []
        };
        _this.handleOk = function () {
            if (_this.props.onOk) {
                _this.props.onOk(_this.state.selectRows);
            }
        };
        return _this;
    }
    default_1.prototype.componentWillMount = function () {
        var _this = this;
        if (this.props.url) {
            // @ts-ignore
            this.props.dispatch({
                type: 'userChooseModel/urlset',
                data: { url: this.props.url }
            });
        }
        if (this.props.domainUrl) {
            utils_1.Ajax.GET(this.props.domainUrl, function (res) {
                _this.setState({
                    treeData: res.data
                });
            });
        }
        else {
            utils_1.Ajax.GET("/api-common/secruity/domain/all", function (res) {
                if (res.data && _.isArray(res.data) && res.data.length > 0) {
                    var settree_1 = function (data, pcode) {
                        var temp = [];
                        if (_.isArray(data) && data.length > 0) {
                            if (!pcode) {
                                data.forEach(function (element) {
                                    if (!element.parentCode) {
                                        temp.push(element);
                                        element.children = settree_1(data, element.code);
                                    }
                                });
                            }
                            else {
                                data.forEach(function (element) {
                                    if (element.parentCode == pcode) {
                                        element.children = settree_1(data, element.code);
                                        temp.push(element);
                                    }
                                });
                            }
                        }
                        return temp;
                    };
                    _this.setState({
                        treeData: settree_1(res.data, null)
                    });
                }
            });
        }
        utils_1.Ajax.GET("/api-common/role/control", function (controls) {
            var canShow = _.filter(controls.data.join(',').split(','), function (item) { return !_.isEmpty(item); });
            utils_1.Ajax.GET("/api-common/role", function (allResp) {
                if (canShow.length > 0) {
                    var options_1 = [];
                    allResp.data.map(function (role) {
                        if (canShow.indexOf(role.id + '') >= 0) {
                            options_1.push(role);
                        }
                    });
                    _this.setState({
                        roleOptions: options_1
                    });
                }
                else {
                    _this.setState({
                        roleOptions: allResp.data
                    });
                }
            });
        });
    };
    default_1.prototype.componentWillReceiveProps = function (nextProps) {
        if (nextProps.show && !this.props.show) {
        }
    };
    default_1.prototype.render = function () {
        var _this = this;
        var param = {};
        param.selectBar = {
            title: "安全域选择",
            type: "tree",
            config: {
                treeData: this.state.treeData,
                nameField: this.props.nameField ? this.props.nameField : "domainName",
                valueField: this.props.valueField ? this.props.valueField : "code",
            },
            onSelect: function (item) {
                return { domainCode: item };
            },
        };
        var selectColumns = {
            title: "", dataIndex: "id", width: 40, render: function (id, editObject) {
                var checked = false;
                if (_this.state.selectedRowKeys.indexOf(id) > -1) {
                    checked = true;
                }
                return React.createElement(index_1.Checkbox, { checked: checked, onChange: function (e) {
                        var selectedRowKeys = _this.state.selectedRowKeys.slice();
                        var selectRows = _this.state.selectRows.slice();
                        if (e.target.checked) {
                            if (_this.props.multiple) {
                                selectedRowKeys.push(id);
                                selectRows.push(editObject);
                            }
                            else {
                                selectedRowKeys = [id];
                                selectRows = [editObject];
                            }
                        }
                        else {
                            var n_1 = -1;
                            selectedRowKeys.forEach(function (element, i) {
                                if (element == id) {
                                    n_1 = i;
                                }
                            });
                            if (n_1 > -1) {
                                selectedRowKeys.splice(n_1, 1);
                                selectRows.splice(n_1, 1);
                            }
                        }
                        _this.setState({
                            selectedRowKeys: selectedRowKeys,
                            selectRows: selectRows
                        });
                    } });
            }
        };
        var columns = [
            selectColumns,
            { title: '用户名称', dataIndex: 'name', sorter: true, },
            { title: '用户帐号', dataIndex: 'account', sorter: true, },
            { title: '所在机构', dataIndex: 'orgName', sorter: true, },
            { title: '身份证', dataIndex: 'idcard', className: 'vapfont', },
            { title: '电话', dataIndex: 'phone', className: 'vapfont', },
            { title: '邮箱', dataIndex: 'email', className: 'vapfont', },
            { title: '状态', dataIndex: 'status', render: user_status, sorter: true, },
        ];
        var fields = [
            { label: "用户名称", field: "name", },
            { label: "用户帐号", field: "account", },
            { label: "状态", field: "status", type: 'radio', span: 3, options: utils_1.Const.STATUS_FILTER, },
            { label: "角色", field: "roleId", type: 'checkbox', span: 3, options: this.state.roleOptions, },
        ];
        if (this.props.columns) {
            // @ts-ignore
            columns = __spreadArray([selectColumns], __read(this.props.columns), false);
        }
        if (this.props.fields) {
            // @ts-ignore
            fields = this.props.fields;
        }
        return React.createElement(React.Fragment, null,
            React.createElement(index_1.Modal, { title: "用戶选择", width: 1000, maskClosable: false, onCancel: function () { _this.props.onCancel(); }, destroyOnClose: true, visible: this.props.show, onOk: this.handleOk },
                React.createElement(index_2.VTable, __assign({}, param, { showIndex: false, scroll: { y: 400 }, namespace: "userChooseModel", ref: function (table) { return _this.table = table; }, columns: columns, searchBar: {
                        fields: fields,
                    } }))));
    };
    return default_1;
}(React.Component));
exports.default = default_1;
