"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var d3 = require("d3");
var D3Chart_1 = require("../D3Chart");
var _ = require("lodash");
var common_1 = require("../common");
/**
 * 横向，气泡Bar图
 * @deprecated
*/
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.__ClassName = '_vc_bar_top2';
        _this.__Grid = {
            left: 12,
            right: 12,
            top: 0,
            bottom: 0,
        };
        _this.itemHeight = 40;
        _this.widthScale = null;
        return _this;
    }
    default_1.prototype.sort = function () {
        var _this = this;
        this.DATA = _.orderBy(this.props.data, function (d) { return parseFloat(d[_this.props.valueField]); }, 'desc');
        if (this.DATA.length > this.MAXCOUNT && !_.has(this.props, "isLimite"))
            this.DATA.length = this.MAXCOUNT;
        var _a = __read(this.extent(this.DATA, function (d) { return d[_this.props.valueField]; }), 2), min = _a[0], max = _a[1];
        this.itemHeight = this.HEIGHT / this.DATA.length;
        this.widthScale = d3.scaleLinear().domain([min, max]).range([0.4 * this.LAYOUT.w, this.LAYOUT.w]);
    };
    default_1.prototype.build = function () {
        this.SVG.append('defs').html([
            common_1.DefUtil.BuildShadow(),
            common_1.DefUtil.BuildMutiBarImage()
        ].join(''));
        this.update();
    };
    default_1.prototype.update = function () {
        var _this = this;
        var group = this.SVG.selectAll('g._item')
            .data(this.DATA, function (d) { return d[_this.props.labelField]; });
        var enter = group.enter().append('g')
            .attr('transform', "translate(0,".concat(this.HEIGHT + 100, ")"));
        enter.merge(group)
            .attr('class', function (d, i) { return _this.itemClass(d, i); })
            .transition()
            .duration(this.DURATION)
            .attr('transform', function (d, i) { return "translate(0,".concat(_this.itemHeight * i, ")"); });
        enter.append('text')
            .attr('x', this.LAYOUT.x)
            .merge(group.select('text._index'))
            .attr('class', '_index')
            .text(function (d, i) { return (i + 1) + '.'; })
            .attr('y', this.itemHeight / 2 - 6);
        enter.append('text')
            .attr('class', '_label')
            .text(function (d) { return _this.FormatLabel(d[_this.props.labelField]); })
            .attr('x', this.LAYOUT.x + 12)
            .merge(group.select('text._label'))
            .attr('y', this.itemHeight / 2 - 8);
        enter.append('text')
            .attr('class', '_value')
            .merge(group.select('text._value'))
            .text(function (d) { return _this.FormatValue(d[_this.props.valueField]); })
            .attr('x', this.LAYOUT.x + this.LAYOUT.w)
            .attr('y', this.itemHeight / 2 - 8);
        enter.append('rect')
            .attr('class', '_bkg')
            .attr('rx', 5)
            .attr('ry', 5)
            .attr('x', this.LAYOUT.x)
            .attr('height', 12)
            .merge(group.select('rect._bkg'))
            .attr('width', this.LAYOUT.w)
            .attr('y', this.itemHeight / 2);
        enter.append('rect')
            .attr('class', function (d, i) { return "_content _content_".concat(i + 1); })
            .attr('width', 0)
            .attr('height', 8)
            .attr('rx', 4)
            .attr('ry', 4)
            .attr('x', this.LAYOUT.x)
            .merge(group.select('rect._content'))
            .attr('y', this.itemHeight / 2 + 2)
            .transition()
            .duration(this.DURATION)
            .attr('width', function (d) { return _this.widthScale(d[_this.props.valueField]); });
        enter.on('mouseover', function (d) {
            if (_this.props.tip) {
                common_1.ToolTip.show(_this.props.tip(d));
            }
            else {
                common_1.ToolTip.show("<h2>".concat(_this.FormatLabel(d[_this.props.labelField]), " : <small class=\"vapfont\">").concat(_this.FormatValue(d[_this.props.valueField]), "</small></h2>"));
            }
        }).on('mouseout', function (d) {
            common_1.ToolTip.hide();
        });
        if (this.props.onClick) {
            enter.on('click', function (d) { return _this.props.onClick(d); });
        }
        group.exit()
            .transition()
            .duration(this.DURATION)
            .attr('transform', "translate(0,-150)")
            .remove();
    };
    return default_1;
}(D3Chart_1.default));
exports.default = default_1;
