import D3Chart from '../D3Chart';
import { ChartOpts } from '../interface';
/**
 * 曲线图
*/
interface paddingOpt {
    top: number;
    left: number;
    right: number;
    bottom: number;
}
export interface CurveOpts extends ChartOpts {
    /**
     * 值
     */
    valueFields: string | Array<String>;
    /**
     * 名
     */
    nameFields: string | Array<String>;
    /**
     * 是否是多条曲线 - 暂不支持
     */
    mutiLine: boolean;
    /**
     * 是否显示Y轴
     */
    showYlabel: boolean;
    /**
     * 是否是堆叠 - 暂不支持
     */
    isArea?: boolean;
    /**
     * 标签 - 暂不支持
     */
    tag?: Array<String>;
    /**
     * 标签 位置 - 暂不支持
     */
    setTag?: "top" | "left" | "right" | "buttom";
    /**
     * 标签 点击 - 暂不支持
     */
    clickTag?: Function;
    /**
     * 设置样式
     */
    padding?: paddingOpt;
}
export default class extends D3Chart<CurveOpts> {
    __ClassName: string;
    __Grid: paddingOpt;
    max: number;
    showYlabel: boolean;
    widthScale: any;
    heightScale: any;
    lineGenerator: any;
    init(): void;
    sort(): void;
    private _appendLine;
    private _appendXAxis;
    private _appendYAxis;
    private _appendTag;
    build(): void;
    private _updateX;
    private _updateY;
    update(): void;
}
export {};
