"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var D3Chart_1 = require("../D3Chart");
var ToolTip_1 = require("../common/ToolTip");
var DefUtil_1 = require("../common/DefUtil");
var d3 = require("d3");
var _ = require("lodash");
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.__ClassName = '_vc_line_curve';
        _this.__Grid = _this.props.padding ? _this.props.padding : {
            top: 12,
            left: _this.props.showYlabel ? 40 : 12,
            right: 12,
            bottom: _this.props.setTag ? 80 : 30,
        };
        _this.max = 0;
        _this.showYlabel = false;
        _this.widthScale = null;
        _this.heightScale = null;
        _this.lineGenerator = null;
        return _this;
    }
    default_1.prototype.init = function () {
        // if (this.props.setTag) {
        //     let grid = _.extend([], this.__Grid);
        //     grid[this.props.setTag] = grid[this.props.setTag] + 50;
        //     this.__Grid = grid;
        // }
    };
    default_1.prototype.sort = function () {
        var _a;
        var _this = this;
        var data = [];
        var nameField;
        var valueField;
        if (!_.isArray(this.props.nameFields)) {
            nameField = this.props.nameFields;
        }
        if (!_.isArray(this.props.valueFields)) {
            valueField = this.props.valueFields;
        }
        this.props.data.map(function (d) { return data.push({
            name: d[nameField],
            value: d[valueField]
        }); });
        this.DATA = data;
        var _b = __read([0, 1], 2), min = _b[0], max = _b[1];
        if (this.DATA.length > 0) {
            _a = __read(d3.extent(data, function (item) { return item["value"]; }), 2), min = _a[0], max = _a[1];
            if (min == max) {
                min = 0;
            }
        }
        this.max = max;
        this.heightScale = d3.scaleLinear()
            .domain([0, max])
            .range([0, this.HEIGHT - this.__Grid.top - this.__Grid.bottom - 10]);
        this.widthScale = d3.scaleLinear()
            .domain([1, data.length])
            .range([this.__Grid.left, this.WIDTH - this.__Grid.left - this.__Grid.right - 10]);
        this.lineGenerator = d3.line()
            .x(function (d, i) { return _this.__Grid.left + _this.widthScale(i + 1); })
            .y(function (d, i) { return _this.HEIGHT - _this.__Grid.bottom - _this.heightScale(d["value"]); })
            .curve(d3.curveMonotoneX);
    };
    default_1.prototype._appendLine = function () {
        var _this = this;
        this.SVG.append("path")
            .datum(this.DATA)
            .attr("d", this.lineGenerator)
            .attr("stroke", "blue")
            .attr("stroke-width", 0)
            .attr("fill", "none")
            .transition()
            .duration(this.DURATION)
            .attr("stroke-width", 1);
        var group = this.SVG.selectAll("g._point")
            .data(this.DATA)
            .enter();
        group.append("circle")
            .attr("fill", "blue")
            .attr("rx", function (d, i) { return _this.__Grid.left + _this.widthScale(i + 1); })
            .attr("ry", function (d, i) { return _this.HEIGHT - _this.__Grid.bottom - _this.heightScale(d["value"]); })
            .attr("r", 1);
    };
    default_1.prototype._appendXAxis = function () {
        this.SVG.append("g")
            .attr("class", "_x_axis")
            .attr("transform", "translate(".concat(this.__Grid.left, ",").concat(this.HEIGHT - this.__Grid.bottom, ")"));
    };
    default_1.prototype._appendYAxis = function () {
        this.SVG.append("g")
            .attr("class", "_y_axis")
            .attr("transform", "translate(".concat(this.__Grid.left * 2, ",").concat(this.__Grid.top * 2, ")"));
    };
    default_1.prototype._appendTag = function () {
        var group = this.SVG.selectAll("g._tag")
            .data(this.props.tag)
            .enter();
        group.append("rect")
            .attr("x", this.WIDTH / 2)
            .attr("y", this.HEIGHT - this.__Grid.bottom + 30)
            .attr("width", 18)
            .attr("height", 16)
            .attr("fill", "blue");
        group.append("text")
            .attr("x", (this.WIDTH / 2) + 25)
            .attr("y", this.HEIGHT - this.__Grid.bottom + 42)
            .attr("text-anchor", "start")
            .attr("fill", "blue")
            .text(function (d) {
            return d + "";
        });
    };
    default_1.prototype.build = function () {
        this.SVG.append('defs').html(DefUtil_1.default.BuildLineDistribution());
        this._appendLine();
        this._appendXAxis();
        if (this.props.showYlabel) {
            this._appendYAxis();
        }
        if (this.props.setTag) {
            this._appendTag();
        }
    };
    default_1.prototype._updateX = function (circleGroup) {
        var _this = this;
        var self = this;
        var text = [];
        _.map(this.DATA, function (d) { return text.push(d.name); });
        var _widthScale = d3.scaleQuantize()
            .domain([0, this.DATA.length])
            .range(text);
        var bottomAxis = d3.axisBottom(_widthScale)
            .tickPadding(5)
            .tickFormat(function (d, i) {
            if (i < _this.DATA.length) {
                return "_widthScale(i)";
            }
            return "";
        });
        if (this.DATA.length == 1) {
            var _bottomAxis = d3.axisBottom(_widthScale)
                .ticks(2)
                .tickSize(1)
                .tickFormat(function (d, i) { return i == 1 ? self.DATA[0].name : ""; });
            bottomAxis = _bottomAxis;
            circleGroup.attr("cx", 0)
                .attr("transform", function () {
                if (_this.DATA.length == 1) {
                    return "translate(".concat((_this.WIDTH + _this.__Grid.left + _this.__Grid.right) / 2, ",0)");
                }
                return "translate(0,0)";
            });
        }
        this.SVG.select("._x_axis").call(bottomAxis);
    };
    default_1.prototype._updateY = function () {
        var self = this;
        var _heightScale = d3.scaleLinear()
            .domain([this.max, 0])
            .range([0, this.HEIGHT - this.__Grid.top - this.__Grid.bottom - 10]);
        var leftAxis = d3.axisLeft(_heightScale)
            .ticks(3)
            .tickSize(1)
            .tickPadding(5)
            .tickFormat(function (d, i) {
            return d + "";
        });
        this.SVG.select("._y_axis").call(leftAxis);
    };
    default_1.prototype.update = function () {
        var _this = this;
        this.SVG.select("path")
            .datum(this.DATA)
            .attr("d", this.lineGenerator)
            .attr("stroke", "blue")
            .attr("stroke-width", 0)
            .attr("fill", "none")
            .transition()
            .duration(this.DURATION)
            .attr("stroke-width", 1);
        var group = this.SVG.selectAll("g._point")
            .data(this.DATA)
            .enter();
        var circleGroup = group.append("circle")
            .attr("fill", "blue")
            .attr("cx", function (d, i) { return _this.__Grid.left + _this.widthScale(i + 1); })
            .attr("cy", function (d, i) { return _this.HEIGHT - _this.__Grid.bottom - _this.heightScale(d["value"]); })
            .attr("r", 0)
            .attr("style", "cursor: pointer;")
            .on("mouseover", function (d) {
            d3.select(this).attr("fill", "red");
            ToolTip_1.default.show("".concat(d["name"], ":").concat(d["value"]));
        })
            .on("mouseout", function () {
            d3.select(this).attr("fill", "blue");
            ToolTip_1.default.hide();
        })
            .transition()
            .duration(this.DURATION)
            .attr("r", 2.5);
        this._updateX(circleGroup);
        this._updateY();
    };
    return default_1;
}(D3Chart_1.default));
exports.default = default_1;
