import { ChartOpts } from '../interface';
/**
 * 普通PIE加税
*/
export interface PieOpts extends ChartOpts {
    /**
     * 标签label对应的数据字段
    */
    labelField: string;
    /**
     * 值对应的数据字段
    */
    valueField: string;
    /**
     * 圆环大小，如果要是想要纯PIE图，请设置大一点，比如 999
    */
    radius?: number;
    /**
     * 圆环加距
    */
    padding?: number;
    /**
     * 文字说明出现方式， tip 为弹出，其它为直接显示
    */
    hoverTip?: boolean;
    /**
     * 如果设置此项，则显示图例
    */
    legend?: 'left' | 'right' | 'top' | 'bottom';
}
export interface Layout {
    layout: {
        x: number;
        y: number;
        w: number;
        h: number;
    };
    nest: {
        x: number;
        y: number;
        w: number;
        h: number;
    };
    isHorizontal: boolean;
}
export declare const getLayout: (legend: 'left' | 'right' | 'top' | 'bottom', width: number, height: number) => Layout;
