import * as React from "react";
import { DraggerProps } from "./type";
type ListenType = 'drag' | 'resize';
export declare class Dragger extends React.Component<DraggerProps, {}> {
    parent: any;
    self: any;
    ListenMove: (type: ListenType) => void;
    unListenMove: (type: ListenType) => void;
    constructor(props: DraggerProps);
    /**
     * 初始变量设置
     */
    static defaultProps: {
        allowX: boolean;
        allowY: boolean;
        isUserMove: boolean;
    };
    state: {
        /** x轴位移，单位是px */
        x: number;
        /** y轴位移，单位是px */
        y: number;
        /**鼠标点击元素的原始位置，单位是px */
        originX: number;
        originY: number;
        isUserMove: boolean;
        /**已经移动的位移，单位是px */
        lastX: number;
        lastY: number;
        /**堆叠的层级 */
        zIndex: number;
        w: number;
        h: number;
        lastW: number;
        lastH: number;
    };
    move: (event: any) => void;
    onDragStart: (event: any) => void;
    onDragEnd: (event: any) => void;
    onResizeStart: (event: React.MouseEvent<HTMLSpanElement>) => void;
    onResizing: (event: any) => void;
    onResizeEnd: (event: any) => void;
    componentWillReceiveProps(nextProps: DraggerProps): void;
    mixin: () => {
        dragMix: {};
        resizeMix: {};
    };
    render(): JSX.Element;
}
export {};
