"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.stringJoin = exports.getDataSet = exports.isNumber = exports.parseBounds = exports.outerHeight = exports.innerHeight = exports.outerWidth = exports.innerWidth = exports.int = void 0;
var int = function (number) {
    if (number === '' || number === null) {
        return 0;
    }
    return parseInt(number, 10);
};
exports.int = int;
var innerWidth = function (node) {
    var width = node.clientWidth;
    var computedStyle = node.style;
    width -= (0, exports.int)(computedStyle.paddingLeft);
    width -= (0, exports.int)(computedStyle.paddingRight);
    return width;
};
exports.innerWidth = innerWidth;
var outerWidth = function (node) {
    var width = node.clientWidth;
    var computedStyle = node.style;
    width += (0, exports.int)(computedStyle.borderLeftWidth);
    width += (0, exports.int)(computedStyle.borderRightWidth);
    return width;
};
exports.outerWidth = outerWidth;
var innerHeight = function (node) {
    var height = node.clientHeight;
    var computedStyle = node.style;
    height -= (0, exports.int)(computedStyle.paddingTop);
    height -= (0, exports.int)(computedStyle.paddingBottom);
    return height;
};
exports.innerHeight = innerHeight;
var outerHeight = function (node) {
    var height = node.clientHeight;
    var computedStyle = node.style;
    height += (0, exports.int)(computedStyle.borderTopWidth);
    height += (0, exports.int)(computedStyle.borderBottomWidth);
    return height;
};
exports.outerHeight = outerHeight;
var parseBounds = function (bounds) {
    return {
        left: bounds.left,
        top: bounds.top,
        right: bounds.right,
        bottom: bounds.bottom
    };
};
exports.parseBounds = parseBounds;
var isNumber = function (things) {
    return typeof things === 'number' ? true : false;
};
exports.isNumber = isNumber;
var getDataSet = function (children) {
    return children.map(function (child) {
        return __assign(__assign({}, child.props['data-set']), { isUserMove: true, key: child.key });
    });
};
exports.getDataSet = getDataSet;
var stringJoin = function (source, join) {
    return source + (join ? " ".concat(join) : '');
};
exports.stringJoin = stringJoin;
