"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDoLoad = void 0;
var react_1 = require("react");
var useSetState_1 = require("./useSetState");
/**
 * 说明： doLoad 是一个更高阶的 doSetState, 支持异步方法，说明：可能会有BUG （尤其是在方法速度慢的时候）
 *
 * const [state,doLoad] =  useDoLoad({a:1,b:2,c:3});
 *
 * doLoad({b:5})
 *
 * doLoad((prevState)=>return {
 *      c:prevState + 1
 * })
 *
 * doLoad(async (prevState) =>{
 *  const resp = await Ajax.GET('API')
 *  return { c:resp.xxx }
 * })
*/
var useDoLoad = function (initValue) {
    var _a = __read((0, useSetState_1.useSetState)(initValue), 2), state = _a[0], setState = _a[1];
    var ref = (0, react_1.useRef)(state);
    (0, react_1.useEffect)(function () {
        ref.current = state;
    }, [state]);
    var doLoader = function (patch) {
        if (patch instanceof Function) {
            var result = patch(ref.current);
            if (result instanceof Promise) {
                result.then(function (resp) { return setState(resp); });
            }
            else {
                setState(result);
            }
        }
        else {
            setState(patch);
        }
    };
    return [state, doLoader];
};
exports.useDoLoad = useDoLoad;
