"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSetState = void 0;
var react_1 = require("react");
/**
 * 使用方法参考
 * https://github.com/streamich/react-use/blob/master/docs/useSetState.md
 *
 * 扩展点 1： 支持返回 null ，返回  null 不渲染，性能增加
 * 扩展点 2： 支持 callBack
 *
*/
var useSetState = function (initialState) {
    if (initialState === void 0) { initialState = {}; }
    var _a = __read((0, react_1.useState)(initialState), 2), state = _a[0], set = _a[1];
    var setState = function (patch, callback) { return set(function (prevState) {
        var next = patch instanceof Function ? patch(prevState) : patch;
        if (next == null)
            return prevState;
        var nextState = Object.assign({}, prevState, next);
        if (callback)
            setTimeout(function () { return callback(nextState); }, 1);
        return nextState;
    }); };
    return [state, setState];
};
exports.useSetState = useSetState;
