"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VCol = void 0;
var React = require("react");
var _ = require("lodash");
var dva_1 = require("dva");
var antd_1 = require("antd");
var _Panel_1 = require("./_Panel");
/**
 * 布局组件 ： 一列 参考 antd Col,
 * 在VAP里面，一列集成了一个标准的 Panel
 * 支持 loading_effect  empty 判断
*/
var VColContent = /** @class */ (function (_super) {
    __extends(VColContent, _super);
    function VColContent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VColContent.prototype.render = function () {
        var _a = this.props, xs = _a.xs, sm = _a.sm, md = _a.md, lg = _a.lg, xl = _a.xl, xxl = _a.xxl, span = _a.span, title = _a.title, icon = _a.icon, titleDesc = _a.titleDesc, noBg = _a.noBg, className = _a.className, theme = _a.theme;
        var colParam = _.extend({ xs: 24 }, { xs: xs, sm: sm, md: md, lg: lg, xl: xl, xxl: xxl, span: span });
        var clazz = ['vpanel', 'vpanel-default'];
        var hasTitle = false;
        var hasIcon = false;
        if (noBg) {
            clazz.push('vpanel-nobg');
        }
        if (theme) {
            clazz.push('vpanel-theme-' + theme);
        }
        if (title) {
            hasTitle = true;
            if (icon) {
                hasIcon = true;
            }
            if (titleDesc) {
                clazz.push('vpanel-complex');
            }
        }
        else {
            clazz.push('vpanel-notitle');
        }
        if (!colParam.span) {
            if (!_.has(this.props.style, 'width') && !_.has(this.props.style, 'height')) {
                colParam.className = 'vcol-nospan';
            }
            else {
                colParam.className = 'vcol-fixed';
            }
        }
        if (className) {
            clazz.push(className);
        }
        return React.createElement(antd_1.Col, __assign({}, colParam, { style: this.props.style }),
            React.createElement("div", { className: clazz.join(' ') },
                hasTitle && React.createElement("div", { className: "vpanel-title" + (hasIcon ? ' vpanel-title-with-icon' : ''), style: this.props.titleStyle }, this.renderTitle()),
                React.createElement("div", { className: "vpanel-content", style: this.props.contentStyle },
                    " ",
                    this.renderContent())));
    };
    return VColContent;
}(_Panel_1.Panel));
exports.VCol = (0, dva_1.connect)(function (_a) {
    var _loading = _a._loading;
    return ({ _loading: _loading });
})(VColContent);
