"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Panel = void 0;
var React = require("react");
var _ = require("lodash");
var antd_1 = require("antd");
var PageUtil_1 = require("../utils/PageUtil");
var Panel = /** @class */ (function (_super) {
    __extends(Panel, _super);
    function Panel() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Panel.prototype.isLoading = function () {
        var e_1, _a;
        if (this.props.loading) {
            return true;
        }
        if (_.has(this.props, 'loading_effect')) {
            // @ts-ignore;
            var _loadingEffect = this.props._loading.effects;
            if (_.isArray(this.props.loading_effect)) {
                try {
                    for (var _b = __values(this.props.loading_effect), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var loadingeffect = _c.value;
                        if (_loadingEffect[loadingeffect]) {
                            return true;
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }
            else if (_loadingEffect[this.props.loading_effect]) {
                return true;
            }
        }
        return false;
    };
    Panel.prototype.isEmpty = function () {
        if (_.has(this.props, 'empty')) {
            if (_.isBoolean(this.props.empty)) {
                if (this.props.empty) {
                    return true;
                }
            }
            else {
                if (this.props.empty == null) {
                    return true;
                }
                else if (_.isArray(this.props.empty) && this.props.empty.length == 0) {
                    return true;
                }
            }
        }
        return false;
    };
    Panel.prototype.renderAction = function () {
        if (this.props.btns && this.props.btns.length) {
            return React.createElement("span", { className: "vpanel-title-btns" },
                " ",
                this.props.btns.map(function (btn) {
                    if (_.has(btn, 'show')) {
                        if (!btn.show) {
                            return [];
                        }
                    }
                    if (_.has(btn, 'roleCode')) {
                        if (!PageUtil_1.default.hasRole(btn.roleCode)) {
                            return [];
                        }
                    }
                    if (btn.confirm) {
                        return React.createElement(antd_1.Popconfirm, { title: btn.confirm, onConfirm: function (evt) { return btn.onClick(); } },
                            React.createElement("span", { className: 'vpanel-title-btns-item', title: btn.title, onClick: function (evt) { return btn.onClick(); } },
                                React.createElement(antd_1.Icon, { type: btn.icon }),
                                btn.text));
                    }
                    return React.createElement("span", { className: 'vpanel-title-btns-item', title: btn.title, onClick: function (evt) {
                            evt.preventDefault();
                            evt.stopPropagation();
                            btn.onClick();
                        } },
                        React.createElement(antd_1.Icon, { type: btn.icon }),
                        btn.text);
                }));
        }
        if (this.props.actions) {
            return React.createElement("span", { className: "vpanel-title-actions" }, this.props.actions);
        }
        return [];
    };
    Panel.prototype.renderTitle = function () {
        var _a = this.props, title = _a.title, titleSub = _a.titleSub, titleDesc = _a.titleDesc, icon = _a.icon, help = _a.help;
        return React.createElement(React.Fragment, null,
            React.createElement("h4", null,
                icon && React.createElement(antd_1.Icon, { type: icon, className: "vpanel-title-icon" }),
                React.createElement("span", null,
                    title,
                    titleSub ? React.createElement("small", { className: "sub" }, titleSub) : [],
                    " ",
                    help ? React.createElement(antd_1.Tooltip, { title: help },
                        React.createElement(antd_1.Icon, { type: "question-circle", theme: "filled", className: "vpanel-title-help" })) : []),
                this.renderAction()),
            titleDesc && React.createElement("h5", null, titleDesc));
    };
    Panel.prototype.renderContent = function () {
        if (this.isLoading()) {
            return React.createElement("div", { className: "content-blank" },
                React.createElement(antd_1.Spin, null));
        }
        if (this.isEmpty()) {
            return React.createElement("div", { className: "content-blank" },
                React.createElement(antd_1.Empty, { description: this.props.emptyText || '暂无数据' }));
        }
        return this.props.children || [];
    };
    return Panel;
}(React.PureComponent));
exports.Panel = Panel;
