"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PasswordChecker = void 0;
/**
 * 密码复杂度,安全等级判断
*/
var PasswordChecker = /** @class */ (function () {
    function PasswordChecker(options) {
    }
    PasswordChecker.prototype.check = function (txt) {
        return true;
    };
    /**
     * 说明
     * 一. 密码长度
     *  1) 5 分: 小于等于 4 个字符
     *  2) 10 分: 5 到 7 字符
     *  3) 25 分: 大于等于 8 个字符
     * 二. 字母
     *  1) 0 分: 没有字母
     *  2) 10 分: 全都是小（大）写字母
     *  1) 2 分: 字母和数字
     *  2) 3 分: 字母、数字和符号
     *  3) 5 分: 大小写字母、数字和符号
    */
    PasswordChecker.prototype.strong = function (txt) {
        return 1;
    };
    /**
     * 0: 非常弱
     * 25: 弱（Weak）
     * 50: 一般（Average）
     * 60: 强（Strong）
     * 70: 非常强
     * 80: 安全（Secure）
     * 90: 非常安全
     *
     * 说明，返回 false , 说明密码没有通过验证
    */
    PasswordChecker.prototype.safeCheck = function (txt) {
        if (!this.check(txt))
            return false;
        var score = this.strong(txt);
        if (score < 25)
            return '非常弱';
        if (score < 50)
            return '弱';
        if (score < 60)
            return '一般';
        if (score < 70)
            return '强';
        if (score < 80)
            return '非常强';
        if (score < 90)
            return '安全';
        return '非常安全';
    };
    return PasswordChecker;
}());
exports.PasswordChecker = PasswordChecker;
