"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var base64EncodeChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
var TIME_LEN = 16;
var base64 = function (str) {
    var out, i, len;
    var c1, c2, c3;
    len = str.length;
    i = 0;
    out = [];
    while (i < len) {
        c1 = str.charCodeAt(i++) & 0xff;
        if (i == len) {
            out.push(base64EncodeChars.charAt(c1 >> 2));
            out.push(base64EncodeChars.charAt((c1 & 0x3) << 4));
            out.push("==");
            break;
        }
        c2 = str.charCodeAt(i++);
        if (i == len) {
            out.push(base64EncodeChars.charAt(c1 >> 2));
            out.push(base64EncodeChars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xF0) >> 4)));
            out.push(base64EncodeChars.charAt((c2 & 0xF) << 2));
            out.push("=");
            break;
        }
        c3 = str.charCodeAt(i++);
        out.push(base64EncodeChars.charAt(c1 >> 2));
        out.push(base64EncodeChars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xF0) >> 4)));
        out.push(base64EncodeChars.charAt(((c2 & 0xF) << 2) | ((c3 & 0xC0) >> 6)));
        out.push(base64EncodeChars.charAt(c3 & 0x3F));
    }
    return out.join('');
};
exports.default = {
    base64: base64,
    /**
     * 说明：内部加密算法，用于加密密码，
     * 安全度高于 Base64，不易被软狗扫描报漏，请用 vap 专业解密算法进行解密
    */
    base65: function (str, salt) {
        if (salt === void 0) { salt = 3; }
        salt = salt % 5;
        var password = base64(str);
        var timeStr = (new Date().getTime() + '').substr(1, 11) + String.fromCharCode(65 + str.length);
        var time = base64(timeStr);
        var buf = [];
        var mixlen = password.length < TIME_LEN ? password.length : TIME_LEN;
        for (var i = 0; i < mixlen; i++) {
            buf.push(String.fromCharCode(password.charAt(i).charCodeAt() - salt));
            buf.push(time.charAt(i));
        }
        if (mixlen < TIME_LEN) {
            buf.push(time.substr(mixlen));
        }
        else {
            for (var i = TIME_LEN; i < password.length; i++) {
                buf.push(String.fromCharCode(password.charAt(i).charCodeAt() - salt));
            }
        }
        var result = buf.join('');
        return result;
    },
    // decode: (str: string, salt = 3) => {
    //     if (str == null || str.length % 2 != 0) {
    //         throw new Error('Parse Error')
    //     }
    //     const len = str.length;
    //     const time_len = TIME_LEN * 2;
    //     let shortTime = len > time_len;
    //     let stop = shortTime ? time_len : time_len - (time_len - len) * 2;
    //     var p = []
    //     var d = [];
    //     try {
    //         for (let i = 0; i < stop; i = i + 2) {
    //             p.push(str.charCodeAt(i) + salt);
    //             d.push(str.charCodeAt(i + 1));
    //         }
    //         if (shortTime) {
    //             for (let j = time_len; j < len; j++) {
    //                 p.push(str.charCodeAt(j) + salt)
    //             }
    //         } else {
    //             for (let j = stop; j < len; j++) {
    //                 d.push(str.charCodeAt(j))
    //             }
    //         }
    //         let date = String.fromCharCode(...d)
    //         let pass = String.fromCharCode(...p)
    //         let dateStr = decodeBase64(date);
    //         let time = "1" + dateStr.substring(0, 11) + "5";
    //         let dateTime = parseInt(time)
    //         if (Math.abs(dateTime - Date.now()) > 1000 * 60 * 5) {
    //             throw new Error("TimeOut");
    //         }
    //         let idx = dateStr.charAt(11) - 65;
    //         let result = decodeBase64(pass);
    //         if (result.length() != idx) {
    //             throw new Error("Parse Error");
    //         }
    //         return result;
    //     } catch (error) {
    //         throw error;
    //     }
    // }
};
