export default abstract class {
    /**
     * 特殊字符
    */
    static SPECIAL_CHARACTER: RegExp;
    /***
    * 身份证号（支持15/18位）
    */
    static REGEXP_IDCARD: RegExp;
    static DATE_RANGE_COMMON: {
        今天: any[];
        本月: any[];
        近三天: any[];
        近七天: any[];
        上月: any[];
    };
    static DATE_RANGE_COMMON_MORE: {
        今天: any[];
        本月: any[];
        近三天: any[];
        近七天: any[];
        上月: any[];
        近三月: any[];
        今年: any[];
    };
    /**
     * 通用分页
    */
    static PAGE_OPTIONS: string[];
    /**
     * 启用 / 禁用 Switch 开关选项，用于表单元素的输入
     * ```
     *  {name:'启用',value:'0'},
     *  {name:'禁用',value:'1'}
     * ```
    */
    static STATUS_OPTION: {
        name: string;
        value: string;
    }[];
    /**
     * 全部 / 启用 / 禁用 过滤器 定义，用于 Table 头上的过滤搜索
     * ```
     *  {name:'全部',value:''},
     *  {name:'启用',value:'0'},
     *  {name:'禁用',value:'1'}
     * ```
    */
    static STATUS_FILTER: {
        name: string;
        value: string;
    }[];
    /**
    *  启用 / 禁用 映射文字，用于将值传为文字进行显示
     * ```
     * {
     *  '0':'是',
     *  '1':'否'
     * }
     * ```
    */
    static STATUS_MAP: {
        '0': string;
        '1': string;
    };
    /**
     * 是 / 否 Switch 开关选项，用于表单元素的输入
     * ```
     *  {name:'是',value:'0'},
     *  {name:'否',value:'1'}
     * ```
    */
    static IS_NOT_OPTION: {
        name: string;
        value: string;
    }[];
    /**
     * 全部 / 是 / 否 过滤器 定义，用于 Table 头上的过滤搜索
     * ```
     *  {name:'全部',value:''},
     *  {name:'是',value:'0'},
     *  {name:'否',value:'1'}
     * ```
    */
    static IS_NOT_FILTER: {
        name: string;
        value: string;
    }[];
    /**
    *  是 / 否 映射文字，用于将值传为文字进行显示
     * ```
     * {
     *  '0':'是',
     *  '1':'否'
     * }
     * ```
    */
    static IS_NOT_MAP: {
        '0': string;
        '1': string;
    };
    /**
     * 异常报警类型
    */
    static DICT_WARN_TYPE: string;
    /**
     * 系统类型  1. 系统 ，2，网站
     * */
    static DICT_SYS_TYPE: string;
    /**
     * 人员类型  1.警员 2. 辅警 3. 外协
     * */
    static DICT_PERSON_TYPE: string;
    /**
     * 对象类型
     */
    static DICT_OBJECT_TYPE: string;
    /**
     * PKI警种 Render
    */
    static DICT_POLICE_TYPE_PKI: string;
    /**
     * 人员警种 Render
    */
    static DICT_POLICE_TYPE: string;
    /**
    * 威胁类型 render
   */
    static DICT_THREAT_TYPE: string;
    /**
     * 证书状态
    */
    static DICT_PKI_STATUS: string;
    /**
   * 站点类型分类 siteType Render
  */
    static DICT_SITE_TYPE: string;
    /**
    * 登录类型(安全级别) Render
    */
    static DICT_LOGIN_TYPE: string;
    /**
     * 岗位类型
    */
    static DICT_STATION_TYPE: string;
    /**
     * 应用 ：服务器类型
    */
    static DICT_SYS_SERVER_TYPE: string;
    /**
     * 应用 建库模式
    */
    static DICT_SYS_CREATE_MODEL: string;
    /**
     * 应用 操作系统类型
    */
    static DICT_SYS_OS_TYPE: string;
    /**
     * 应用 数据库类型
    */
    static DICT_SYS_APP_DATABASE_TYPE: string;
    /**
     * 应用 应用系统来源
    */
    static DICT_SYS_SOURCE_TYPE: string;
    /**
     * 应用 字符集
    */
    static DICT_SYS_CHARTSET: string;
    /**
     * 应用 网络
    */
    static DICT_SYS_NETWORK: string;
    /**
     * 应用 个人用户登录方式
    */
    static DICT_SYS_USER_LOGIN_TYPE: string;
    /**
     * 应用 账户类型
    */
    static DICT_SYS_ACCOUNT_TYPE: string;
    /**
     * 应用 系统等级
    */
    static DICT_SYS_LEVEL: string;
    /**
     * 应用 系统状态
    */
    static DICT_SYS_STATE: string;
    /**
     * 应用 应用类型
    */
    static DICT_SYS_APP_TYPE: string;
    /***
     * 资产风险等级
     * */
    static DICT_WARN_LEVEL: string;
    /**
     *告警处置状态
    */
    static DICT_ALARM_STATUS: string;
    /**
     * 通用二元状态： 启用，禁用
     * */
    static DICT_OPEN_CLOSE: string;
    /**
     * 通用二元状态： 是，否
     * */
    static DICT_YES_NO: string;
    /**
     *设备类型
     * */
    static DEVICE_TYPE: string;
    /**
     * 攻击类型
     */
    static ATTACK_TYPE: string;
    /**
     * 公司简称
     */
    static DICT_COMPANY_DESC: string;
    /**
     * 请求方法
     */
    static DICT_REQUEST_METHOD: string;
    /**
     * 执行策略
     */
    static DICT_EXECUTE_STRATEGY: string;
    /**
     * waf攻击事件类型
     */
    static DICT_WAF_ATTACK_TYPE: string;
    /**
     * 通用等级
     */
    static DICT_COMMON_LEVEL: string;
}
