"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
if (!_.has(window, '_i18n')) {
    window['_i18n'] = { zh_CN: {}, en_US: {}, _lang: 'zh_CN' };
}
var i18n = window['_i18n'];
/**
 * 设定国际化语言，
 * 目前仅支持 zh_CN, en_US
 * 默认设定顺序 : vap.system_lang / window.navigator.language / 'zh_CN';
*/
var setLanguage = function (lang) {
    i18n._lang = lang;
};
var register = function (lang, res) {
    _.extend(window['_i18n'][lang], res);
};
var getSystem = function () {
    i18n._lang == 'en_US' ? window.antd.locales.en_US : window.antd.locales.zh_CN;
};
var get = function (text, def) {
    if (_.has(i18n[i18n._lang], text)) {
        return _.get(i18n[i18n._lang], text);
    }
    return def || '';
};
exports.default = {
    setLanguage: setLanguage,
    register: register,
    get: get,
    getSystem: getSystem,
};
