import './__DefaultGlobal';
import type { SystemConfApi } from '../index';
declare class VAP {
    /**
     * 系统 ： 系统版本
    */
    system_version: string;
    /**
     * 系统 ： 系统语言
    */
    system_lang: 'zh_CN' | 'en_US';
    /**
     * 系统 ： 系统Logo
     * false : 使用安装包内的 logo.png文件
     * string:  Base64字串，使用此图片
    */
    system_logo: string;
    /**
     * 系统 ： 产品名称：显示在内页，Logo 旁边的标题
    */
    system_name: string;
    /**
     * 系统 ： 登录页面标题
    */
    system_login_title: string;
    /**
     * 系统 ： 登录页面副标题
    */
    system_login_sub: string;
    /**
     * 系统 ： 登录页面页脚
    */
    system_login_foot: string;
    /**
     *  系统 ： 系统入口
    */
    system_entrance: string;
    /**
     * 系统 ： 开启权限检查
    */
    system_check_path: boolean;
    /**
     * 默认检测时间将士们为分钟，0 为不检测（必须大于后台超时时间）
    */
    system_session_timeout: number;
    /**
     *  皮肤 ： 支持的皮肤
    */
    theme_available: string[];
    /**
     *  皮肤 ： 当前使用皮肤
    */
    theme_default: string;
    /**
     *  皮肤 ： 是否开启Tabs
    */
    theme_tabs: boolean;
    /**
     *  皮肤 ： 上下结构
    */
    theme_top: boolean;
    /**
     *  皮肤 ： 限制宽度
    */
    theme_wide: boolean;
    /**
     *  皮肤 ： 左边 Menu 宽度
    */
    theme_banner_width: number;
    /**
     *  皮肤 ： 头部 Nav 高度
    */
    theme_banner_height: number;
    /**
     * 左侧菜单收缩后的宽度，默认为64
    */
    theme_collapsed_width: number;
    /**
     *  皮肤 ： 允许收缩，仅JD版本不允许
    */
    theme_menu_collapse: boolean;
    /**
     *  皮肤 ： 菜单缓存，仅GW版本不缓存
    */
    theme_menu_cache: boolean;
    /**
     *  导航 ： 开启消息推送
    */
    nav_message: boolean;
    /**
     * 是否锁定， 0 不锁定  ，数字N = N**分钟** 后自动锁定
    */
    nav_lock: number;
    /**
     *  导航 ： 开启最大化页面按钮
    */
    nav_max: boolean;
    /**
     *  导航 ： 开启大屏导航
    */
    nav_screen: boolean;
    /**
     *  导航 ： 开启皮肤切换
    */
    nav_theme: boolean;
    /**
     *  导航 ： 开启应用跳转
    */
    nav_app: boolean;
    /**
     *  导航 ： 开启告警事件
    */
    nav_alarm: boolean;
    /**
     *  导航 ： 开启搜索应用
    */
    nav_search: boolean;
    /**
     *  导航 ： 自定义应用
    */
    nav_custom: string[];
    /**
     * 其它属性
    */
    _extra: {};
    constructor();
    /**
     * 缓存刷新
    */
    reflush(): void;
    private SYS_INFO;
    getExtra(key: string): string;
    init(options?: SystemConfApi): void;
    private parseData;
    private getData;
}
declare const _default: VAP;
export default _default;
