"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var $ = require("jquery");
var _ = require("lodash");
require("./__DefaultGlobal");
var LAST_CACHE = '_last_cache';
// 默认配置
var DEFAULT = {
    system_version: 'base',
    system_logo: '',
    system_name: '',
    system_login_title: '',
    system_login_sub: '',
    system_login_foot: '',
    system_entrance: '/admin/',
    system_session_timeout: 0,
    system_check_path: false,
    theme_available: ['default', 'pro', 'dark', 'virid', 'darkgray', 'darkblue'],
    theme_default: 'default',
    theme_tabs: false,
    theme_top: false,
    theme_wide: true,
    theme_banner_width: 220,
    theme_banner_height: 48,
    theme_collapsed_width: 64,
    theme_menu_collapse: true,
    theme_menu_cache: true,
    nav_message: false,
    nav_max: true,
    nav_screen: true,
    nav_theme: true,
    nav_lock: 0,
    nav_app: false,
    nav_alarm: false,
    nav_search: true,
    nav_custom: ['version', 'user'],
    _extra: {}
};
var VAP = /** @class */ (function () {
    function VAP() {
        var _this = this;
        /**
         * 系统 ： 系统版本
        */
        this.system_version = 'base';
        /**
         * 系统 ： 系统语言
        */
        this.system_lang = 'zh_CN';
        /**
         * 系统 ： 系统Logo
         * false : 使用安装包内的 logo.png文件
         * string:  Base64字串，使用此图片
        */
        this.system_logo = '';
        /**
         * 系统 ： 产品名称：显示在内页，Logo 旁边的标题
        */
        this.system_name = '';
        /**
         * 系统 ： 登录页面标题
        */
        this.system_login_title = '';
        /**
         * 系统 ： 登录页面副标题
        */
        this.system_login_sub = '';
        /**
         * 系统 ： 登录页面页脚
        */
        this.system_login_foot = '';
        /**
         *  系统 ： 系统入口
        */
        this.system_entrance = '';
        /**
         * 系统 ： 开启权限检查
        */
        this.system_check_path = false;
        /**
         * 默认检测时间将士们为分钟，0 为不检测（必须大于后台超时时间）
        */
        this.system_session_timeout = 0;
        /**
         *  皮肤 ： 支持的皮肤
        */
        this.theme_available = ['default', 'pro', 'dark', 'virid', 'darkgray', 'darkblue']; // 可用皮肤（逗号分开）
        /**
         *  皮肤 ： 当前使用皮肤
        */
        this.theme_default = 'default'; //默认皮肤
        /**
         *  皮肤 ： 是否开启Tabs
        */
        this.theme_tabs = false;
        /**
         *  皮肤 ： 上下结构
        */
        this.theme_top = false; //默认皮肤
        /**
         *  皮肤 ： 限制宽度
        */
        this.theme_wide = true; //默认皮肤
        /**
         *  皮肤 ： 左边 Menu 宽度
        */
        this.theme_banner_width = 220; // 左边 Menu 宽度
        /**
         *  皮肤 ： 头部 Nav 高度
        */
        this.theme_banner_height = 48; //头部 Nav 高度
        /**
         * 左侧菜单收缩后的宽度，默认为64
        */
        this.theme_collapsed_width = 64; //
        /**
         *  皮肤 ： 允许收缩，仅JD版本不允许
        */
        this.theme_menu_collapse = true; //允许收缩
        /**
         *  皮肤 ： 菜单缓存，仅GW版本不缓存
        */
        this.theme_menu_cache = true; //缓存菜单
        /**
         *  导航 ： 开启消息推送
        */
        this.nav_message = false; //开启消息推送
        /**
         * 是否锁定， 0 不锁定  ，数字N = N**分钟** 后自动锁定
        */
        this.nav_lock = 0;
        /**
         *  导航 ： 开启最大化页面按钮
        */
        this.nav_max = true; //开启最大化页面按钮
        /**
         *  导航 ： 开启大屏导航
        */
        this.nav_screen = true; //开启大屏导航
        /**
         *  导航 ： 开启皮肤切换
        */
        this.nav_theme = true; //开启皮肤切换
        /**
         *  导航 ： 开启应用跳转
        */
        this.nav_app = false; //开启应用跳转
        /**
         *  导航 ： 开启告警事件
        */
        this.nav_alarm = false; //开启告警事件
        /**
         *  导航 ： 开启搜索应用
        */
        this.nav_search = true; //开启搜索应用
        /**
         *  导航 ： 自定义应用
        */
        this.nav_custom = ['version', 'user']; //自定义如下
        /**
         * 其它属性
        */
        this._extra = {};
        this.SYS_INFO = { api: '/api-common/system/config', codeField: 'confId', valueField: 'confValue', timeout: 1000 * 60 * 30 };
        _.keys(DEFAULT).map(function (key) { return _this[key] = DEFAULT[key]; });
    }
    /**
     * 缓存刷新
    */
    VAP.prototype.reflush = function () {
        window.localStorage.clear();
        this.init();
    };
    VAP.prototype.getExtra = function (key) {
        return _.has(this._extra, key) ? this._extra[key] : '';
    };
    VAP.prototype.init = function (options) {
        var _this = this;
        if (options) {
            this.SYS_INFO = _.merge(this.SYS_INFO, options);
        }
        var cache_data = null;
        var SYS_INFO = this.SYS_INFO;
        if (window.hasOwnProperty('localStorage')) {
            // 间隔缓存，1小时
            var _last_cache = window.localStorage.getItem(LAST_CACHE);
            if (!_.isEmpty(_last_cache)) {
                var now = _.now();
                try {
                    var last = parseInt(_last_cache);
                    if (Math.abs(last - now) < (SYS_INFO.timeout)) {
                        var data = window.localStorage.getItem(SYS_INFO.api);
                        cache_data = JSON.parse(data);
                    }
                }
                catch (e) {
                    cache_data = null;
                    window.localStorage.removeItem(SYS_INFO.api);
                    window.localStorage.clear();
                }
            }
        }
        if (cache_data == null) {
            var confings = [];
            $.ajax(SYS_INFO.api, { async: false, method: 'GET' }).done(function (resp) {
                confings = resp.data || [];
            });
            cache_data = this.parseData(confings);
            if (window.hasOwnProperty('localStorage')) {
                window.setTimeout(function () {
                    window.localStorage.setItem(LAST_CACHE, _.now() + '');
                    window.localStorage.setItem(SYS_INFO.api, JSON.stringify(cache_data));
                }, 50);
            }
        }
        _.keys(cache_data).map(function (key) { return _this[key] = cache_data[key]; });
    };
    VAP.prototype.parseData = function (confings) {
        var _this = this;
        var SYS_INFO = this.SYS_INFO;
        var cache_data = _.extend({}, DEFAULT);
        confings.map(function (conf) {
            if (_.has(cache_data, conf[SYS_INFO.codeField])) {
                cache_data[conf[SYS_INFO.codeField]] = _this.getData(conf[SYS_INFO.codeField], conf[SYS_INFO.valueField]);
            }
            else {
                cache_data._extra[conf[SYS_INFO.codeField]] = conf[SYS_INFO.valueField];
            }
        });
        return cache_data;
    };
    VAP.prototype.getData = function (key, value) {
        var e_1, _a, e_2, _b;
        switch (key) {
            case 'system_lang':
                if (value == 'zh_CN' || value == 'en_US') {
                    return value;
                }
                return 'zh_CN';
            case 'system_logo':
                if (value == 'false' || _.isEmpty(value)) {
                    return '';
                }
                return value;
            case 'theme_available':
                var themes = [];
                var confTheme = value.split(',');
                try {
                    for (var confTheme_1 = __values(confTheme), confTheme_1_1 = confTheme_1.next(); !confTheme_1_1.done; confTheme_1_1 = confTheme_1.next()) {
                        var item = confTheme_1_1.value;
                        var theme = item.toLocaleLowerCase();
                        themes.push(theme);
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (confTheme_1_1 && !confTheme_1_1.done && (_a = confTheme_1.return)) _a.call(confTheme_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                return themes;
            case 'nav_custom':
                var fns = [];
                var menus = value.split(',');
                try {
                    for (var menus_1 = __values(menus), menus_1_1 = menus_1.next(); !menus_1_1.done; menus_1_1 = menus_1.next()) {
                        var item = menus_1_1.value;
                        var fn = item.toLocaleLowerCase();
                        fns.push(fn);
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (menus_1_1 && !menus_1_1.done && (_b = menus_1.return)) _b.call(menus_1);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
                return fns;
            case 'theme_banner_width':
            case 'theme_banner_height':
            case 'nav_lock':
            case 'system_session_timeout':
                try {
                    return parseInt(value);
                }
                catch (e) {
                }
                return DEFAULT[key];
            case 'theme_top':
            case 'theme_tabs':
            case 'theme_wide':
            case 'theme_menu_collapse':
            case 'theme_menu_cache':
            case 'nav_message':
            case 'nav_max':
            case 'nav_screen':
            case 'nav_theme':
            case 'nav_app':
            case 'nav_alarm':
            case 'nav_search':
            case 'system_check_path':
                if (value == 'true' || value == '1') {
                    return true;
                }
                if (value == 'false' || value == '0') {
                    return false;
                }
                return DEFAULT[key];
            default:
                return value;
        }
    };
    return VAP;
}());
window['__VAP_GLOBAL'] = window['__VAP_GLOBAL'] ? window['__VAP_GLOBAL'] : new VAP();
exports.default = window['__VAP_GLOBAL'];
