/**
 * format 说明
 *
 * 目前 在根结点上的 format 支持以下7种类型，在子结点上配置字符串
 *
 *
 *      1. tag         : 以 tag 标签方式显示，子节点format配置颜色值，参考antd
 *              说明：以 绝对颜色显示 如 #ff0000 时，可能会在不同的皮肤下不兼容，如果系统上线了多套皮肤切换，则不要配为绝对颜色
                pink
                red
                yellow
                orange
                cyan
                green
                blue
                purple
                geekblue
                magenta
                volcano
                gold
                lime
                ...more
        2. border       ： 以 border+color 方式显示
 *              说明：以 绝对颜色显示 如 #ff0000 时，可能会在不同的皮肤下不兼容，如果系统上线了多套皮肤切换，则不要配为绝对颜色


 *      3. status      : 以状态方式显示，子节点format,支持以下五项，默认为 default
                success
                error
                default
                processing
                warning
 *      4.sup         : 以下标方式展示在 value 后面
 *      5.sub         : 以上标方式展示在 value 后面
                string(text)
 *      6.icon        :
                string(icon)      ：配置一个 icon type 字符串
                string(url)      ：配置一个 以绝对路径  "/" 开头的字符串
 *      7.progress    :     流程状态示意
                prepare     准备中
                ready       准备完成
                doing       进行中
                finsh       已完成
                error       有问题
        8.clazz        : 扩展样式render ， 需要自行在样式里面扩展
                string(className) ,会 渲染为 <span class="clazz">{value}</span>
 *
*/
export interface Dict {
    value: string;
    name: string;
    format?: string;
}
export interface DictMap {
    map: Map<string, [string, string]>;
    reverse: Map<string, string>;
    nodes: Dict[];
    format?: string;
}
/**
 * 用于列表，字典等 Render 的 Value，由 name(显示) 和 value(实际取值) 两个字段组成
*/
export interface Value {
    /**
     * 显示在页面上的名称
    */
    name: string;
    /**
     * 实际取值
    */
    value: number | string;
    /**
     * 子结构，多级时适用
    */
    children?: Value[];
}
export interface DictRender {
    (value: any): string;
    nodes: Value[];
    reverse: (txt?: string) => string;
    optAs: (nameField?: string, valueField?: string, shift?: any) => any[];
    intOpts: () => {
        name: string;
        value: number;
    }[];
    get: (txt?: string) => {
        value: string;
        name: string;
    };
    getByName: (txt?: string) => {
        value: string;
        name: string;
    };
}
export declare const dictRender: (type: string, def?: string | false, onlyText?: boolean) => DictRender;
