"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.dictRender = void 0;
var React = require("react");
var _ = require("lodash");
var antd_1 = require("antd");
var Ajax_1 = require("../utils/Ajax");
var TEXT = window.VAP_GLOBAL.TIPS;
var LOOPDICT = function (dict, root, map, reverse, nodes) {
    var e_1, _a;
    var _b = window.VAP_GLOBAL, DICT_INFO = _b.DICT_INFO, VDATA = _b.VDATA;
    var childrens = _.filter(dict[VDATA.data], function (child) { return child[DICT_INFO.parentField] == root[DICT_INFO.idField]; });
    try {
        for (var childrens_1 = __values(childrens), childrens_1_1 = childrens_1.next(); !childrens_1_1.done; childrens_1_1 = childrens_1.next()) {
            var node = childrens_1_1.value;
            map.set(node[DICT_INFO.codeField] + '', [node[DICT_INFO.valueField] + '', node.format]);
            reverse.set(node[DICT_INFO.valueField] + '', node[DICT_INFO.codeField] + '');
            if (node.leaf == '1') {
                nodes.push({ name: node[DICT_INFO.valueField] + '', value: node[DICT_INFO.codeField] + '', format: node.format || null });
            }
            else {
                var parent_1 = { name: node[DICT_INFO.valueField] + '', value: node[DICT_INFO.codeField] + '', format: node.format || null, children: [] };
                LOOPDICT(dict, node, map, reverse, parent_1.children);
                nodes.push(parent_1);
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (childrens_1_1 && !childrens_1_1.done && (_a = childrens_1.return)) _a.call(childrens_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
};
window['_VAP_DICT_LOADED'] = false;
//初始化字典
function __initDict() {
    if (window['_VAP_DICT_LOADED']) {
        return;
    }
    var _a = window.VAP_GLOBAL, DICT_INFO = _a.DICT_INFO, RESULT = _a.RESULT, VDATA = _a.VDATA;
    var dict = [];
    Ajax_1.default.SESION(DICT_INFO.api);
    try {
        var resp = Ajax_1.default.GETASYNC(DICT_INFO.api);
        if (resp[RESULT.code] == RESULT.success) {
            dict = resp;
        }
        var roots = _.filter(dict[VDATA.data], function (item) { return item[DICT_INFO.parentField] == '0' || item[DICT_INFO.parentField] == ''; });
        roots.map(function (root) {
            var map = new Map();
            var reverse = new Map();
            var nodes = [];
            LOOPDICT(dict, root, map, reverse, nodes);
            window['_VAP_DICT_DETAIL'].set(root.type, { format: root.format, map: map, reverse: reverse, nodes: nodes });
        });
        window['_VAP_DICT_LOADED'] = true;
    }
    catch (e) {
    }
}
if (!_.has(window, '_VAP_DICT_DETAIL')) {
    window['_VAP_DICT_DETAIL'] = new Map();
    window['_VAP_DICT_RENDER'] = new Map();
}
var DICTMAP = window['_VAP_DICT_DETAIL'];
var RENDERMAP = window['_VAP_DICT_RENDER'];
var DEFAULT_DICT_RENDER = function (value) { return value; };
DEFAULT_DICT_RENDER.nodes = [];
DEFAULT_DICT_RENDER.reverse = function (txt) { return null; };
DEFAULT_DICT_RENDER.optAs = function (nameField, valueField, shift) { return []; };
DEFAULT_DICT_RENDER.intOpts = function () { return []; };
DEFAULT_DICT_RENDER.get = function (txt) { return null; };
DEFAULT_DICT_RENDER.getByName = function (txt) { return null; };
var tagRender = function (key, def, map) {
    if (def === void 0) { def = TEXT.RENDER_TEXT; }
    if (!map.has(key)) {
        if (def) {
            return React.createElement(antd_1.Tag, null, def);
        }
        return '';
    }
    var _a = __read(map.get(key), 2), txt = _a[0], format = _a[1];
    return React.createElement(antd_1.Tag, { className: "dict-value-tag", color: format ? format : 'geekblue' }, txt);
};
var STATUS = new Set(['success', 'processing', 'warning', 'error', 'default']);
var statusRender = function (key, def, map) {
    if (!map.has(key)) {
        if (def === false)
            return key;
        return React.createElement(antd_1.Badge, { className: "dict-value-status", status: "default", text: def });
    }
    var _a = __read(map.get(key), 2), txt = _a[0], format = _a[1];
    if (STATUS.has(format)) {
        // return <Badge status={format as any} text={txt} />
    }
    return React.createElement(antd_1.Badge, { className: "dict-value-status", status: "default", text: txt });
};
var subRender = function (key, def, map) {
    if (!map.has(key)) {
        if (def === false)
            return key;
        return def;
    }
    var _a = __read(map.get(key), 2), txt = _a[0], format = _a[1];
    return React.createElement("span", { className: "dict-value-sub" },
        txt,
        format && React.createElement("sub", null, format));
};
var supRender = function (key, def, map) {
    if (!map.has(key)) {
        if (def === false)
            return key;
        return def;
    }
    var _a = __read(map.get(key), 2), txt = _a[0], format = _a[1];
    return React.createElement("span", { className: "dict-value-sup" },
        txt,
        format && React.createElement("sup", null, format));
};
var iconRender = function (key, def, map) {
    if (!map.has(key)) {
        if (def === false)
            return key;
        return def;
    }
    var _a = __read(map.get(key), 2), txt = _a[0], format = _a[1];
    if (format == null || format == '') {
        return txt;
    }
    if (_.startsWith(format, '/')) {
        return React.createElement(React.Fragment, null,
            React.createElement("img", { className: "dict-value-img", src: format }),
            txt);
    }
    return React.createElement(React.Fragment, null,
        React.createElement(antd_1.Icon, { className: "dict-value-icon", type: format }),
        txt);
};
// const PROGRESS = new Set<string>(['prepare', 'ready', 'doing', 'finsh', 'error'])
var progressRender = function (key, def, map) {
    if (!map.has(key)) {
        if (def == false)
            return key;
        return def;
    }
    var _a = __read(map.get(key), 2), txt = _a[0], format = _a[1];
    switch (format) {
        case 'prepare':
            return React.createElement(antd_1.Badge, { className: "dict-value-progress dict-value-progress-" + format, count: React.createElement(antd_1.Icon, { type: "plus-circle", theme: "filled", style: { color: '#56AE92' } }), text: txt });
        case 'ready':
            return React.createElement(antd_1.Badge, { className: "dict-value-progress dict-value-progress-" + format, count: React.createElement(antd_1.Icon, { type: "clock-circle", theme: "filled", style: { color: '#5687AE' } }), text: txt });
        case 'doing':
            return React.createElement(antd_1.Badge, { className: "dict-value-progress dict-value-progress-" + format, count: React.createElement(antd_1.Icon, { type: "play-circle", theme: "filled", style: { color: '#565CAE' } }), text: txt });
        case 'finsh':
            return React.createElement(antd_1.Badge, { className: "dict-value-progress dict-value-progress-" + format, count: React.createElement(antd_1.Icon, { type: "check-circle", theme: "filled", style: { color: '#4FA32E' } }), text: txt });
        case 'error':
            return React.createElement(antd_1.Badge, { className: "dict-value-progress dict-value-progress-" + format, count: React.createElement(antd_1.Icon, { type: "close-circle", theme: "filled", style: { color: '#AD3142' } }), text: txt });
    }
    return txt;
};
var borderRender = function (key, def, map) {
    if (!map.has(key)) {
        if (def === false)
            return key;
        return def;
    }
    var _a = __read(map.get(key), 2), txt = _a[0], format = _a[1];
    return React.createElement("span", { className: "dict-value-border", style: { color: format, borderLeftColor: format } }, txt);
};
var extClass = function (key, def, map) {
    if (!map.has(key)) {
        if (def === false)
            return key;
        return def;
    }
    var _a = __read(map.get(key), 2), txt = _a[0], format = _a[1];
    if (format) {
        return React.createElement("span", { className: format }, txt);
    }
    return txt;
};
var dictRender = function (type, def, onlyText) {
    if (def === void 0) { def = TEXT.RENDER_TEXT; }
    if (onlyText === void 0) { onlyText = false; }
    __initDict();
    var key = def ? "".concat(type, "-").concat(def) : type;
    if (RENDERMAP.has(key))
        return RENDERMAP.get(key);
    if (!DICTMAP.has(type))
        return DEFAULT_DICT_RENDER;
    var define = DICTMAP.get(type);
    var format = define.format, map = define.map, reverse = define.reverse, nodes = define.nodes;
    var fn = null;
    if (onlyText) {
        fn = function (code) {
            var key = code + '';
            if (map.has(key)) {
                return map.get(key)[0];
            }
            return def;
        };
    }
    else {
        switch (format) {
            case 'tag':
                fn = function (code) { return tagRender(code + '', def, map); };
                break;
            case 'status':
                fn = function (code) { return statusRender(code + '', def, map); };
                break;
            case 'sub':
                fn = function (code) { return subRender(code + '', def, map); };
                break;
            case 'sup':
                fn = function (code) { return supRender(code + '', def, map); };
                break;
            case 'icon':
                fn = function (code) { return iconRender(code + '', def, map); };
                break;
            case 'progress':
                fn = function (code) { return progressRender(code + '', def, map); };
                break;
            case 'border':
                fn = function (code) { return borderRender(code + '', def, map); };
                break;
            case 'clazz':
                fn = function (code) { return extClass(code + '', def, map); };
                break;
            default:
                fn = function (code) {
                    var key = code + '';
                    if (map.has(key))
                        return map.get(key)[0];
                    if (def === false)
                        return key;
                    return def;
                };
                break;
        }
    }
    fn.reverse = function (name) { return reverse.get(name + '') || ''; };
    fn.nodes = nodes;
    fn.get = function (value) {
        var ns = _.filter(nodes, { value: value });
        if (ns && ns.length == 1) {
            return ns[0];
        }
        return null;
    };
    fn.getByName = function (name) {
        var ns = _.filter(nodes, { name: name });
        if (ns && ns.length == 1) {
            return ns[0];
        }
        return null;
    };
    fn.optAs = function (nameField, valueField, shift) {
        if (nameField === void 0) { nameField = 'name'; }
        if (valueField === void 0) { valueField = 'value'; }
        if (shift === void 0) { shift = null; }
        var opts = nodes.map(function (item) {
            var _a;
            return _a = {}, _a[nameField] = item.name, _a[valueField] = item.value, _a;
        });
        if (shift) {
            opts.unshift(shift);
        }
        return opts;
    };
    fn.intOpts = function () { return nodes.map(function (item) { return ({ name: item.name, value: parseInt(item.value) }); }); };
    RENDERMAP.set(key, fn);
    return fn;
};
exports.dictRender = dictRender;
