import * as React from 'react';
import { WidgetProps } from './interface';
export declare abstract class Widget extends React.PureComponent<WidgetProps> {
    /**
     * 组件依赖的脚本,可以为零个或多个，通常不建议小组件再引入脚本
    */
    protected REQUIRE_JS: string[];
    /**
     * 组件依赖的服务,可以为零个或多个，通常不建议小组件再引入样式
    */
    protected REQUIRE_CSS: string[];
    /**
     * 组件依赖的服务,可以为零个或多个，如果多个时，每个服务都启动的状态下才出组件
    */
    protected REQUIRE_SERVICE: string[];
    componentDidMount(): void;
    show(): React.ReactNode;
    render(): React.ReactNode;
}
