import * as React from 'react';
declare class _WidgetManager {
    WIDGETS: any[];
    constructor();
    loadCss(css: any): void;
    getByPath(path: any): any;
    loadByPath(path: any): Promise<boolean>;
}
export declare const WidgetManager: _WidgetManager;
declare class _WidgetUtil {
    /**
     * 注册小组件
    */
    registerWidget: (clazz: any) => void;
    /**
     * 显示小组件，
     * 说明 showWidget 没有权限控制，如果需要进行权限验证，使用 layoutWidget
     * @path 为小组件的JS文件路径绝对地址 ，必传
     * @props 为传给小组件的参数
    */
    showWidget: (path: string, props?: any) => React.ReactNode;
    /**
     * 自定义布局的小组件
     * @path 为小组件的JS文件路径绝对地址 ，也支持小组件的id
     * @fn 小组件的布局回调方法，说明，小组件为空时，则回调的参数为null，需要自行判断
     * @props 为传给小组件的参数
    */
    layoutWidget: (path: string | number, fn: (widget: React.ReactNode) => React.ReactNode, props?: any) => React.ReactNode;
    /**
     * 获取当前用户可用的所有小组件
    */
    getAll: () => any[];
}
export declare var WidgetUtil: _WidgetUtil;
export {};
